%      JCtangle.ch for Japanese
%
%     (C) Hideki ISOZAKI  isozaki@ntt-20.ntt.jp
%           Dec. 15, 1988
%
%        Nippon Telegraph and Telephone Corp.
%        NTT Software Labs.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% [0]      TeX banner lines
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@x
\def\title{CTANGLE $
  ($Revision: 1.1 $)
  $}
\def\contentspagenumber{1} % should be odd
\def\topofcontents{\null\vfill
  \titlefalse % include headline on the contents page
  \def\rheader{\hfil}
  \centerline{\titlefont The {\ttitlefont CTANGLE} processor}
  \vskip 15pt
  \centerline{$
    ($Revision: 1.1 $)
    $}}
@y
\def\title{CTANGLE $
  ($Revision: 1.1J Beta$)
  $}
\def\contentspagenumber{1} % should be odd
\def\topofcontents{\null\vfill
  \titlefalse % include headline on the contents page
  \def\rheader{\hfil}
  \centerline{\titlefont The {\ttitlefont CTANGLE} processor}
  \vskip 15pt
  \centerline{$
    ($Revision: 1.1J Beta$)
    $}}
@z
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% [1]      C banner line
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@x
@d banner "This is CTANGLE ($Revision: 1.1 $)\n"
@y
@d banner "This is CTANGLE ($Revision: 1.1J Beta$)\n"
@z
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% [6]      Special Character
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@x
@ Code related to the character set:
@d and_and 04 /* `\.{\&\&}' */
@d tab_mark 011 /* ASCII code used as tab-skip */
@d line_feed 012 /* ASCII code thrown away at end of line */
@d form_feed 014 /* ASCII code used at end of page */
@d carriage_return 015 /* ASCII code used at end of line */
@d gt_gt 020 /* `\.{>>}'; this doesn't exist in MIT */
@d lt_lt 022 /* `\.{<<}'; this doesn't exist in MIT */
@d plus_plus 013 /* `\.{++}'; this corresponds to MIT's up-arrow */
@d minus_minus 01 /* `\.{--}'; this corresponds to MIT's down-arrow */
@d minus_gt 031 /* `\.{->}' */
@d not_eq 032 /* `\.{!=}' */
@d lt_eq 034 /* `\.{<=}' */
@d gt_eq 035 /* `\.{>=}' */
@d eq_eq 036 /* `\.{==}' */
@d or_or 037 /* `\.{\v\v}' */
@y
@ Code related to the character set: 
@d and_and 04 /* `\.{\&\&}' */
@d tab_mark 011 /* ASCII code used as tab-skip */
@d line_feed 012 /* ASCII code thrown away at end of line */
@d form_feed 014 /* ASCII code used at end of page */
@d carriage_return 015 /* ASCII code used at end of line */
@d gt_gt 020 /* `\.{>>}'; this doesn't exist in MIT */
@d lt_lt 022 /* `\.{<<}'; this doesn't exist in MIT */
@d plus_plus 013 /* `\.{++}'; this corresponds to MIT's up-arrow */
@d minus_minus 01 /* `\.{--}'; this corresponds to MIT's down-arrow */
@d minus_gt 031 /* `\.{->}' */
@d not_eq 032 /* `\.{!=}' */
@d esc 033 /* escape is used for Japanese */
@d lt_eq 034 /* `\.{<=}' */
@d gt_eq 035 /* `\.{>=}' */
@d eq_eq 036 /* `\.{==}' */
@d or_or 037 /* `\.{\v\v}' */
@z
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% [44]      skip_ahead
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@x
@ The |skip_ahead| procedure reads through the input at fairly high speed
until finding the next non-ignorable control code, which it returns.

@c eight_bits skip_ahead() /* skip to next control code */
{
  eight_bits c; /* control code found */
  while (1) {
    if (loc>limit && (get_line()==0)) return(new_module);
    *(limit+1)='@@';
    while (*loc!='@@') loc++;
    if (loc<=limit) {
      loc++; c=ccode[*loc]; loc++;
      if (c!=ignore || *(loc-1)=='>') return(c);
    }
  }
}
@y
@ The |skip_ahead| procedure reads through the input at fairly high speed
until finding the next non-ignorable control code, which it returns.
If we find an escape character, 

@c eight_bits skip_ahead() /* skip to next control code */
{
  eight_bits c; /* control code found */
  while (1) {
    if (loc>limit && (get_line()==0)) return(new_module);
    *(limit+1)='@@';
    while (*loc!='@@') {if(*loc==esc) skip_japanese(); else loc++;}
    if (loc<=limit) {
      loc++; c=ccode[*loc]; loc++;
      if (c!=ignore || *(loc-1)=='>') return(c);
    }
  }
}
@z
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% [46]     skip_comment
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@x
@ @c
skip_comment() /* skips over comments */
{
  ASCII c; /* current character */
  while (1) {
    if (loc>limit)
      if(get_line()) return(comment_continues=1);
      else{
        err_print("! Input ended in mid-comment");
@.Input ended in mid-comment@>
	return(comment_continues=0);
      }
    c=*(loc++);
    if (c=='*' && *loc=='/') { loc++; return(comment_continues=0); }
    if (c=='@@') {
      if (ccode[*loc]==new_module) {
        err_print("! Section name ended in mid-comment"); loc--;
@.Section name ended in mid-comment@>
	return(comment_continues=0);
      }
      else loc++;
    }
  }
}
@y
@ @c
skip_comment() /* skips over comments */
{
  ASCII c; /* current character */
  while (1) {
    if (loc>limit)
      if(get_line()) return(comment_continues=1);
      else{
        err_print("! Input ended in mid-comment");
@.Input ended in mid-comment@>
	return(comment_continues=0);
      }
    c=*(loc++);
    if (c==esc && *loc=='$') { loc--; skip_japanese(); c=*loc;}
    if (c=='*' && *loc=='/') { loc++; return(comment_continues=0); }
    if (c=='@@') {
      if (ccode[*loc]==new_module) {
        err_print("! Section name ended in mid-comment"); loc--;
@.Section name ended in mid-comment@>
	return(comment_continues=0);
      }
      else loc++;
    }
  }
}
@z
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% [56]   scan module
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@x
@ @<Scan the module name...@>= {
  ASCII *k; /* pointer into |mod_text| */
  @<Put module name into |mod_text|@>;
  if (k-mod_text>3 && strncmp(k-2,"...",3)==0) cur_module=prefix_lookup(mod_text+1,k-3);
  else cur_module=mod_lookup(mod_text+1,k);
  return(module_name);
}
@y
@ @<Scan the module name...@>= {
  ASCII *k; /* pointer into |mod_text| */
  @<Put module name into |mod_text|@>;
  if (k-mod_text>3 && strncmp(k-2,"...",3)==0) 
    {
      if(k-mod_text>6 && *(k-4)=='(' && *(k-5)==esc)
	cur_module=prefix_lookup(mod_text+1,k-6);
      else
	cur_module=prefix_lookup(mod_text+1,k-3);
    }
  else cur_module=mod_lookup(mod_text+1,k);
  return(module_name);
}
@z
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% [58]    put module name
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@x
@ @<Put module name...@>=
k=mod_text;
while (1) {
  if (loc>limit && get_line()==0) {
    err_print("! Input ended in section name");
@.Input ended in section name@>
    loc=buffer+1; break;
  }
  c=*loc;
  @<If end of name, |break|@>;
  loc++; if (k<mod_text_end) k++;
  if (c==' ' || c==tab_mark) {
    c=' '; if (*(k-1)==' ') k--;
  }
*k=c;
}
if (k>=mod_text_end) {
  printf("\n! Section name too long: ");
@.Section name too long@>
  ASCII_write(mod_text+1,25);
  printf("..."); mark_harmless;
}
if (*k==' ' && k>mod_text) k--;
@y
@ @<Put module name...@>=
k=mod_text;
while (1) {
  if (loc>limit && get_line()==0) {
    err_print("! Input ended in section name");
@.Input ended in section name@>
    loc=buffer+1; break;
  }
  c=*loc;
  if(c==esc) @<Copy Japanese@>;
  @<If end of name, |break|@>;
  loc++; if (k<mod_text_end) k++;
  if (c==' ' || c==tab_mark) {
    c=' '; if (*(k-1)==' ') k--;
  }
*k=c;
}
if (k>=mod_text_end) {
  printf("\n! Section name too long: ");
@.Section name too long@>
  ASCII_write(mod_text+1,25);
  printf("..."); mark_harmless;
}
if (*k==' ' && k>mod_text) k--;

@z
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% [last]   skip japanese
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@x
@* Index.
@y
@ @<Copy Japanese@>=
{
  *(k++)=*(loc++); /* ESC */
  c = *(loc+1);
  if(*loc!='$' || c!='@@' && c!='B')
    fatal("Invalid escape sequence","");
  while(*loc!=esc) {*k=*loc; loc++; if(mod_text_end) k++;}
  if(k+2<mod_text_end){
    *(k++)=*(loc++); /* ESC */
    c = *(loc+1);
    if(*loc!='(' || c!='J' && c!='B' && c!='H')
        fatal("Invalid escape sequence","");
    *(k++)=*(loc++); /* ( */
    *k=*(loc++); /* J or B or H */
    c = *loc; /* First non Japanese */
  }
}
@ \.{TANGLE} should ignore Japanese texts.
@c
skip_japanese()
{
  ASCII c;
  c = *(loc+2);
  if(*(loc+1)!='$' || c!='@@' && c!='B')
    fatal("Invalid escape sequence","");
  loc+=3;
  while(*loc!=esc) loc++;
  c = *(loc+2);
  if(*(loc+1)!='(' || c!='J' && c!='B' && c!='H')
    fatal("Invalid escape sequence","");
  loc+=3;
}
@* Index.
@z

