%      JCweave.ch for Japanese
%
%     (C) Hideki ISOZAKI  isozaki@ntt-20.ntt.jp
%           Dec. 23, 1988
%
%        Nippon Telegraph and Telephone Corp.
%        NTT Software Labs.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% [0] TeX banner
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@x
\def\title{CWEAVE $
  ($Revision: 1.1 $)
  $}
\def\contentspagenumber{1} % should be odd
\def\topofcontents{\null\vfill
  \titlefalse % include headline on the contents page
  \def\rheader{\hfil}
  \centerline{\titlefont The {\ttitlefont CWEAVE} processor}
  \vskip 15pt
  \centerline{$
    ($Revision: 1.1 $)
    $}
  \vfill}
@y
\def\title{CWEAVE $
  ($Revision: 1.1J $)
  $}
\def\contentspagenumber{1} % should be odd
\def\topofcontents{\null\vfill
  \titlefalse % include headline on the contents page
  \def\rheader{\hfil}
  \centerline{\titlefont The {\ttitlefont CWEAVE} processor}
  \vskip 15pt
  \centerline{$
    ($Revision: 1.1J $)
    $}
  \vfill}
@z
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% [1]  C banner
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@x
@d banner "This is CWEAVE ($Revision: 1.1 $)\n"
@y
@d banner "This is CWEAVE ($Revision: 1.1J Beta$)\n"
@z
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% [6]      Special Character
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@x
@ Code related to the character set:
@d and_and 04 /* `\.{\&\&}' */
@d tab_mark 011 /* ASCII code used as tab-skip */
@d line_feed 012 /* ASCII code thrown away at end of line */
@d form_feed 014 /* ASCII code used at end of page */
@d carriage_return 015 /* ASCII code used at end of line */
@d gt_gt 020 /* `\.{>>}'; this doesn't exist in MIT */
@d lt_lt 022 /* `\.{<<}'; this doesn't exist in MIT */
@d plus_plus 013 /* `\.{++}'; this corresponds to MIT's up-arrow */
@d minus_minus 01 /* `\.{--}'; this corresponds to MIT's down-arrow */
@d minus_gt 031 /* `\.{->}' */
@d not_eq 032 /* `\.{!=}' */
@d lt_eq 034 /* `\.{<=}' */
@d gt_eq 035 /* `\.{>=}' */
@d eq_eq 036 /* `\.{==}' */
@d or_or 037 /* `\.{\v\v}' */
@y
@ Code related to the character set: 
@d and_and 04 /* `\.{\&\&}' */
@d tab_mark 011 /* ASCII code used as tab-skip */
@d line_feed 012 /* ASCII code thrown away at end of line */
@d form_feed 014 /* ASCII code used at end of page */
@d carriage_return 015 /* ASCII code used at end of line */
@d gt_gt 020 /* `\.{>>}'; this doesn't exist in MIT */
@d lt_lt 022 /* `\.{<<}'; this doesn't exist in MIT */
@d plus_plus 013 /* `\.{++}'; this corresponds to MIT's up-arrow */
@d minus_minus 01 /* `\.{--}'; this corresponds to MIT's down-arrow */
@d minus_gt 031 /* `\.{->}' */
@d not_eq 032 /* `\.{!=}' */
@d esc 033 /* escape is used for Japanese */
@d lt_eq 034 /* `\.{<=}' */
@d gt_eq 035 /* `\.{>=}' */
@d eq_eq 036 /* `\.{==}' */
@d or_or 037 /* `\.{\v\v}' */
@z
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% [31]     skip limbo
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@x
@c skip_limbo() {
  while(1) {
    if (loc>limit && get_line()==0) return;
    *(limit+1)='@@';
    while (*loc!='@@') loc++; /* look for '@@', then skip two chars */
    if (loc++ <=limit) if (ccode[*loc++]==new_module) return;
  }
}
@y
@c skip_limbo() {
  while(1) {
    if (loc>limit && get_line()==0) return;
    *(limit+1)='@@';
    while (*loc!='@@') {if(*loc==esc) skip_japanese(); else loc++;}
    /* look for '@@', then skip two chars */
    if (loc++ <=limit) if (ccode[*loc++]==new_module) return;
  }
}
@z
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% [32]         skip TeX
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@x
@c unsigned skip_TeX() /* skip past pure \TeX\ code */
{
  while (1) {
    if (loc>limit && get_line()==0) return(new_module);
    *(limit+1)='@@';
    while (*loc!='@@' && *loc!='|') loc++;
    if (*loc++ =='|') return('|');
    if (loc<=limit) return(ccode[*(loc++)]);
  }
}
@y
@c unsigned skip_TeX() /* skip past pure \TeX\ code */
{
  while (1) {
    if (loc>limit && get_line()==0) return(new_module);
    *(limit+1)='@@';
    while (*loc!='@@' && *loc!='|') {
      if(*loc==esc) skip_japanese(); else loc++;
    }
    if (*loc++ =='|') return('|');
    if (loc<=limit) return(ccode[*(loc++)]);
  }
}
@z
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% [46]
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@x
@<Scan the module name...@>= {
  ASCII *k; /* pointer into |mod_text| */
  @<Put module name into |mod_text|@>;
  if (k-mod_text>3 && strncmp(k-2,"...",3)==0) cur_module=prefix_lookup(mod_text+1,k-3); 
  else cur_module=mod_lookup(mod_text+1,k);
  xref_switch=0; return(module_name);
}
@y
@<Scan the module name...@>= {
  ASCII *k; /* pointer into |mod_text| */
  @<Put module name into |mod_text|@>;
  if (k-mod_text>3 && strncmp(k-2,"...",3)==0) 
    {
      if(k-mod_text>7) { /* Non Empty Japanese */
	if(*(k-4)=='(' && *(k-5)==esc) /* JIS */
	  cur_module=prefix_lookup(mod_text+1,k-6);  /* Ignore JIS Ending */
	else 
	  cur_module=prefix_lookup(mod_text+1,k-3);  /* ASCII */
      }
    }
  else cur_module=mod_lookup(mod_text+1,k); /* Complete Matching */
  xref_switch=0; return(module_name);
}
@z
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% [50]         Scan to the next @>
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@x
@ @<Scan to the next...@>= {
  c=ccode[*(loc-1)]; id_first=loc; *(limit+1)='@@';
  while (*loc!='@@') loc++;
  id_loc=loc;
  if (loc++>limit) {
    err_print("! Control text didn't end"); loc=limit; return(c);
@.Control text didn't end@>
  }
  if (*loc++!='>') err_print("! Control codes are forbidden in control text");
@.Control codes are forbidden...@>
  return(c);
}
@y
@ @<Scan to the next...@>= {
  c=ccode[*(loc-1)]; id_first=loc; *(limit+1)='@@';
  while (*loc!='@@') {if(*loc==esc) skip_japanese(); else loc++;}
  id_loc=loc;
  if (loc++>limit) {
    err_print("! Control text didn't end"); loc=limit; return(c);
@.Control text didn't end@>
  }
  if (*loc++!='>') err_print("! Control codes are forbidden in control text");
@.Control codes are forbidden...@>
  return(c);
}
@z
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% [68] cwebmac
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@x
@<Set init...@>=
out_ptr=out_buf+1; out_line=1; *out_ptr='c'; tex_printf("\\input cwebma");
@y
@<Set init...@>=
out_ptr=out_buf+1; out_line=1; *out_ptr='c'; tex_printf("\\input jcwebma");
@z
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% [71] break out
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@x
@c break_out() /* finds a way to break the output line */
{
  ASCII *k=out_ptr; /* pointer into |out_buf| */
  while (1) {
    if (k==out_buf) @<Print warning message, break the line, |return|@>;
    if (*k==' ') {
      flush_buffer(k,0); return;
    }
    if (*(k--)=='\\' && *k!='\\') { /* we've decreased |k| */
      flush_buffer(k,1); return;
    }
  }
}
@y
@c break_out() /* finds a way to break the output line */
{
  ASCII *k=out_ptr; /* pointer into |out_buf| */
  while (1) {
    if (k==out_buf) {flush_buffer(out_ptr-1,0);return;}
    /* Next line is dummy to avoid fatal error on weaving this program */
    if (k<out_buf) @<Print warning message, break the line, |return|@>;
    if (*k==' ') {
      flush_buffer(k,0); return;
    /* We don't break at backslash. Japanese text may contain it. */
    }
    k--;
  }
}
@z
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% [75] copy limbo
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@x
@c copy_limbo()
{
  ASCII c;
  while (1) {
    if (loc>limit && (finish_line(), get_line()==0)) return;
    *(limit+1)='@@';
    while (*loc!='@@') out(*(loc++));
    if (loc++<=limit) {
      c=*loc++;
      if (ccode[c]==new_module) break;
      if (c!='z' && c!='Z') {
        out('@@');
        if (c!='@@') err_print("! Double @@ required outside of sections");
@.Double {\AT} required...@>
      }
    }
  }
}
@y
@c copy_limbo()
{
  ASCII c;
  while (1) {
    if (loc>limit && (finish_line(), get_line()==0)) return;
    *(limit+1)='@@'; /* sentinel */
    while (*loc!='@@') {if(*loc==esc) copy_japanese(); else out(*(loc++));}
    if (loc++<=limit) {
      c=*loc++;
      if (ccode[c]==new_module) break;
      if (c!='z' && c!='Z') {
        out('@@');
        if (c!='@@') err_print("! Double @@ required outside of sections");
@.Double {\AT} required...@>
      }
    }
  }
}
@z
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% [77] copy TeX
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@x
@ @c eight_bits copy_TeX()
{
  ASCII c; /* current character being copied */
  while (1) {
    if (loc>limit && (finish_line(), get_line()==0)) return(new_module);
    *(limit+1)='@@';
    while ((c=*(loc++))!='|' && c!='@@') {
      out(c);
      if (out_ptr==out_buf+1 && (c==' ' || c==tab_mark)) out_ptr--;
    }
    if (c=='|') return('|');
    if (loc<=limit) return(ccode[*(loc++)]);
  }
}
@y
@ @c eight_bits copy_TeX()
{
  ASCII c; /* current character being copied */
  while (1) {
    if (loc>limit && (finish_line(), get_line()==0)) return(new_module);
    *(limit+1)='@@'; /* sentinel */
    while ((c=*loc)!='|' && c!='@@') { /* Until you find C text or control */
      if (c==esc) copy_japanese(); else {loc++; out(c);}
	/* Skip Japanese */
      if (out_ptr==out_buf+1 && (c==' ' || c==tab_mark)) out_ptr--;
    }
    loc++;
    if (c=='|') return('|'); /* C text found */
    if (loc<=limit) return(ccode[*(loc++)]); /* Char after AT mark */
  }
}
@z
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% [78]     copy comment
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@x
@c copy_comment(bal) /* copies \TeX\ code in comments */
int bal; /* brace balance */
{
  ASCII c; /* current character being copied */
  while (1) {
    if (loc>limit) if (get_line()==0) {
	err_print("! Input ended in mid-comment");
@.Input ended in mid-comment@>
        loc=buffer+1; @<Clear |bal| and |return|@>;
      }
    c=*(loc++);
    if (c=='|') return(bal);
    @<Check for end of comment@>;
    if (phase==2) app_tok(c);
    @<Copy special things when |c=='@@', '\\', '{', '}'|; |return| at end@>;
  }
}
@y
@c copy_comment(bal) /* copies \TeX\ code in comments */
int bal; /* brace balance */
{
  ASCII c; /* current character being copied */
  while (1) {
    if (loc>limit) if (get_line()==0) {
	err_print("! Input ended in mid-comment");
@.Input ended in mid-comment@>
        loc=buffer+1; @<Clear |bal| and |return|@>;
      }
    c=*(loc++);
    if (c==esc) @<Copy Comment Japanese if phase two@>;
    if (c=='|') return(bal);
    @<Check for end of comment@>;
    if (phase==2) app_tok(c);
    @<Copy special things when |c=='@@', '\\', '{', '}'|; |return| at end@>;
    }
}
@z
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% [83]       Category Code
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@x
@d semi 27 /* denotes a semicolon */
@y
@d semi 14 /* denotes a semicolon; changed from 27 for Japanese */
@z
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% [165]      Output module name
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@x
@ @<Output the text...@>=
k=cur_name->byte_start; k_limit=(cur_name+1)->byte_start;
cur_mod_name=cur_name;
while (k<k_limit) {
  b=*(k++);
  if (b=='@@') @<Skip next character, give error if not `\.{@@}'@>;
  if (b!='|') out(b)
  else {
    @<Copy the \cee\ text into the |buffer| array@>;
    save_loc=loc; save_limit=limit; loc=limit+2; limit=j+1;
    *limit='|'; output_C();
    loc=save_loc; limit=save_limit;
  }
}
@y
@ @<Output the text...@>=
k=cur_name->byte_start; /* This ID */
k_limit=(cur_name+1)->byte_start; /* Next ID */
cur_mod_name=cur_name;
while (k<k_limit) {
  b=*(k++);
  if(b==esc) {
      do { out(b); b=*(k++); } while(b!=esc);
      out(b);   /* ESC */
      b=*(k++); out(b); /* ( */
      b=*(k++); out(b); /* B or J or H */
      b=*(k++); /* First Non-Japanese Char */
  }
  if (k>=k_limit) break; /* Exit |while| loop */
  if (b=='@@') 
       @<Skip next character, give error if not `\.{@@}'@>;
  if (b!='|') out(b)
  else {   /* C-mode in \TeX\ part */
    @<Copy the \cee\ text into the |buffer| array@>;
    save_loc=loc; save_limit=limit; loc=limit+2; limit=j+1;
    *limit='|'; output_C();
    loc=save_loc; limit=save_limit;
  }
}
@z
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% [173] Translate TeX part
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@x
@<Translate the \T...@>= do {
  next_control=copy_TeX();
  switch (next_control) {
    case '|': init_stack; output_C(); break;
    case '@@': out('@@'); break;
    case TeX_string: case xref_roman: case xref_wildcard: case xref_typewriter:
    case module_name: loc-=2; next_control=get_next(); /* skip to \.{@@>} */
      if (next_control==TeX_string)
        err_print("! TeX string should be in C text only"); break;
@.TeX string should be...@>
    case thin_space: case math_break:
    case line_break: case big_line_break: case no_line_break: case join:
    case pseudo_semi: err_print("! You can't do that in TeX text"); break;
@.You can't do that...@>
  }
} while (next_control<format);
@y
@<Translate the \T...@>= do {
  next_control=copy_TeX();
  switch (next_control) {
    case '|': init_stack; output_C(); break;
    case '@@': out('@@'); break;
    case TeX_string: case xref_roman: case xref_wildcard: case xref_typewriter:
    case module_name: loc-=2; next_control=get_next(); /* skip to \.{@@>} */
      if (next_control==TeX_string)
        err_print("! TeX string should be in C text only"); break;
@.TeX string should be...@>
    case thin_space: case math_break:
    case line_break: case big_line_break: case no_line_break: case join:
    case pseudo_semi: err_print("! You can't do that in TeX text"); break;
@.You can't do that...@>
  }
} while (next_control<format);
@z
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% [last]       Addition for Japanese
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
@x
@* Index.
@y
@ \.{WEAVE} should ignore Japanese texts in the first pass.
@c
skip_japanese()
{
  ASCII c;
  c = *(loc+2);
  if(*(loc+1)!='$' || c!='@@' && c!='B')
    fatal("Invalid escape sequence","");
  loc+=3;
  while(*loc!=esc) loc++;
  c = *(loc+2);
  if(*(loc+1)!='(' || c!='J' && c!='B' && c!='H')
    fatal("Invalid escape sequence","");
  loc+=3;
}

@ @c
copy_japanese()
{
  ASCII c,d;
  out(*(loc++));  out(d=*(loc++));  out(c=*(loc++));
  if(d!='$' || c!='@@' && c!='B')
    fatal("Invalid beginning escape sequence","");
  while(*loc!=esc) out(*(loc++));
  out(*(loc++));  out(d=*(loc++));  out(c=*(loc++));
  if(d!='(' || c!='J' && c!='B' && c!='H')
    fatal("Invalid ending escape sequence","");
}

@ @<Copy Comment Japanese if phase two@>=
{
  if (phase==2)
    {
      app_tok(c); /* ESC */
      c=*(loc++); app_tok(c); /* \$ */
      c=*(loc++); app_tok(c); /* @@ */
      c=*(loc++); while(c!=esc) {app_tok(c); c=*(loc++);}
      app_tok(c); /* ESC */
      c=*(loc++); app_tok(c); /* ( */
      c=*(loc++); app_tok(c); /* B or J or H */
      c=*(loc++); /* First non-Japanese char */
    }	
  else  /* |phase!=2| */
    {
      c=*(loc++); if(c!='$') fatal("Invalid escape sequence","");
      c=*(loc++); if(c!='@@' && c!='B') fatal("Invalid escape sequence","");
      c=*(loc++); while(c!=esc) c=*(loc++);
      c=*(loc++); if(c!='(') fatal("Invalid escape sequence","");
      c=*(loc++); if(c!='J' && c!='B' && c!='H') 
	fatal("Invalid escape sequence","");
      c=*(loc++); /* First non-Japanese char */
    }
}
@* Index.
@z
