@x
@ Some \cee\ compilers accept an extended character
set, so that one can type things like \.^^Z\ instead of \.{!=}.
If that's the case in your system, you should change this module,
assigning positions |01| to |037| in the most convenient way;
for example, at MIT you can just say
$$\hbox{|for (i=1; i<=037; i++) xchr[i]=i;|}$$
since \.{WEB}'s character set is essentially identical to MIT's,
even with respect to characters less than |040| (see the definitions
below).  If, however, the changes do not conform with these
definitions you should change the definitions as well.
@^system dependencies@>
@^notes to myself@>

@d and_and 04 /* `\.{\&\&}' */
@d tab_mark 011 /* ASCII code used as tab-skip */
@d line_feed 012 /* ASCII code thrown away at end of line */
@d form_feed 014 /* ASCII code used at end of page */
@d carriage_return 015 /* ASCII code used at end of line */
@d gt_gt 020 /* `\.{>>}'; this doesn't exist in MIT */
@d lt_lt 022 /* `\.{<<}'; this doesn't exist in MIT */
@d plus_plus 013 /* `\.{++}'; this corresponds to MIT's up-arrow */
@d minus_minus 01 /* `\.{--}'; this corresponds to MIT's down-arrow */
@d minus_gt 031 /* `\.{->}' */
@d not_eq 032 /* `\.{!=}' */
@d lt_eq 034 /* `\.{<=}' */
@d gt_eq 035 /* `\.{>=}' */
@d eq_eq 036 /* `\.{==}' */
@d or_or 037 /* `\.{\v\v}' */

@<System-dependent parts of character set@>= /* nothing needs to be done */
@y
@ Some \cee\ compilers accept an extended character
set, so that one can type things like \.^^Z\ instead of \.{!=}.
If that's the case in your system, you should change this module,
assigning positions |01| to |037| in the most convenient way;
for example, at MIT you can just say
$$\hbox{|for (i=1; i<=037; i++) xchr[i]=i;|}$$
since \.{WEB}'s character set is essentially identical to MIT's,
even with respect to characters less than |040| (see the definitions
below).  If, however, the changes do not conform with these
definitions you should change the definitions as well.
@^system dependencies@>
@^notes to myself@>

@d and_and 04 /* `\.{\&\&}' */
@d tab_mark 011 /* ASCII code used as tab-skip */
@d line_feed 012 /* ASCII code thrown away at end of line */
@d form_feed 014 /* ASCII code used at end of page */
@d carriage_return 015 /* ASCII code used at end of line */
@d gt_gt 020 /* `\.{>>}'; this doesn't exist in MIT */
@d lt_lt 022 /* `\.{<<}'; this doesn't exist in MIT */
@d plus_plus 013 /* `\.{++}'; this corresponds to MIT's up-arrow */
@d minus_minus 01 /* `\.{--}'; this corresponds to MIT's down-arrow */
@d minus_gt 031 /* `\.{->}' */
@d not_eq 032 /* `\.{!=}' */
@d esc 033 /* escape is used for Japanese */
@d lt_eq 034 /* `\.{<=}' */
@d gt_eq 035 /* `\.{>=}' */
@d eq_eq 036 /* `\.{==}' */
@d or_or 037 /* `\.{\v\v}' */

@<System-dependent parts of character set@>=
xchr[esc]=esc;

@z
