#define MAXFONTS 256 \

#define PIXELS_PER_INCH 300
#define HARD_XPAGE_OFFSET 160
#define PIXELS_PER_LINE (8*PIXELS_PER_INCH-HARD_XPAGE_OFFSET) \

#define PIXELS_PER_PAGE (11*PIXELS_PER_INCH) \

#define FONT_DIRECTORY "/usr/lib/tex/fonts" \

#define pixel_round(x)((long)(conv*(double)(x)+0.5))
#define dvi_round(x)((long)((double)(x)/conv+0.5)) \

#define one(fp)(getc(fp)&0xff)
#define sone(fp)snum(fp,1)
#define two(fp)num(fp,2)
#define four(fp)num(fp,4)
#define sfour(fp)snum(fp,4)
#define remove_entry(fp) \
{fp->left->right= fp->right;fp->right->left= fp->left;} \

#define add_to_tail(fp) \
{fp->left= open_fonts->left;fp->right= open_fonts; \
open_fonts->left->right= fp;open_fonts->left= fp;} \

/*1:*/
#line 43 "/usr3/JCWEB/examples/Jdviimp.web"

/*3:*/
#line 91 "/usr3/JCWEB/examples/Jdviimp.web"

#include <stdio.h>
#include <curses.h>
#include <pwd.h>
#include "dvi.h"
#include "font.h"


/*:3*/
#line 44 "/usr3/JCWEB/examples/Jdviimp.web"

/*4:*/
#line 99 "/usr3/JCWEB/examples/Jdviimp.web"

typedef unsigned char ubyte;

struct frame
{
long pxl_h,dvi_h,pxl_v,dvi_v,w,x,y,z;
};

struct frame*stack;
int stackp;

extern int landscape;

int debug= 0;
int verbose= 0;
int spoolit= 1;
int landscape= 0;
int center= 1;
int inchmargin= 1;
int numcopies= 1;
int beginpage= -1000;
int endpage= 0;
int numpages= 10000;
char*prntr= "tex-luis";
struct font*fontparray[MAXFONTS];
struct font*fontListHead= NULL;
char job_id[300];
char InputName[300];
int total_pages,maxstack,Xpage_offset,Ypage_offset;
int fontnum= 0;
double conv;
long numerator,denominator,magnification;
char*output_file_name;
char*Usage_str= \
"Usage: jdviimp [-U] [-I] [-L] [-B] [-N] [-E] [-v] [-s] [-d]\
 [-D[string]] <dvi-file>";
char ipr_D_option[128];

long read_postamble();
unsigned long num();
long snum();
char*malloc();
char*mktemp();

/*:4*/
#line 45 "/usr3/JCWEB/examples/Jdviimp.web"


main(argc,argv)
int argc;
char*argv[];
{
/*5:*/
#line 143 "/usr3/JCWEB/examples/Jdviimp.web"

FILE*fp;
long last_page;
int nc;
extern char*getenv();
char*prn,*prnopt;

/*:5*/
#line 51 "/usr3/JCWEB/examples/Jdviimp.web"

/*6:*/
#line 151 "/usr3/JCWEB/examples/Jdviimp.web"

if(prn= getenv("PRINTER"))
prntr= prn;
if(prnopt= getenv("PRINTOPTION"))
strcat(strcpy(ipr_D_option,"-D"),prnopt);
else
strcpy(ipr_D_option,"-Djobheader on");


/*:6*/
#line 52 "/usr3/JCWEB/examples/Jdviimp.web"

/*7:*/
#line 160 "/usr3/JCWEB/examples/Jdviimp.web"

while(argv[1][0]=='-')
{
switch(argv[1][1])
{
case'c':
if((nc= atoi(&argv[1][2]))>0)numcopies= nc;
break;

/*8:*/
#line 210 "/usr3/JCWEB/examples/Jdviimp.web"

case'B':
if((nc= atoi(&argv[1][2]))>0)beginpage= nc;
break;

case'N':
if((nc= atoi(&argv[1][2]))>0)numpages= nc;
break;
/*:8*/
#line 169 "/usr3/JCWEB/examples/Jdviimp.web"

case'P':
prntr= &(argv[1][2]);
break;

case's':
spoolit= 0;
break;

case'd':
debug= 1;
break;

case'D':
if(argv[1][2]){
if(*ipr_D_option)
strcat(ipr_D_option,",");
strcat(ipr_D_option,&argv[1][2]);
}else{
debug= 2;
}
break;

case'v':
verbose= 1;
spoolit= 0;
break;

case'L':
landscape= 1;
break;

/*9:*/
#line 218 "/usr3/JCWEB/examples/Jdviimp.web"

case'U':
center= 0;
break;

case'I':
inchmargin= 1;
break;


/*:9*/
#line 201 "/usr3/JCWEB/examples/Jdviimp.web"

default:
error(Usage_str);
}

argv++;
argc--;
}

/*:7*/
#line 53 "/usr3/JCWEB/examples/Jdviimp.web"

/*10:*/
#line 228 "/usr3/JCWEB/examples/Jdviimp.web"

if(argc!=2)
error(Usage_str);

/*:10*/
#line 54 "/usr3/JCWEB/examples/Jdviimp.web"

/*11:*/
#line 232 "/usr3/JCWEB/examples/Jdviimp.web"

if((fp= fopen(argv[1],"r"))==NULL){
char longername[256];
strcpy(longername,argv[1]);
strcat(longername,".dvi");
if((fp= fopen(longername,"r"))==NULL)
error("jdviimp: Can't open %s",argv[1]);
}
strcpy(InputName,argv[1]);

/*:11*/
#line 55 "/usr3/JCWEB/examples/Jdviimp.web"

/*12:*/
#line 242 "/usr3/JCWEB/examples/Jdviimp.web"

if(beginpage==-1000)endpage= numpages;
else endpage= beginpage+numpages-1;


/*:12*/
#line 56 "/usr3/JCWEB/examples/Jdviimp.web"

process_preamble(fp);
find_postamble(fp);
last_page= read_postamble(fp);
start_output();
do_pages(fp,last_page);
close_pixel_files();
finish_output();
}

/*:1*//*2:*/
#line 85 "/usr3/JCWEB/examples/Jdviimp.web"

#ifndef MAXFONTSOPEN
#define MAXFONTSOPEN 10 
#endif


/*:2*//*13:*/
#line 252 "/usr3/JCWEB/examples/Jdviimp.web"

process_preamble(fp)
FILE*fp;
{
ubyte k;
double fraction;
/*14:*/
#line 265 "/usr3/JCWEB/examples/Jdviimp.web"

if(one(fp)!=PRE)
error("jdviimp: DVI file doesn't start with preamble");

if(one(fp)!=2)
error("jdviimp: Wrong version of DVI output for this program");

/*:14*/
#line 258 "/usr3/JCWEB/examples/Jdviimp.web"

/*15:*/
#line 272 "/usr3/JCWEB/examples/Jdviimp.web"

numerator= four(fp);
denominator= four(fp);
magnification= four(fp);

fraction= (((double)numerator*magnification)
/((double)denominator*1000.));

conv= ((fraction/100000)/2.54)*PIXELS_PER_INCH;

/*:15*/
#line 259 "/usr3/JCWEB/examples/Jdviimp.web"

k= one(fp);
fread(job_id,sizeof(char),k,fp);
job_id[k]= '\0';
}

/*:13*//*16:*/
#line 285 "/usr3/JCWEB/examples/Jdviimp.web"

find_postamble(fp)
FILE*fp;
{
ubyte byte;
long offset= -4;
/*17:*/
#line 299 "/usr3/JCWEB/examples/Jdviimp.web"

do
{
offset--;
fseek(fp,offset,2);
byte= one(fp);
}while(byte==TRAILER);

/*:17*/
#line 291 "/usr3/JCWEB/examples/Jdviimp.web"

/*18:*/
#line 307 "/usr3/JCWEB/examples/Jdviimp.web"

if(byte!=2)
error("jdviimp: Wrong version of DVI output for this program");


/*:18*/
#line 292 "/usr3/JCWEB/examples/Jdviimp.web"

offset-= 4;
fseek(fp,offset,2);

fseek(fp,four(fp),0);
}

/*:16*//*19:*/
#line 317 "/usr3/JCWEB/examples/Jdviimp.web"

long
read_postamble(fp)
FILE*fp;
{
long last_page;
long tallest,widest;
ubyte cmnd;

fprintf(stderr,"Reading font info");
fflush(stderr);
/*20:*/
#line 344 "/usr3/JCWEB/examples/Jdviimp.web"

if(one(fp)!=POST)
error("jdviimp: Postamble doesn't begin with POST");

/*:20*/
#line 328 "/usr3/JCWEB/examples/Jdviimp.web"

last_page= four(fp);
/*21:*/
#line 348 "/usr3/JCWEB/examples/Jdviimp.web"

if(numerator!=four(fp)
||denominator!=four(fp)
||magnification!=four(fp))
error("jdviimp: Postamble doesn't match preamble");

/*:21*/
#line 330 "/usr3/JCWEB/examples/Jdviimp.web"

tallest= four(fp);
/*22:*/
#line 354 "/usr3/JCWEB/examples/Jdviimp.web"

if(!landscape){
Ypage_offset= (PIXELS_PER_PAGE-pixel_round(tallest))/2;
widest= four(fp);
Xpage_offset= (PIXELS_PER_LINE-pixel_round(widest))/2
+HARD_XPAGE_OFFSET;
}else{
Ypage_offset= (PIXELS_PER_LINE-pixel_round(tallest))/2
+HARD_XPAGE_OFFSET;
widest= four(fp);
Xpage_offset= (PIXELS_PER_PAGE-pixel_round(widest))/2;
}

if(!center)Ypage_offset= Xpage_offset= 0;

if(inchmargin)Ypage_offset= Xpage_offset= PIXELS_PER_INCH;

/*:22*/
#line 332 "/usr3/JCWEB/examples/Jdviimp.web"

maxstack= two(fp);
total_pages= two(fp);
/*23:*/
#line 371 "/usr3/JCWEB/examples/Jdviimp.web"

if(debug)
remark("tall, wide, po, stk, pages = %d, %d, %d, %d, %d",
tallest,widest,Xpage_offset,maxstack,total_pages);

/*:23*/
#line 335 "/usr3/JCWEB/examples/Jdviimp.web"

/*24:*/
#line 376 "/usr3/JCWEB/examples/Jdviimp.web"

do
{
switch(cmnd= one(fp))
{
case FNTDEF1:
case FNTDEF2:
case FNTDEF3:
case FNTDEF4:
define_font(fp,cmnd);
fprintf(stderr,".");
fflush(stderr);
break;

case POSTPOST:
break;

default:
error("jdviimp: Non-fntdef cmnd found in postamble");
}
}while(cmnd!=POSTPOST);


/*:24*/
#line 336 "/usr3/JCWEB/examples/Jdviimp.web"

fprintf(stderr,"\n");
fflush(stderr);
return(last_page);
}



/*:19*//*25:*/
#line 407 "/usr3/JCWEB/examples/Jdviimp.web"

define_font(fp,cmnd)
FILE*fp;
ubyte cmnd;
{
struct font*fontp;
long checksum;
int len;
char fontname[513];
/*26:*/
#line 421 "/usr3/JCWEB/examples/Jdviimp.web"

if(fontnum>=MAXFONTS)
error("jdviimp: Too many fonts.  Maximum is %d",MAXFONTS);
fontp= (struct font*)malloc(sizeof(struct font));
if(fontp==NULL)
error("jdviimp: Out of memory while reading font %d",fontnum);

/*:26*/
#line 416 "/usr3/JCWEB/examples/Jdviimp.web"

/*27:*/
#line 428 "/usr3/JCWEB/examples/Jdviimp.web"

fontp->next= fontListHead;
fontListHead= fontp;

fontp->TeXnumber= num(fp,cmnd-FNTDEF1+1);
fontp->Inumber= fontnum++;

fontparray[fontp->TeXnumber]= fontp;

checksum= four(fp);

fontp->scale= four(fp);
fontp->design= four(fp);

len= one(fp)+one(fp);
fread(fontname,sizeof(char),len,fp);
fontname[len]= '\0';
strcpy(fontp->fontname,fontname);

read_pxl_file(fontp,fontname);


/*:27*/
#line 417 "/usr3/JCWEB/examples/Jdviimp.web"

if(debug>1)dump_font(fontp,fontname);
}

/*:25*//*28:*/
#line 462 "/usr3/JCWEB/examples/Jdviimp.web"

struct font*open_fonts= NULL;
int open_font_count= 0;

/*:28*//*30:*/
#line 474 "/usr3/JCWEB/examples/Jdviimp.web"

use_font(fp)
struct font*fp;
{
if(fp==open_fonts){
open_fonts= open_fonts->right;
}else if(fp!=open_fonts->left){
remove_entry(fp);
add_to_tail(fp);
}
}

/*:30*//*31:*/
#line 486 "/usr3/JCWEB/examples/Jdviimp.web"

close_one_font()
{
fclose(open_fonts->pxlfp);
open_fonts->pxlfp= NULL;
remove_entry(open_fonts);
open_fonts= open_fonts->right;
}

/*:31*//*32:*/
#line 495 "/usr3/JCWEB/examples/Jdviimp.web"

close_pixel_files()
{
struct font*first= open_fonts;
do{
fclose(open_fonts->pxlfp);
open_fonts= open_fonts->right;
}while(open_fonts!=first);
}


/*:32*/
