%{
/* ATMS WEAVE by Hideki ISOZAKI 1988-9-7 */
#define RM printf("{\\rm %s}",yytext);
#define BRM printf("{\\rm\\%s}",yytext);
#define BF printf("{\\bf %s}",yytext);
#define BBF printf("{\\bf\\%s}",yytext);
#define SL printf("{\\sl %s}",yytext);
#define BSL printf("{\\sl\\%s}",yytext);
#define IT printf("{\\it %s}",yytext);
#define BIT printf("{\\it\\%s}",yytext);
#define TT printf("{\\tt %s}",yytext);
#define BTT printf("{\\tt\\%s}",yytext);
	int p;
%}
%S PREAM DOC WFF REF SQUOTE DQUOTE COMM DEF Normal
%%
<PREAM>^"\\begin{document}"	{
	 printf("\\def\\Ptab#1{\\def\\nl{\\par\\hspace*{#1 cm}}}\n");
	 printf("{\\catcode`\\_=\\active\n");
	 printf("\\gdef\\makeusletter{\\catcode`\\_=\\active");
	 printf("\\gdef_{{\\tt\\char95}}}}\n");
	 printf("\\newcounter{para}\\newcounter{program}\n");
	 printf("\\pagestyle{headings}\n");
	 ECHO; BEGIN DOC;}
<DOC>^"@{"[ \t\n]*	{printf("\\stepcounter{program}\n"); BEGIN WFF;
		 printf("\\begin{flushleft}\\small\n");
		 printf("\\baselineskip=0.9\\baselineskip\n"); p=0;
		 printf("\\def\\nl{\\par}\\makeusletter\n");}
<DOC>^"@ "	printf("\\par\\stepcounter{para}{\\bf\\thepara.}\\ \\rm\n");
<DOC>^"@!"	printf("\\par\\bf ");
<DOC>^"@:"	BEGIN DEF;
<DEF>\|[^|]+\|	{printf("\\index{\\verb|%s|(D)}",yytext);
		 printf("\\par\\hfill$\\diamond$\\verb|%s|\\par",yytext);
		 printf("\\label{%s}\n",yytext); BEGIN DOC;}
<DEF>[a-zA-Z0-9\-]+	{printf("\\index{\\verb|%s|(D)}",yytext);
		 printf("\\hfill$\\diamond$\\verb|%s|\\par",yytext);
		 printf("\\label{%s}\n",yytext); BEGIN DOC;}
<DOC>^"@?"	BEGIN REF;
<REF>[^ \t\n\.,]+	{printf("\\index{%s}",yytext);
		 printf("({\\tt %s} p.\\pageref{%s})\n",yytext,yytext);}
<REF>[ ,\t\n]+		;
<REF>"\."		BEGIN DOC;
<WFF>"-"		printf("$-$");
<WFF>[a-zA-Z0-9]+"::"	BF;
<WFF>[a-zA-Z0-9]+("-"[a-zA-Z0-9]+)+	BF;
<WFF>^"@}"		{printf("\\end{flushleft}\n"); BEGIN DOC;}
<WFF>\n[ \t]*		printf("\\nl\n");
<WFF>\|			{printf("\\verb*\\"); BEGIN DQUOTE;}
<SQUOTE>[^|]*\|		{printf("%s\\",yytext); BEGIN WFF;}
<WFF>\"			{printf("\\verb*\|\""); BEGIN DQUOTE;}
<DQUOTE>[^"]*\"		{printf("%s\|",yytext); BEGIN WFF;}
<WFF>"\;"[^\n]*/\n	printf("\\verb\|%s\|",yytext);
<WFF>"{"		printf("$\\{$");
<WFF>"}"		printf("$\\}$");
<WFF>"^"		printf("{\\tt\\char94}");
<WFF>"<"		printf("$<$");
<WFF>">"		printf("$>$");
<WFF>"("		{p++; printf("\\begingroup(\\Ptab{%d}",p);}
<WFF>")"		{p--; printf(")\\endgroup\\Ptab{%d}",p);}
<WFF>"'"[\-a-zA-Z0-9]+		TT;
<WFF>","[\-a-zA-Z0-9]+		RM;
<WFF>"&"[\-a-zA-Z0-9]+		BIT;
<WFF>"#"[\-a-zA-Z0-9]+		BIT;
<WFF>":"[\-a-zA-Z0-9]+		IT;
<WFF>"%"		printf("\\%%");
<WFF>"`"" "*"("		{p++; printf("`\\begingroup\\tt(\\Ptab{%d}",p);}
<WFF>"'"" "*"("		{p++; printf("'\\begingroup\\tt(\\Ptab{%d}",p);}
<WFF>","" "*"("		{p++; printf(",\\begingroup\\rm(\\Ptab{%d}",p);}
<WFF>"$"		printf("{\\bf\\$}");
<WFF>"#"		printf("{\\bf\\#}");
<WFF>"&"		printf("{\\bf\\&}");
<WFF>"["		{p++; printf("\\begingroup$[$\\Ptab{%d}",p);}
<WFF>"]"		{p--; printf("\\endgroup$]$\\Ptab{%d}",p);}
<Normal>^"\\documentstyle"	{ECHO; BEGIN PREAM;}
%%
main(argc,argv)
	char **argv;
{
	int i;
	p=0;	
	BEGIN Normal; /* Starts yylex off in the right state */
	if (argc==1) {
	    yyin = stdin;
	    yylex();
	    }
	else for (i=1; i<argc; i++) {
	    yyin = fopen(argv[i],"r");
/*	    if (yyin==NULL) {
		fprintf(stderr,"can't open %s\n",argv[i]);
		exit(1);
		} */
	    yylex();
	    }
	exit(0);
}
