%{
/*
 jis2ascii.lex by Hideki ISOZAKI, June 6, 1988

 This program converts JIS alphabet and numbers to corresponding ASCII
 code.

 Compile:
 % lex jis2ascii.lex
 % cc -o jis2ascii lex.yy.c -ll

 Usage:
 % jis2ascii < foo.txt > foo.tex
 */

#define KIN             printf("\033\$@")
#define KOUT            printf("\033\(J")
#define SECONDBYTE      printf("%c",yytext[yyleng-1])
%}
K       [^\033\n\t]
Kin     \033\$.
Kout    \033\(.
Jroma   \043[^\033\n\t]
%Start Normal JIS JROMA
%%
<Normal>{Kin}/{Jroma}   {BEGIN JROMA;}
<Normal>{Kin}           {ECHO; BEGIN JIS;}
<JIS>{Kout}             {ECHO; BEGIN Normal;}
<JIS>\n                 {ECHO;}
<JIS>\t                 {ECHO;}
<JIS>{Jroma}            {KOUT; SECONDBYTE; BEGIN JROMA;}
<JIS>{K}{K}             {ECHO;}
<JROMA>{Kout}           {BEGIN Normal;}
<JROMA>\n               {ECHO;}
<JROMA>\t               {ECHO;}
<JROMA>{Jroma}          {SECONDBYTE;}
<JROMA>{K}{K}           {KIN; ECHO; BEGIN JIS;}
%%
main(argc,argv)
        char **argv;
{
        BEGIN Normal; /* Starts yylex off in the right state */
        if(argc==1) {yyin = stdin; yylex(); exit(0);}
        else {fprintf(stderr,"\n Eh?\n"); exit(1);}
}

