%{
/* 
This program converts an ordinary JLaTeX file to an ordinary text file.

 jlatextxt.lex was generated from
 expert-sun:/usr3/tex2.1/tex82/TeXcontrib/trickey/delatex.lex
 by Hideki ISOZAKI 17 Dec 87
 Make this with:  lex jlatextxt.lex;  cc -o jlatextxt lex.yy.c -ll

 Modified by Kusumoto@etl.junet for JUNET manual

 Modified by Hideki ISOZAKI Feb.12 1988 for subsubsec and arrows

 */

static int brace,bracket,sec,subsec,subsubsec,mathmode,gob;
static char verbchar;
%}
L [A-Za-z]
CL [^{L}]
I ("itemize}"|"description}"|"enumerate}")
V "verbatim"("\*}"|"}")
Q ("quotation}"|"quote}")
T "tabbing}"
F ("flushleft}"|"flushright}")
C "center}"
EQ "eqnarray"("\*}"|"}")
B "\\begin{"
E "\\end{"
%e 4000
%p 7000
%n 1000
%k 1500
%a 4000
%o 4000
%Start Math Normal Skip Ref Head JIS HeadJIS Verbatim Gobble Verb
%%
<Ref>"{"		{brace++;}
<Ref>"}"		{brace--;if(brace==0){printf("]");
		if(mathmode>0){BEGIN Math;}else{mathmode=0;BEGIN Normal;}}}
<Skip>"{"		{brace++;}
<Skip>[^{}]		;
<Skip>"}"		{brace--;if(brace==0){
		if(mathmode>0){BEGIN Math;}else{mathmode=0;BEGIN Normal;}}}
<Normal>"\\("	{mathmode=1;BEGIN Math;}
<Normal>\$	{mathmode=1;BEGIN Math;}
<Normal>"\\["	{mathmode=2;printf("\n");BEGIN Math;}
<Normal>{B}{EQ}	{mathmode=2;printf("\n");BEGIN Math;}
<Normal>\$\$	{mathmode=2;printf("\n");BEGIN Math;}
<Normal>\033\$.		{ECHO; BEGIN JIS;}
<JIS>[^\033]	{ECHO; BEGIN JIS;}
<JIS>\033\(.	{ECHO; BEGIN Normal;}
<Normal>"\\%"	{printf("%%");}
<Normal>"\\&"	{printf("\&");}
<Normal>"\\$"	{printf("\$");}
<Normal>"\\#"	{printf("\#");}
<Normal>"\\_"	{printf("_");}
<Normal,Math>"\\{"	{printf("{");}
<Normal,Math>"\\}"	{printf("}");}
<Normal>\#	;
<Normal>~	{printf(" ");}
<Normal>\&	{printf("\t");}
<Normal>"\\newcommand{"		{brace=1;gob=2;BEGIN Gobble;}
<Gobble>"}"	{brace--;if(brace==0){gob--;if(gob==0){BEGIN Normal;}}}
<Gobble>[^{}]	;
<Gobble>"{"	{brace++;}
<Normal>{B}"tabular}"		{printf("\n");brace=0;BEGIN Skip;}
<Normal>{E}"tabular}"		{printf("\n");}
<Math>"\n"	{printf(" ");}
<Math>{B}"array}{"	{printf("\n");brace=1;BEGIN Skip;}
<Math>{E}"array}"	{printf("\n");}
<Math>"\\hline"/{CL}	{printf("\n----------------------------------\n");}
<Math>\&	{printf("\t");}
<Math>"\\alpha"/{CL}	{printf("$@&A(J");}
<Math>"\\beta"/{CL}	{printf("$@&B(J");}
<Math>"\\gamma"/{CL}	{printf("$@&C(J");}
<Math>"\\delta"/{CL}	{printf("$@&D(J");}
<Math>"\\epsilon"/{CL}	{printf("$@&E(J");}
<Math>"\\theta"/{CL}	{printf("$@&H(J");}
<Math>"\\kappa"/{CL}	{printf("$@&J(J");}
<Math>"\\lambda"/{CL}	{printf("$@&K(J");}
<Math>"\\mu"/{CL}	{printf("$@&L(J");}
<Math>"\\nu"/{CL}	{printf("$@&M(J");}
<Math>"\\xi"/{CL}	{printf("$@&O(J");}
<Math>"\\pi"/{CL}	{printf("$@&P(J");}
<Math>"\\rho"/{CL}	{printf("$@&Q(J");}
<Math>"\\sigma"/{CL}	{printf("$@&R(J");}
<Math>"\\tau"/{CL}	{printf("$@&S(J");}
<Math>"\\phi"/{CL}	{printf("$@&U(J");}
<Math>"\\chi"/{CL}	{printf("$@&V(J");}
<Math>"\\psi"/{CL}	{printf("$@&W(J");}
<Math>"\\omega"/{CL}	{printf("$@&X(J");}
<Math>"\\leq"/{CL}	{printf("$@!e(J");}
<Math>"\\geq"/{CL}	{printf("$@!f(J");}
<Math>"\\ll"/{CL}	{printf("$@!T(J");}
<Math>"\\gg"/{CL}	{printf("$@!U(J");}
<Math>"\\langle"/{CL}	{printf("$@!R(J");}
<Math>"\\rangle"/{CL}	{printf("$@!S(J");}
<Math>"\\pm"/{CL}	{printf("$@!^(J");}
<Math>"\\\|"/{CL}	{printf("$@!B(J");}
<Math>"\\times"/{CL}	{printf("$@!_(J");}
<Math>"\\div"/{CL}	{printf("$@!`(J");}
<Math>"\\neq"/{CL}	{printf("$@!b(J");}
<Math>"\\infty"/{CL}	{printf("$@!g(J");}
<Math>"\\S"/{CL}	{printf("$@!x(J");}
<Math>"\\\\"		{printf("\n");}
<Math>"\\rightarrow"/{CL}	{printf("\033$@\"*\033(J");}
<Math>"\\leftarrow"/{CL}	{printf("\033$@\"+\033(J");}
<Math>"\\uptarrow"/{CL}	        {printf("\033$@\",\033(J");}
<Math>"\\downarrow"/{CL}	{printf("\033$@\"-\033(J");}
<Math>"\\displaystyle"/{CL}	;
<Math>"\\textstyle"/{CL}	;
<Math>"\\left"/{CL}	;
<Math>"\\right"/{CL}	;
<Math>\$\$	{mathmode=0;printf("\n");BEGIN Normal;}
<Math>"\\]"	{mathmode=0;printf("\n");BEGIN Normal;}
<Math>{E}{EQ}	{mathmode=0;printf("\n");BEGIN Normal;}
<Math>\$	{mathmode=0;BEGIN Normal;}
<Math>"\\)"	{mathmode=0;BEGIN Normal;}
<Math>"\\"/{L}	{printf(" ");}
<Math,Normal>"\\ "	{printf(" ");}
<Math,Normal>"\\;"	;
<Math,Normal>"\\/"	;
<Math,Normal>"\\:"	;
<Math,Normal>"\\,"	;
<Math,Normal>"\\cdots"/{CL}	{printf("$@!D(J");}
<Math,Normal>"\\ldots"/{CL}	{printf("...");}
<Normal>"\\hline"/{CL}  {printf("\n----------------------------------\n");}
<Normal>" "*"\\="" "*	{printf("\t");}
<Normal>" "*"\\>"" "*	{printf("\t");}
<Normal>\n\n+	{printf("\n\n");}
<Normal>\n/[^\033]	{printf(" ");}
<Normal>\n/"\033"	;
<Normal>"\\documentstyle"/{CL}	{brace=0;BEGIN Skip;}
<Normal>"%".*		; /* ignore comments */
<Normal>"\\\\"		{printf("\n");}
<Normal>"\\maketitle"/{CL}	{printf("\n");}
<Normal>"\\author{"	{printf("\n\n");}
<Normal>"\\date{"	{printf("\n\n");}
<Normal>"\\title{"	{printf("\n\n");}
<Normal>"\\section{"	{sec++;printf("\n\n<%d> ",sec); brace=1;BEGIN Head;}
<Normal>"\\section*{"	{printf("\n"); brace=1;BEGIN Head;}
<Normal>"\\subsection{"	{subsec++;printf("\n\n<%d,%d> ",sec,subsec);
			brace=1;BEGIN Head;}
<Normal>"\\subsubsection{" 
                        {subsubsec++;
                        printf("\n\n<%d,%d,%d> ",sec,subsec,subsubsec);
			brace=1;BEGIN Head;}
<Head>[^{}]		{ECHO; /* ignore things up to next "}" */}
<Head>"{"		{brace++;}
<Head>"}"		{brace--;if(brace==0){printf("\n\n");BEGIN Normal;}}
<Head>\033\$.		{ECHO; BEGIN HeadJIS;}
<HeadJIS>[^\033]	{ECHO; BEGIN HeadJIS;}
<HeadJIS>\n		;
<HeadJIS>\033\(.	{ECHO; BEGIN Head;}
<Normal>"\\part{"	{printf("\n******\n\014\n******"); brace=1;BEGIN Head;}
<Normal>"\\chapter{"	{printf("\n\014\n***"); brace=1;BEGIN Head;}
<Normal>{B}{V}		BEGIN Verbatim;
<Verbatim>{E}{V}	BEGIN Normal;
<Normal>"\\verb".	{verbchar=yytext[yyleng-1];BEGIN Verb;}
<Verb>.			{if(yytext[0]==verbchar)
				BEGIN Normal;
			else
				printf("%c",yytext[0]);}
<Normal>({B}|{E})({I}|{Q}|{T}|{F}|{C})	{printf("\n\n");}
<Normal>({B}|{E})	{brace=1;BEGIN Skip;}
<Normal>"\\item"	{printf("\n\n");}
<Normal>"\\bibitem"	{printf("\n\n[");brace=0;BEGIN Ref;}
<Normal>{B}"thebibliography}{"	{brace=1;BEGIN Skip;}
<Normal>"\\cite{"	{printf(" $@;2>H(J [");brace=1;BEGIN Ref;}
<Normal>"\\footnote{"	{printf(" [$@5SCm(J: ");brace=1;BEGIN Ref;}
<Normal>"\\include{"	{printf(" $@;2>H(J [");brace=1;BEGIN Ref;}
<Normal>"\\includeonly{"	{brace=1;BEGIN Skip;}
<Normal>"\\input{"	{printf(" $@;2>H(J [");brace=1;BEGIN Ref;}
<Normal>"\\label{"	{printf("[");brace=1;BEGIN Ref;}
<Normal>"\\pageref{"	{printf(" $@;2>H(J [");brace=1;BEGIN Ref;}
<Normal>"\\ref{"	{printf(" $@;2>H(J [");brace=1;BEGIN Ref;}
<Normal>"\\hspace{"	{printf("  ");brace=1;BEGIN Skip;}
<Normal>"\\hspace*{"	{printf("  ");brace=1;BEGIN Skip;}
<Normal>"\\vspace{"	{printf("\n");brace=1;BEGIN Skip;}
<Normal>"\\vspace*{"	{printf("\n");brace=1;BEGIN Skip;}
<Normal>\\{L}+	; /* ignore other control sequences */
<Normal>"{"	;
<Normal>"}"	;
<Normal>" "+		{printf(" ");}
%%
main(argc,argv)
	char **argv;
{
	int i;
	
	BEGIN Normal; /* Starts yylex off in the right state */
	if (argc==1) {
	    yyin = stdin;
	    yylex();
	    }
	else for (i=1; i<argc; i++) {
	    yyin = fopen(argv[i],"r");
	    if (yyin==NULL) {
		fprintf(stderr,"can't open %s\n",argv[i]);
		exit(1);
		}
	    yylex();
	    }
	exit(0);
}

