%{
#define BF printf("{\\bf %s}",yytext);
%}
%S PREAM DOC WFF REF SQUOTE DQUOTE COMM DEF
%%
	int p;
<PREAM>^"\\begin{document}"	{
	 printf("\\def\\Ptab#1{\\def\\nl{\\\\\\hspace*{#1 cm}}}\n");
	 printf("{\\catcode`\\_=\\active\n");
	 printf("\\gdef\\makeusletter{\\catcode`\\_=\\active");
	 printf("\\gdef_{{\\tt\\char95}}}}\n");
	 printf("\\newcounter{para}\\newcounter{program}\n");
	 ECHO; BEGIN DOC;}
<DOC>^"@{"[ \t\n]*	{printf("\\stepcounter{program}\n"); BEGIN WFF;
		 printf("\\begin{flushleft}\n"); p=0;
		 printf("\\def\\nl{\\\\}\\makeusletter\n");}
<DOC>^"@ "	printf("\\par\\stepcounter{para}{\\bf\\thepara.}\\ \\rm\n");
<DOC>^"@!"	printf("\\par\\bf ");
<DOC>^"@:"	BEGIN DEF;
<DEF>\|[^|]+\|	{printf("\\index{\\verb|%s|(D)}",yytext);
		 printf("\\par\\hfill$\\diamond$\\verb|%s|\\par",yytext);
		 printf("\\label{%s}\n",yytext); BEGIN DOC;}
<DEF>[a-zA-Z0-9\-]+	{printf("\\index{\\verb|%s|(D)}",yytext);
		 printf("\\par\\hfill$\\diamond$\\verb|%s|\\par",yytext);
		 printf("\\label{%s}\n",yytext); BEGIN DOC;}
<DOC>^"@?"	BEGIN REF;
<REF>[^ \t\n\.,]+	{printf("\\index{%s}",yytext);
		 printf("({\\tt %s} p.\\pageref{%s})\n",yytext,yytext);}
<REF>[ ,\t\n]+		;
<REF>"\."		BEGIN DOC;
<WFF>"-"		printf("$-$");
<WFF>"abs"		BF;
<WFF>"and"		BF;
<WFF>"append"		BF;
<WFF>"assoc"		BF;
<WFF>"case"		BF;
<WFF>"cond"		BF;
<WFF>"cons"		BF;
<WFF>"decf"		BF;
<WFF>"declare"		BF;
<WFF>"defconsumer"	BF;
<WFF>"defmacro"		BF;
<WFF>"defstruct"	BF;
<WFF>"defun"		BF;
<WFF>"defvar"		BF;
<WFF>"delete"		BF;
<WFF>"do"		BF;
<WFF>"dolist"		BF;
<WFF>"dotimes"		BF;
<WFF>"eq"		BF;
<WFF>"equal"		BF;
<WFF>"format"		BF;
<WFF>"funcall"		BF;
<WFF>"getf"		BF;
<WFF>"if"		BF;
<WFF>"incf"		BF;
<WFF>"in-package"	BF;
<WFF>"labels"		BF;
<WFF>"lambda"		printf("$\\lambda$",yytext);
<WFF>"let"		BF;
<WFF>"let*"		BF;
<WFF>"list"		BF;
<WFF>"mapcan"		BF;
<WFF>"mapcar"		BF;
<WFF>"member"		BF;
<WFF>"multiple-value-"[a-z0-9]*		BF;
<WFF>"nil"		BF;
<WFF>"not"		BF;
<WFF>"null"		BF;
<WFF>"or"		BF;
<WFF>"otherwise"	BF;
<WFF>"proclaim"		BF;
<WFF>"prog1"		BF;
<WFF>"progn"		BF;
<WFF>"push"		BF;
<WFF>"return"		BF;
<WFF>"reverse"		BF;
<WFF>"setf"		BF;
<WFF>"setq"		BF;
<WFF>"some"		BF;
<WFF>"special"		BF;
<WFF>"t"		BF;
<WFF>"time"		BF;
<WFF>"unless"		BF;
<WFF>"values"		BF;
<WFF>"values-list"	BF;
<WFF>"when"		BF;
<WFF>c[ad]+r		BF;
<WFF>[a-zA-Z0-9][\-*a-zA-Z0-9]*	printf("{\\sl %s}",yytext);
<WFF>^"@}"		{printf("\\end{flushleft}\n"); BEGIN DOC;}
<WFF>\n[ \t]*		printf("\\nl\n");
<WFF>\|			{printf("\\verb*\\"); BEGIN DQUOTE;}
<SQUOTE>[^|]*\|		{printf("%s\\",yytext); BEGIN WFF;}
<WFF>\"			{printf("\\verb*\|\""); BEGIN DQUOTE;}
<DQUOTE>[^"]*\"		{printf("%s\|",yytext); BEGIN WFF;}
<WFF>"\;"[^\n]*/\n	printf("\\verb\|%s\|",yytext);
<WFF>"{"		printf("$\\{$");
<WFF>"}"		printf("$\\}$");
<WFF>"^"		printf("{\\tt\\char94}");
<WFF>"<"		printf("$<$");
<WFF>">"		printf("$>$");
<WFF>"("		{p++; printf("{\\rm(}\\Ptab{%d}",p);}
<WFF>")"		{p--; printf("{\\rm)}\\Ptab{%d}",p);}
<WFF>"&"		printf("{\\tt\\&}");
<WFF>"#"		printf("{\\tt\\#}");
<WFF>"%"		printf("\\%%");
<WFF>"$"		printf("{\\tt\\$}");
<WFF>"["		{p++; printf("$[$\\Ptab{%d}",p);}
<WFF>"]"		{p--; printf("$]$\\Ptab{%d}",p);}
^"\\documentstyle"	{printf("\\font\\bs=cmbxsl10\n"); ECHO; BEGIN PREAM;}
