%{
/*
 *         Prolog WEAVE by Hideki ISOZAKI November 27, 1987
 *     November 27: Inhibit Blank Line by The Last CRLF in <WFF>
 *                  \topsep
 *     Feb. 16, 1988 successive \nl in WFF
 *                   @[ @], >> <<
 *     Feb. 25, 1988 \nl, p=0;
 *     Feb. 26, 1988 \newfont
 *     Jun.  6, 1988 @d
 *     Aug. 18, 1988 Delete @d because I determined to use cpp
 */

static char outtext[200];
int outp, /* Output Text Pointer */
	p, /* Paren Depth */
	b, /* With Body or Not */
	t; /* Tab Depth */
#define pf1(x)	 	printf(x)
#define pf2(x,y) 	printf(x,y)
#define pf3(x,y,z) 	printf(x,y,z)
#define pftxt(x) 	printf(x,yytext)
#define pftex(x) 	printf(x,outtext)
#define pfm(x)		printf("$\\%s$","x")
#define MAKETEX	 tex()
#define MAXQLENG 200
#define SHORTER  (yyleng<MAXQLENG)
#define TOOLONG  {pftxt("--- Too long quotation\n%s\n");exit(1);}
#define USEBF    {pftxt("{\\bf %s}");}
#define PAGEREF  {pf3("(%s p.\\pageref{%s})\n",outtext,yytext);}
#define USED 	 {MAKETEX; pftex("\\index{%s (R)}");PAGEREF;}
#define DEFLABL	 {pftxt("\\label{%s}\n"); BEGIN DOC;}
#define DEFMARK	 {pftex("\n\\par\\hfill$\\diamond$%s\\par");DEFLABL;}
#define DEFINED	 {MAKETEX; pftex("\\index{%s (D)}"); DEFMARK;}
#define TABSET   {pf2("\\Ptab{%d}",t);}
#define INIDEP   {p=0; b=0; t=0;}
#define INCDEP   {p++; t++;}
#define DECDEP   {p--; t--;}
#define WITHBODY {b=1; t=1;}
%}
%S PREAM DOC WFF REF SQUOTE DQUOTE COMM DEF Normal TeXsymbol Verbatim CPP
%%
<PREAM>^"\\begin{document}"	{pf1("\\newfont{\\bs}{cmbxsl10}\n");
	 pf1("\\newlength\\unittab \\setlength{\\unittab}{2em}\n");
	 pf1("\\def\\Ptab#1{\\gdef\\nl{\\\\\\hspace*{#1\\unittab}}}\n");
	 pf1("{\\catcode`\\_=\\active\n");
	 pf1("\\gdef\\makeusletter{\\catcode`\\_=\\active");
	 pf1("\\gdef_{{\\tt\\char95}}}}\n");
	 pf1("\\newcounter{para}\\newcounter{program}\n");
	 pf1("\\pagestyle{headings}\\def\\nl{\\\\}\n");
	 pf1("\\makeindex\\topsep 1mm plus 1mm\n");
	 ECHO; 
	 BEGIN DOC;}
<DOC>^"@{"[ \t\n]*	{pf1("\\begin{quote}\n");
		 pf1("\\stepcounter{program}\n"); BEGIN WFF;
		 pf1("\\begin{flushleft}\\baselineskip 2.7ex\n"); 
		 pf1("\\makeusletter\\ \\nl\n");}
<DOC>^"@ "	pf1("\\par\\stepcounter{para}{\\bf\\thepara.}\\ \\rm\n");
<DOC>^"@!"	pf1("\\par\\bf ");
<DOC>^"@:"	BEGIN DEF;
<DOC>^"@["	{pf1("\\begin{verbatim}");BEGIN Verbatim;}
<Verbatim>^"@]" {pf1("\\end{verbatim}\n");BEGIN DOC;}
<DOC>^"\\end{document}"	{pf1("\\tableofcontents\n"); ECHO; }
<DEF>\'[^']+\'\/[0-9]+			DEFINED;
<DEF>[a-z][a-zA-Z0-9_]*\/[0-9]+		DEFINED;
<DOC>^"@?"				BEGIN REF;
<REF>\'[^']+\'				USED;
<REF>[^ \t\n\.,]+			USED;
<REF>[ ,\t\n]+				;
<REF>"\."				BEGIN DOC;
<WFF>"/*"				{BEGIN COMM; ECHO;}
<COMM>[^(*/)]*"*/"			{ECHO; BEGIN WFF;}
<WFF>[ \t]*":-"[ \t]*			{pf1("\\ $:-$\\ \\Ptab{1}"); WITHBODY;}
<WFF>"repeat"		USEBF;
<WFF>"tell"		USEBF;
<WFF>"told"		USEBF;
<WFF>"see"		USEBF;
<WFF>"seen"		USEBF;
<WFF>"fail"		USEBF;
<WFF>"forall"		USEBF;
<WFF>"assert"		USEBF;
<WFF>"assert"[az]	USEBF;
<WFF>"retract"		USEBF;
<WFF>"abolish"		USEBF;
<WFF>"record"[az]	USEBF;
<WFF>(set|bag)of	USEBF;
<WFF>"abort"		USEBF;
<WFF>"!"			pfm(rhd);
<WFF>"in"			pfm(in);
<WFF>[a-z][a-zA-Z0-9_]*		pftxt("{\\sl %s}");
<WFF>[A-Z_][a-zA-Z0-9_]*	pftxt("{\\bs %s}");
<WFF>[0-9]+"."[0-9]+	ECHO;
<WFF>^"@}"		{pf1("\\end{flushleft}\\end{quote}\n"); BEGIN DOC;}
<WFF>\n/[^@]		pf1("\\ \\nl\n");
<WFF>\"			{pf1("{\\tt\"}\\verb*\""); BEGIN DQUOTE;}
<DQUOTE>[^"]*\"		{if(SHORTER){pftxt("%s{\\tt\"}");BEGIN WFF;}
			else TOOLONG;}
<WFF>\'			{pf1("{\\tt\'}\\verb\'"); BEGIN SQUOTE;}
<SQUOTE>[^']+\'		{if(SHORTER){pftxt("%s{\\tt\'}");BEGIN WFF;}
			else TOOLONG;}
<WFF>"\%"[^\n]*/\n	{if(SHORTER){pftxt("\\verb\|%s\|");} else TOOLONG;}
<WFF>"|"		pfm(mid);
<WFF>"{"		pf1("$\\{$");
<WFF>"}"		pf1("$\\}$");
<WFF>"-->"		pfm(longrightarrow);
<WFF>"->"		pfm(rightarrow);
<WFF>"<-"		pfm(leftarrow);
<WFF>"==>"		pfm(Longrightarrow);
<WFF>"=>"		pfm(Rightarrow);
<WFF>"<=="		pfm(Longleftarrow);
<WFF>"<="		pfm(Leftarrow);
<WFF>"\\+"		pfm(neg);
<WFF>"=.."		pfm(simeq);
<WFF>"\\"		pfm(backslash);
<WFF>"\\=="		pf1("$\\not\\equiv$");
<WFF>"=="		pfm(equiv);
<WFF>"@<"		pfm(prec);
<WFF>"@>"		pfm(succ);
<WFF>"@=<"		pfm(preceq);
<WFF>"@>="		pfm(succeq);
<WFF>"=<"		pfm(leq);
<WFF>">="		pfm(geq);
<WFF>"^"		pf1("{\\tt\\char94}");
<WFF>"*"		pfm(cdot);
<WFF>"-"		pf1("$-$");
<WFF>"=:="		pf1("=");
<WFF>"=\\="		pfm(neq);
<WFF>"<"		pf1("$<$");
<WFF>">"		pf1("$>$");
<WFF>"<<"		pfm(ll);
<WFF>">>"		pfm(gg);
<WFF>"\/\\"		pfm(wedge);
<WFF>"\\\/"		pfm(vee);
<WFF>"="		pfm(cong);
<WFF>"("		{INCDEP; pf1("{\\rm(}"); TABSET;}
<WFF>")"		{DECDEP; pf1("{\\rm)}"); TABSET;}
<WFF>","[ \t]*		pf1(", \n");
<WFF>"."[ \t]*		{pf1(".\\Ptab{0}"); 
		if(p==0){INIDEP;} else 
		    {fprintf(stderr,"Mismatched ( ) at line %d.\n",yylineno);
			exit(1);}}
<WFF>"&"		pf1("{\\tt\\&}");
<WFF>"#"		pf1("{\\tt\\#}");
<WFF>"$"		pf1("{\\tt\\$}");
<WFF>"["		{INCDEP; pf1("$[$"); TABSET;}
<WFF>"]"		{DECDEP; pf1("$]$"); TABSET;}
<Normal>"\\documentstyle"	{ECHO; BEGIN PREAM;}
%%

tex()
{
 int bfin;
 int inp;
 inp=0;
 outp=0;
 while((bfin=(int)yytext[inp])>0)
 {
 inp++;
 switch(bfin)
  {
/* TeX Special Characters */
  case 35 : usecommand("\\#") ; break ; /* sharp# in ASCII */
  case 36 : usecommand("\\$") ; break ; /* dollar$ in ASCII */
  case 37 : usecommand("\\%%") ; break ; /* percent% in ASCII */
  case 38 : usecommand("\\&") ; break ; /* ampersand& in ASCII */
  case 60 : usecommand("$<$"); break ;
		       /* bra (is less than)< in ASCII */
  case 62 : usecommand("$>$"); break ;
		       /* ket (is greater than)> in ASCII */
  case 91 : usecommand("$[$"); break ;
		       /* left bracket[ in ASCII : LaTeX optional arg*/
  case 92 : usecommand("$\\backslash$") ; break ;
		       /* backslash\ in ASCII */
  case 93 : usecommand("$]$"); break ;
		       /* right bracket] in ASCII : LaTeX optional arg*/
  case 94 : usecommand("{\\tt\\char94}"); break ;
		       /* caret^ in ASCII */
  case 95 :  usecommand("\\_"); break ; /* underscore_ in ASCII */
  case 123 : usecommand("$\\{$");
	     break ; /* left brace{ in ASCII */
  case 124 : usecommand("$|$"); break ;
		       /* vertical bar (pipe)| in ASCII */
  case 125 : usecommand("$\\}$");
	     break ; /* right brace} in ASCII */
  case 126 : usecommand("{\\tt\\char126}"); break ;
		       /* tilde~ in ASCII */
  default : outtext[outp]=(char)bfin ; outp++;
  }
outtext[outp]=(char)0;
}}

usecommand(s)
char *s;
{
int bfout; 
	while((bfout=(int)*s)>0)
		{outtext[outp]=(char)bfout; outp++; s++;} 
}

main(argc,argv)
	char **argv;
{
	INIDEP;
	BEGIN Normal; /* Starts yylex off in the right state */
	if(argc==1) {yyin = stdin; yylex(); exit(0);}
        else {fprintf("!! Invalid Argument for %s\n",argv[0]);exit(1);}
}
