%{
/*
 *         Universal WEAVE by Hideki ISOZAKI November 24, 1987
 *     Language Independent WEAVE
 */

static char outtext[200];
int outp;

%}
%S PREAM DOC WFF REF COMM DEF
%%
	int p;
<PREAM>^"\\begin{document}"	{
	 printf("\\newcounter{para}\\newcounter{program}\n");
	 printf("\\pagestyle{headings}\n");
	 printf("\\makeindex\n");
	 ECHO; 
	 BEGIN DOC;}
<DOC>^"@{"[ \t\n]*	{printf("\\stepcounter{program}\n"); BEGIN WFF;
		 printf("\\begin{verbatim}\n"); p=0;}
<DOC>^"@ "	printf("\\par\\stepcounter{para}{\\bf\\thepara.}\\ \\rm\n");
<DOC>^"@!"	printf("\\par\\bf ");
<DOC>^"@:"	BEGIN DEF;
<DOC>^"\\end{document}"	{printf("\\tableofcontents\n"); ECHO; }
<DEF>\'[^']+\'\/[0-9]+	{tex(); printf("\\index{%s (D)}",outtext);
		 printf("\n\\par\\hfill$\\diamond$%s\\par",outtext);
		 printf("\\label{%s}\n",yytext); BEGIN DOC;}
<DEF>[a-z][a-zA-Z0-9_]*\/[0-9]+	{tex();printf("\\index{%s (D)}",outtext);
		 printf("\\par\\hfill$\\diamond$%s\\par",outtext);
		 printf("\\label{%s}\n",yytext); BEGIN DOC;}
<DOC>^"@?"	BEGIN REF;
<REF>\'[^']+\'	{tex(); printf("\\index{%s (R)}",outtext);
		 printf("(%s p.\\pageref{%s})\n",outtext,yytext);}
<REF>[^ \t\n\.,]+	{tex(); printf("\\index{%s (R)}",outtext);
		 printf("(%s p.\\pageref{%s})\n",outtext,yytext);}
<REF>[ ,\t\n]+		;
<REF>"\."		BEGIN DOC;
<WFF>"/*"		{BEGIN COMM; ECHO;}
<COMM>[^(*/)]*"*/"	{ECHO; BEGIN WFF;}
<WFF>^"@}"		{printf("\\end{verbatim}\n"); BEGIN DOC;}
^"\\documentstyle"	{ECHO; BEGIN PREAM;}
%%

tex()
{
 int bfin;
 int inp;
 inp=0;
 outp=0;
 while((bfin=(int)yytext[inp])>0)
 {
 inp++;
 switch(bfin)
  {
/* TeX Special Characters */
  case 35 : mov("\\#") ; break ; /* sharp# in ASCII */
  case 36 : mov("\\$") ; break ; /* dollar$ in ASCII */
  case 37 : mov("\\%%") ; break ; /* percent% in ASCII */
  case 38 : mov("\\&") ; break ; /* ampersand& in ASCII */
  case 60 : mov("$<$"); break ;
                       /* bra (is less than)< in ASCII */
  case 62 : mov("$>$"); break ;
                       /* ket (is greater than)> in ASCII */
  case 91 : mov("$[$"); break ;
                       /* left bracket[ in ASCII : LaTeX optional arg*/
  case 92 : mov("$\\backslash$") ; break ;
                       /* backslash\ in ASCII */
  case 93 : mov("$]$"); break ;
                       /* right bracket] in ASCII : LaTeX optional arg*/
  case 94 : mov("{\\tt\\char94}"); break ;
                       /* caret^ in ASCII */
  case 95 :  mov("\\_"); break ; /* underscore_ in ASCII */
  case 123 : mov("$\\{$");
             break ; /* left brace{ in ASCII */
  case 124 : mov("$|$"); break ;
                       /* vertical bar (pipe)| in ASCII */
  case 125 : mov("$\\}$");
             break ; /* right brace} in ASCII */
  case 126 : mov("{\\tt\\char126}"); break ;
                       /* tilde~ in ASCII */
  default : outtext[outp]=(char)bfin ; outp++;
  }
outtext[outp]=(char)0;
}}

mov(s)
char *s;
{
int bfout; 
while((bfout=(int)*s)>0)
{outtext[outp]=(char)bfout; outp++; s++;} 
}
