/**********************************************************************/
/*************************  Global Procedures  ************************/
/**********************************************************************/

/* $Header$ */
/* Note: Global procedures are declared here in alphabetical order, with
   those which do not return values typed "void".  Their bodies occur in
   alphabetical order following the main() procedure.  The names are
   kept unique in the first 6 characters for portability. */

void	do_pages();
void	AbortRun();
float	ActualFactor();
void	AllDone();
FILE*	BINARYOPEN();
void	Fatal();
void	FindPostAmblePtr();
void	GetBytes();
void	GetFontDef();
void	GotInterrupt();
void	InitLBP();
int	InputWaiting();
void	MoveDown();
void	MoveOver();
int	PixRound();
void	PutCharPattern();
int	ReadFontDef();
int	ReadPostAmble();
void	ResetLBP();
void	SetChar();
void	SetFntNum();
BOOLEAN	CheckFontNum();
void	SetRule();
void	SkipFontDef();
void	Warning();

/**********************************************************************/
/*************************  Global Variables  *************************/
/**********************************************************************/


struct char_entry {		/* character entry */
   short width, height;		/* width and height in pixels */
   short xOffset, yOffset;      /* x offset and y offset in pixels */
   struct {
       struct {
	   int fileOffset;
	   char *pixptr;
       } address;
   } where;
   int tfmw;			/* TFM width */
   int nbpl;
   short loaded;
};

struct font_entry {  /* font entry */
	int	k, c, s, d, a, l;
	char	n[STRSIZE];	/* FNT_DEF command parameters 		    */
	int	font_space;	/* computed from FNT_DEF s parameter        */
	int	font_mag;	/* computed from FNT_DEF s and d parameters */
	int	font_type;
	int	dic_pack;
	char	name[STRSIZE];	/* full name of PXL file                    */
	int	isDownLoad;	/* font is down loaded			    */
	                /*  0 non loaded, 1 loaded, 2 internal */
	int	gfxSetNumber;	/* LPB8 graphics set number		    */
	int	magnification;	/* magnification read from PXL file         */
	int	designsize;	/* design size read from PXL file           */
	FILE 	*font_file_id;  /* file identifier (NO_FILE if none)	*/
	struct	char_entry ch[NPXLCHARS];  /* character information         */
	struct	font_entry *next;
};

#ifdef MAIN 
#  define  EXTERN
#  define  INIT(arg) =(arg)
#else
#  define  EXTERN extern
#  define  INIT(arg)
#endif

EXTERN int     use_mem INIT(0);
EXTERN BOOLEAN	isDownLoaded;
EXTERN int     current_gfx INIT(-1);
EXTERN int	gfxSet INIT( GFXSETBASE);/* LBP8 user graphics set number    */
EXTERN int	stack_size;
EXTERN int	conv;			/* converts DVI units to pixels     */
EXTERN int	den;			/* denominator specified in preamble*/
EXTERN FILE	*dvifp;			/* DVI file pointer */
EXTERN struct	font_entry *fontptr;    /* font_entry pointer */
EXTERN struct	font_entry *hfontptr INIT( (struct  font_entry *)NULL);
				/* font_entry pointer                  */
EXTERN int	h;			/* current horizontal position  */
EXTERN int	hh;		/* current horizontal position in pixels    */
EXTERN int	v;			/* current vertical position    */
EXTERN int	vv;			/* current vertical position in pixels*/
EXTERN int	mag;			/* magnification specified in preamble*/
EXTERN int	num;			/* numerator specified in preamble    */
EXTERN FILE	*pxlfp;			/* PXL file pointer                  */
EXTERN int	page_height, page_width,
		paper_height, paper_width;
EXTERN int	xscreen, yscreen;
EXTERN char	*filename;		/* tempolary file name		   */
EXTERN char *FNTpath;			/* Font path name for search	*/

EXTERN int G_errenc INIT(FALSE);	 /* has an error been encountered? */
EXTERN char G_progname[STRSIZE];  /* program name                            */
EXTERN FILE *openfont_file_id;     /* file identifier                    */
EXTERN struct font_entry *pfontptr INIT(NULL); /* previous font_entry pointer */
EXTERN int   nopen INIT(0);        /* number of open FNT files */
#ifdef DEBUG
EXTERN int Debug INIT(0);
#endif
/**********************************************************/
