#include <stdio.h>
#include "pxl.h"
#include "gfcodes.h"

#define 	WHITE	0
#define 	BLACK	1
#define		SETBIT(x,y)	bitsp[y+(x>>3)] |= 1<<(x&7)
#define 	INVERT(x)	x = 1-x

read_GF_bitmap(ch, g)
ubyte ch;
register struct glyph *g;
{
	register struct bitmap *bitmap;
	register int i, j, k;
	register char *bitsp;
	register int bitwidth, paint, length;
	register int min_m,max_m,del_m,min_n,max_n,del_n;
	register file_bytes_wide;
	FILE *pxlfp;
	ubyte pxlch;

	pxlfp = current_font->file;
	fseek(pxlfp, g->addr, 0);
	bitmap = &g->bitmap;

	if ((pxlch = one(pxlfp)) == GF_BOC) {
		if (four(pxlfp) != ch)
			error("Postamble %d points glyph %d\n",ch,pxlch);
		(void)sfour(pxlfp);
		min_m = sfour(pxlfp);
		max_m = sfour(pxlfp);
		min_n = sfour(pxlfp);
		max_n = sfour(pxlfp);
		del_m = max_m - min_m;
		del_n = max_n - min_n;
	}
	else if (pxlch == GF_BOC1) {
		if (one(pxlfp) != ch)
			error("Postamble %d points glyph %d\n",ch,pxlch);
		del_m = one(pxlfp);
		max_m = one(pxlfp);
		del_n = one(pxlfp);
		max_n = one(pxlfp);
		min_m = max_m - del_m;
	}
	else
		error("%d should be GF_BOC or GF_BOC1.\n",pxlch);

	bitmap->w = del_m;
	bitmap->h = del_n + 1;
	g->x = - min_m / shrink_factor;
	g->y = max_n / shrink_factor;

	if ((bitmap->w <= 0) || (bitmap->h <= 0))
		error("Strange font : %s\n width = %d , height = %d\n",
		    current_font->fontname,bitmap->w,bitmap->h);

	bitwidth = bitmap->bytes_wide = ROUNDUP(bitmap->w,BITS_PER_SHORT)*BYTES_PER_SHORT;
	bitsp = bitmap->bits = malloc(bitmap->h * bitwidth);

	for (i = 0; i < bitwidth * bitmap->h; i++)
			bitsp[i] = 0;

	i = j = 0;
	paint = WHITE;

	while ((pxlch = one(pxlfp)) != GF_EOC) {
		switch (pxlch) {
		case GF_PAINT_0:
			INVERT(paint);
			break;
		case GF_PAINT1:
		case GF_PAINT2:
		case GF_PAINT3:
			length = num(pxlfp,pxlch-GF_PAINT1+1);
			if (paint == BLACK)
				for (k = 0; k < length; i++,k++)
					SETBIT(i,j);
			else
				i += length;
			INVERT(paint);
			break;
		case GF_SKIP0:
			j += bitwidth;
			i = 0;
			paint = WHITE;
			break;
		case GF_SKIP1:
		case GF_SKIP2:
		case GF_SKIP3:
			j += bitwidth*(num(pxlfp,pxlch-GF_SKIP0)+1);
			i = 0;
			paint = WHITE;
			break;
		case GF_XXX1:
		case GF_XXX2:
		case GF_XXX3:
		case GF_XXX4:
			fseek(pxlfp,snum(pxlfp,pxlch-GF_XXX1+1),1);
			break;
		case GF_YYY:
			fseek(pxlfp,4L,1);
			break;
		case GF_NOP:
			break;
		default:
			if ((GF_PAINT_0 < pxlch) && (pxlch < GF_PAINT1)) {
				length = pxlch-GF_PAINT_0;
				if (paint)
					for (k = 0; k < length; i++,k++)
						SETBIT(i,j);
				else
					i += length;
				INVERT(paint);
			}
			else if ((GF_NEW_ROW_0 <= pxlch) && (pxlch <= GF_NEW_ROW_MAX)) {
				j += bitwidth;
				paint = BLACK;
				i = pxlch - GF_NEW_ROW_0;
			}
			else
			{
				fprintf(stderr,"GF invalid %d command in %s\n",pxlch,current_font->fontname);
				fseek(pxlfp,-20L,1);
				for (k = 0; k < 20; k++)
					fprintf(stderr,"%3d ",one(pxlfp));
				fprintf(stderr,"\n");					
				for (k = 0; k < 20; k++)
					fprintf(stderr,"%3d ",one(pxlfp));
				fprintf(stderr,"\n");
			}
			break;
		}
	}
}


read_GF_glyphs(fontp)
register struct font *fontp;
{
	register struct glyph *g;
	FILE *pxlfp;
	ubyte pxlch;
	ubyte ch;

	pxlfp = fontp->file;
	fseek(pxlfp,-4L,2);
	while ((pxlch = one(pxlfp)) == GF_FILLER)
		fseek(pxlfp,-2L,1);
	if (pxlch != GF_ID)
		error("GF ID %s = %d not %d\n",fontp->fontname,pxlch,GF_ID);
	fseek(pxlfp,-6L,1);
	if ((pxlch = one(pxlfp)) != GF_POSTPOST)
		error("GF PostPost %s = %d not %d\n",fontp->fontname,pxlch,GF_POSTPOST);

	fseek(pxlfp,four(pxlfp),0);
	if ((pxlch = one(pxlfp)) != GF_POST)
		error("GF Post %s = %d not %d\n",fontp->fontname,pxlch,GF_POST);

	fseek(pxlfp,36L,1);
	g = &fontp->glyph[0];

	while (((pxlch = one(pxlfp)) == GF_CHAR_LOC) || (pxlch == GF_CHAR_LOC0)) {
		ch = one(pxlfp);
		g[ch].bitmap.bits = NULL;
		if (pxlch == GF_CHAR_LOC) {
			g[ch].pxl_adv = four(pxlfp)/65536/shrink_factor;
			fseek(pxlfp,4L,1);
		}
		else 
			g[ch].pxl_adv = one(pxlfp) / shrink_factor;
		g[ch].dvi_adv = ((double) fontp->scale * four(pxlfp)) / (1 << 20);
		g[ch].addr = four(pxlfp);
	}

	if (pxlch != GF_POSTPOST)
		error("There is %d between Post Charloc and PostPost.\n",pxlch);
}
