/*
 * ipr.h -- ImPress printer spooler definitions
 *
 * by Bill Nowicki September 29, 1981
 * at Stanford University for Imagen Corporation
 */

# define SPOOLDIR "/usr/spool/ipd"		/* the spooling directory */
# define LOCK     "/usr/spool/ipd/lock"		/* the lock file  */
# define LOG      "/tmp/implog"		/* the error log file  */
# define DAEMON   "/usr/local/lib/imagen/ipd"		/* the unqueuing daemon */
# define PRINTING "/usr/local/lib/imagen/ips"		/* the printing program */
# define COMMAND  "/usr/nue/bin/ipr"		/* the command for enqueing */
# define WRITE    "/usr/local/lib/imagen/dwrite"		/* write to a user */
# define HUMAN    "ImPress printer Daemon"	/* Human understandable name */
# define KIND	  "ImPrint"			/* kind of printer we use */

# define LOCKTIMEOUT	5*60		/* seconds for the lock timeout */

# define LineSize 128			/* size of a data line */

# include <sys/types.h>
# include <sys/dir.h>
# include <sys/stat.h>
# include <signal.h>
# include <stdio.h>
# include "c.h"
# define bool int

/*
 * I am not sure if the following is documented anywhere, so
 * I thought I would include it here so nonone else has to go through
 * what I did to discover how the standard spooling stuff works.
 * I also added a few of my own codes, which should not conflict
 * with anything.
 *
 * Basically there are files in the spool directory of the form:
 * dfXXXXXa (where XXXXX is the pid), that have lines with a one
 * character code followed by informational lines:
 *	B	treated like F in ipq.c
 *	C	number of copies to print
 *	F	File name to print
 *	L	User's name responsible for printing
 *	M	Mail address to inform when printing is complete
 *	N	User to notify when printing is complete
 *	P	Pages in body (total)
 *	R	"Real" user name for cover sheet
 *	T	"Tag" to identify this job, usually the file name
 *	U	File to unlink after finishing
 */

extern int debug;	/* for extra debugging messages */

int Copies;		/* number of copies to print */
int Pages;		/* number of pages (approx) */
