/*	%W%		%G% %U%						    */

/****************************************************************************/
/****************************************************************************/
/**									   **/
/**	"imPcodes.h"							   **/
/**									   **/
/**	IMAGEN UNIX Host Software					   **/
/**	imPRESS Command Code Definitins					   **/
/**									   **/
/**	Copyright 1985		IMAGEN Corporation			   **/
/**				2650 San Tomas Expressway		   **/
/**				P.O. Box 58101				   **/
/**				Santa Clara, CA 95052-8101		   **/
/**				(408) 986-9400				   **/
/**									   **/
/****************************************************************************/
/****************************************************************************/
/**									   **/
/**	#defines for imPRESS Commands. These Match Those in the August	   **/
/**	1984 imPRESS Programmer's Manual.				   **/
/**	Additionally Contains SET_CLIP_REGION and RESET_CLIP_REGION	   **/
/**	Command Codes							   **/
/**									   **/
/****************************************************************************/
/****************************************************************************/
/**									   **/
/**	Revision History:						   **/
/**	-----------------						   **/
/**									   **/
/**	Release 2.2 -- August 1985, Initial Base Release		   **/
/**									   **/
/****************************************************************************/
/****************************************************************************/

#define iSP		128	/* advance one space			*/
#define	iSP1		129	/* advance one space + 1 pixel		*/
#define iMPLUS		131	/* Move one pixel forward		*/
#define	iMMINUS		132	/* Move one pixel back			*/
#define iMMOVE		133	/* Move in main advance direction	*/
#define iSMOVE		134	/* Move in secondary advance direction	*/

#define iABS_H		135	/* Move to H position			*/
#define iREL_H		136	/* Move in H direction			*/
#define iABS_V		137	/* Move to V position			*/
#define iREL_V		138	/* Move in V direction			*/

#define	iCLIP_REGION	140	/* Define a region to be clipped	*/
#define	iUNCLIP_REGION	141	/* Reset clipping  region		*/

#define iCIRC_ARC	150	/* Define a circular path		*/
#define iELLIPSE_ARC 	151	/* Define an eliptical path		*/
#define iCIRC_SEGM	160	/* Define a pie-shaped path		*/

#define	iBRULE		193	/* print a rule	 			*/

#define	iCRLF		197	/* move to beginning of next line	*/

#define iBGLY		199	/* define a downloaded glyph		*/

#define	iSET_HV_SYSTEM	205	/* Define new coordinate system		*/
#define	iSET_ADV_DIRS	206	/* Define advance directions		*/

#define	iSET_FAMILY	207	/* Use the family given			*/
#define	iSET_IL		208	/* define the space between lines	*/
#define	iSET_BOL	209	/* define the beginning of a line	*/
#define	iSET_SP		210	/* define the space between words	*/

#define	iPUSH		211	/* push state variables on the stack	*/
#define	iPOP		212	/* pop state variables off the stack	*/

#define	iPAGE		213	/* Set H and V to 0			*/
#define iSET_PUSH_MASK	214	/* Specify which variables to save	*/
#define iENDPAGE	219	/* print the current page		*/

#define iC_FAMILY_TABLE	221	/* Define a family table		*/
#define iC_MAP		222	/* Create a member map			*/
#define iSET_PUM	225	/* append or replace current path	*/
#define iC_PATH		230	/* Define a path of segmants		*/
#define	iSET_TEXTURE	231	/* Select a texture for drawing		*/
#define iSET_PEN	232	/* Select a pen width in pixels		*/
#define iFILL_PATH	233	/* shade the area inside a path		*/
#define iDRAW_PATH	234	/* draw the current path		*/
#define iBITMAP		235	/* Print a full bitmap			*/
#define iSET_MAGNIFICATION 236
				/* magnify the page by 1, 2, 4		*/
#define iDEFINE_MACRO	242	/* define a macro			*/
#define iEXECUTE_MACRO	243	/* execute the named macro		*/
#define iNOOP		254	/* no operation				*/
#define iEOF		255	/* end of impress document		*/


/*
 *	OBSOLETE CODES
 */

#define	iO_MMOVE	130
#define	iO_SRULE	192
#define	iO_SET_HPOS	195
#define	iO_SET_VPOS	196
#define iO_SGLY		198
#define	iO_DELG		200
#define	iO_DELF		202
#define	iO_MKTEXTURE	203
#define iO_FORCE_GLY_DEL	240
#define	iO_FILE		244
#define	iO_EXEC_FILE	245



#ifdef OLD_IMP_CODES

#include "oldimPcodes.h"

#endif OLD_IMP_CODES
