#include <stdio.h>
#include "resfonts.h"
#include "imPcodes.h"

#define white(x) (x==' ' || x=='\t')
char *index(),*rindex();

extern int landscape;

typedef char bool;
#define TRUE 1
#define FALSE 0
DoSpecial(bytes,fp) long bytes; FILE *fp;
{
	static bool initfonts=FALSE;
	bool first;
	unsigned long size, tempsize;
	FILE *tempin;
	char *ai,*bi,*ci,*di,*ei,*fi;
	char inchar;	
	int  tempi;
	int  i;
	enum spectype {INSERT, OVERLAY};
	enum spectype optype;

	ai = bi = (char *) malloc((tempsize = bytes)+1);
	while (tempsize--) *bi++=(char) fgetc(fp);
	*bi='\0'; /* null out string */
	bi = ai;
	if (size > 132){
		fprintf(stderr, "special command > 132 characters\n");
		free(ai);
		return;
	}

	while(white(*bi)) bi++;		/* skip leading white space */
	ei = ci = bi;

	if (!index(ei,'(') || !rindex(ei,')')){ 	/* check for leading and trailing *\
			  fprintf(stderr, "incorrect special format\n"); /* prens */
		free(ai);
		return;
	}

	while (!white(*ci) && *ci != '(' ) ci++;  /* skip non white till ( or white */
	*ci='\0';				/* make a string of it */
	while (*ei){				/* and lowercase it all */
		if (*ei >= 'A' && *ei <= 'Z') *ei = *ei + 'a' - 'A';
		ei++;
	}
	if (!strcmp("insert",bi)) 		/* find include, overlay, or */
		optype = INSERT;
	else if (!strcmp("overlay",bi)) 	/* else it is an error */
		optype = OVERLAY;
	else {
		fprintf(stderr,
		"special command operation must be 'insert' or 'overlay'\n");
		free(ai);
		return;
	}

	bi = ++ci;
	while(white(*bi) || *bi == '(' ) bi++;	/* find the file name */
	while(white(*bi)) bi++;
	ci = bi;
	while(!white(*ci) && *ci != ')') ci++;	/* delimited by a ) */
	*ci = '\0';				/* make a string of it */

	if ((tempin = fopen(bi ,"r")) == NULL){	/* open the file */
		fprintf(stderr, " can't open %s \n",bi);
		free(ai);
		return;
	}
	free(ai);				/* no longer need this */

/*	UpdPos(); */
	ImPressPutc(APUSH);
	switch (optype){
/* At the moment, only overlay(file) and insert(file) are
 * recognized.  We use a slightly modified 'impen' (from Stanford
 * via Imagen to produce this stuff, which makes plots come out
 * in landscape mode.  Hence the rotation and stuff.  Other
 * Impress-production software may, of course, behave differently...
 */
	case OVERLAY:				
		ImPressPutc(APAGE);
		if (landscape) {
			ImPressPutc(AMS);
			ImPressPutc(0104);
		}
		else {
			ImPressPutc(ASABSV);
			ImPressBufWord(2040);	/* 8.5 in down */
			ImPressPutc(AMS);
			ImPressPutc(0147);
			ImPressPutc(APAGE);
		}
		break;

	case INSERT:
		ImPressPutc(AMS);
		if (landscape)
			ImPressPutc(0144);
		else
			ImPressPutc(0147);
		break;
	}
	if (!initfonts) {		/* Haven't initialized res fonts */
		for (i=0;i<N_RES_FONTS; i++) {
			ImPressPutc(ACREFAM);
			ImPressPutc(fontTable[i].family);
			ImPressPutc(1);
			ImPressPutc(0);
			ImPressPrintf("%s",fontTable[i].name);
			ImPressPutc(0);
		}
		initfonts=TRUE;
	}
	first = TRUE;
	while ((tempi = getc(tempin)) != EOF) { 	
		inchar = (char) tempi;
		if (inchar ==  '@' && first) {			/* remove document control */
			while (((inchar = getc(tempin)) != EOF)
			          && (inchar != ')' ));
			tempi = getc(tempin);
		}
		first = FALSE;

		ImPressPutc(tempi);
	}
	ImPressPutc(APAGE);
	ImPressPutc(APOP);
}
