/*
 *
 *       This file is separated from original jdviimp.c
 *       because of convienience.
 *
 */

#include <stdio.h>
#include "font.h"

read_PXL_font(fontp)
  struct font *fontp;
{
  long checksum, magnify, trailer_ptr;
  long design_size, font_dir_ptr, pxl_id_word;
  int numchar, i;
  FILE *pxlfp;

	pxlfp = fontp->pxlfp;
	fseek(pxlfp, - (5 * 4L), 2);        /* Seek to trailer info   */
	trailer_ptr = ftell(pxlfp);
        checksum      = four(pxlfp);
        magnify = four(pxlfp);
        design_size   = four(pxlfp);
        font_dir_ptr  = four(pxlfp) * 4;
        pxl_id_word   = four(pxlfp);

	fseek(pxlfp, font_dir_ptr, 0);      /* Seek to font directory */
        
	if (trailer_ptr - font_dir_ptr > 128*16) numchar = 256;
	 else numchar = 128;

	fontp->pxlfp = pxlfp;	/* store file pointer */
        fontp->bc = 0;
        fontp->ec = numchar-1;
	for (i=0; i < numchar; i++)
	{
            fontp->state[i] = NotReady;
	    fontp->W[i]     = two(pxlfp);
	    fontp->H[i]     = two(pxlfp);
	    fontp->X[i]     = two(pxlfp);
	    fontp->Y[i]     = two(pxlfp);
            fontp->glyph_ptr[i]    = four(pxlfp) * 4;
                    /*
                    **  The TFM-width word is kind of funny in the units
                    **  it is expressed in.  It works this way:
                    **
                    **  If a glyph has width 'w' in a font with design-size
                    **  'd' (both in same units), the TFM-width word is
                    **
                    **                    (w/d) * 2^20
                    **
                    **  Therefore, in order to find the glyph width in
                    **  DVI units (1 / 2^16 points), we take the design-size
                    **  'd' (in DVI's), the magnification 'm' of the PXL file
                    **  and the TFM-width word 't' to the width (in DVI's)
                    **  as follows:
                    **
                    **                     dmt
                    **                w = -----
                    **                    2^20
                    **
                    **  But the magnification of the PXL file is just the
                    **  scaled size 's' over the design size, so the final
                    **  expression for the width is
                    **
                    **                     st
                    **                w = ----
                    **                    2^20
                    **
                    */      
#ifndef UNDEFINED
            fontp->dvi_adv[i] =
                    ((double) fontp->scale * four(pxlfp)) / (1 << 20);
#else
            fontp->dvi_adv[i] =
                    ((double) fontp->design * four(pxlfp)) / (1 << 20);
#endif
#ifdef TEXCOPY
            fontp->pxl_adv[i] = 0;
#else
            fontp->pxl_adv[i] = pixel_round(fontp->dvi_adv[i]);
#endif
	}
}


read_PXL_glyph(fontp, i)
     register struct font *fontp;
     int i;
{
  register int 	   real_bytes_wide = (fontp->W[i] + 7) >> 3;
  register int     file_bytes_wide = ((fontp->W[i] + 31) >> 5) << 2;
  register char    *ptr;

  ptr = fontp->Glyph[i] = (char *)malloc(fontp->H[i] * real_bytes_wide);
  if (ptr == NULL)
    error("Out of memory while reading character %d of font %s\n",
	  i, fontp->fontname);
  fseek(fontp->pxlfp, fontp->glyph_ptr[i], 0);
  if (file_bytes_wide == real_bytes_wide) {
    /* if there is no gap in the glyph, read at once */
    if (fread(ptr, sizeof(*ptr),
	      real_bytes_wide*fontp->H[i], fontp->pxlfp)
	==0)
      error("Error while reading character %d of font %s\n",
	    i, fontp->fontname);
  } else {
    register int j;
    for (j=fontp->H[i]; j > 0; j--) {
      if (fread(ptr, sizeof(*ptr), real_bytes_wide, fontp->pxlfp) ==0)
	error("Error while reading character %d of font %s\n",
	      i, fontp->fontname);
      ptr += real_bytes_wide;
      if (fseek(fontp->pxlfp, (long)(file_bytes_wide-real_bytes_wide), 1)== -1)
	error("Error while seeking next raster of char %d of font %s\n",
	      i, fontp->fontname);
    }
  }
}
