#ifndef lint

static char rcsid[] = "$Header: dvikcr.c,v 1.9 88/12/08 05:58:51 root Locked $";
#endif

/*
 *	$Log:	dvikcr.c,v $
 * Revision 1.9  88/12/08  05:58:51  root
 * memory fix
 * 
 * Revision 1.8  88/12/08  02:20:55  root
 * gothic
 * 
 * Revision 1.7  88/12/07  15:09:21  root
 * gcc errors
 * 
 * Revision 1.6  88/11/15  15:55:27  root
 * special
 * 
 * Revision 1.5  88/08/04  12:27:30  root
 * rule and clear bug
 * 
 * Revision 1.4  88/05/10  19:01:26  spock
 * fix open file number
 * 
 * Revision 1.3  88/04/07  17:53:57  spock
 * pk support
 * 
 * Revision 1.2  88/02/27  05:00:40  spock
 * screen compatible with dvi2ps
 * 
 * Revision 1.1  88/02/23  17:50:11  spock
 * Initial revision
 * 
 * Revision 1.0  88/02/23  11:31:34  spock
 * Kyocera Kanji dvi Filger:Ver. 1.0
 * Revision 1.1  86/04/21  14:44:20  nanako
 * Initial revision
 * 
 */

#define  MAIN

#include <sgtty.h>
#include <stdio.h>
#include <sys/file.h>
#include "commands.h"

#include "defs.h"
#include "global.h"
#include "kyocera.h"

/**********************************************************************/
/***********************  external definitions  ***********************/
/**********************************************************************/

char	*index();
char	*malloc();
char	*mktemp();
char	*rindex();
char	*sprintf();
char	*strcpy();

/*-->NoSignExtend*/
/**********************************************************************/
/***************************  NoSignExtend  ***************************/
/**********************************************************************/

int
NoSignExtend(fp, n)	/* return n byte quantity from file fd */
register FILE *fp;	/* file pointer    */
register int n;		/* number of bytes */
{
	register int x;	/* number being constructed */

	x = 0;
	while (n--)  {
		x <<= 8;
		x |= getc(fp);
	}
	return(x);
}

/*-->SignExtend*/
/**********************************************************************/
/****************************  SignExtend  ****************************/
/**********************************************************************/

int
SignExtend(fp, n)   /* return n byte quantity from file fd */
register FILE *fp;  /* file pointer    */
register int n;     /* number of bytes */
{
	int	n1;	/* number of bytes	    */
	register int x; /* number being constructed */

	x = getc(fp);   /* get first (high-order) byte */
	n1 = n--;
	while (n--)  {
		x <<= 8;
		x |= getc(fp);
	}

/* NOTE: This code assumes that the right-shift is an arithmetic, rather
than logical, shift which will propagate the sign bit right.   According
to Kernighan and Ritchie, this is compiler dependent! */
 
	x <<= 32 - 8 * n1;
	x >>= 32 - 8 * n1;	/* sign extend */


#ifdef DEBUG
	if (Debug) {
		fprintf(stderr,"\tSignExtend(fp,%d)=%X\n",n1,x);
	}
#endif
	return(x);
}


/**********************************************************************/
/*******************************  main  *******************************/
/**********************************************************************/

main(argc, argv)
int	argc;
char	*argv[];
{

	int	tfd, rr, last_page;
	char	buf[4096],names[40];
	char	*author_name, *host_name;

	strcpy(G_progname, *argv);
	FNTpath = FONTAREA;       /* default font area */

	while (*++argv) {
		if ((*argv)[0] == '-') {
			switch ((*argv)[1]) {
			case 'a':       /* a selects different FNT font area */
			        FNTpath = *++argv;
				break;
			case 'n':
				author_name = *++argv;
				break;
			case 'h':
				host_name = *++argv;
				break;
			case 'x':
				paper_width = atoi(*argv + 2);
				break;
			case 'y':
				paper_height = atoi(*argv + 2);
				break;
			}
		}
	}

	strcpy(names,"/tmp/dviXXXXXX");
	filename = mktemp(names);

	tfd = open(filename, O_WRONLY | O_CREAT, 0644);
	while((rr = read(0, buf, 4096)) > 0) {
		write(tfd, buf, rr);
	}
	close(tfd);

	if ((dvifp=BINARYOPEN(filename,"r")) == NULL)  {
		fprintf(stderr,"\n");
		fprintf(stderr,"%s: can't open \"%s\"\n\n", G_progname, filename);
		AbortRun(1);
	}

	InitLBP();
	ReadPreamble();
	last_page = ftell(dvifp);	
	ReadPostAmble();

	xscreen = (paper_width - PixRound(page_width)) / 2;
	if (xscreen < 0) xscreen = 0;
	yscreen = (paper_height - PixRound(page_height)) / 2;
	if (yscreen < 0) yscreen = 0;

	/* Default Mergin   0.6 inch 0.3 inch */

	xscreen += 200;
	yscreen += 350;

	do_pages(last_page);
	AllDone();

}

void
do_pages(last_page)
int	last_page;
{
	struct stack_entry {  /* stack entry */
		int h, v, w, x, y, z;  /* what's on stack */
	};

	int	command;	    /* current command			     */
	register int i;		    /* command parameter; loop index	     */
	int	k;		    /* temporary parameter		     */
	int	sp;		    /* stack pointer			     */
	struct stack_entry *stack;  /* stack				     */
	int	val, val2;          /* temporarys to hold command information*/
	int	w;		    /* current horizontal spacing	     */
	int	x;		    /* current horizontal spacing	     */
	int	y;		    /* current vertical spacing		     */
	int	z;		    /* current vertical spacing		     */
	int	next_page;
	BOOLEAN	page_left = TRUE;

	stack = (struct stack_entry *)malloc(sizeof(struct stack_entry) * (stack_size + 1));

	fseek(dvifp, last_page, 0);

	while(page_left) {
		switch (command = NoSignExtend(dvifp, 1)) {

		case SET1:
		case SET2:
		case SET3:
		case SET4:
			val = NoSignExtend(dvifp, command-SET1+1);
			SetChar(val, command);
			break;

		case SET_RULE:
			val = NoSignExtend(dvifp, 4);
			val2 = NoSignExtend(dvifp, 4);
			SetRule(val, val2, 1);
			break;

		case PUT1:
		case PUT2:
		case PUT3:
		case PUT4:
			val = NoSignExtend(dvifp,command-PUT1+1);
			SetChar(val, command);
			break;

		case PUT_RULE:
			val = NoSignExtend(dvifp, 4);
			val2 = NoSignExtend(dvifp, 4);
			SetRule(val, val2, 0);
			break;

		case NOP:
			break;

		case BOP:
			for (i=0; i<=9; i++)
				NoSignExtend(dvifp, 4);
			next_page = NoSignExtend(dvifp, 4);

			h = v = w = x = y = z = 0;
			sp = 0;
			fontptr = NULL;
			break;

		case EOP:
			NRM(putchar('\f'));
			if (use_mem > LBP_MEM)  /* This generate ff */
			  erase_font();
			break;

		case PUSH:
			if (sp >= stack_size)
				Fatal("stack overflow");
			stack[sp].h = h;
			stack[sp].v = v;
			stack[sp].w = w;
			stack[sp].x = x;
			stack[sp].y = y;
			stack[sp].z = z;
			sp++;
			break;

		case POP:
			--sp;
			if (sp < 0)
				Fatal("stack underflow");
			h = stack[sp].h;
			v = stack[sp].v;
			w = stack[sp].w;
			x = stack[sp].x;
			y = stack[sp].y;
			z = stack[sp].z;
			break;

		case RIGHT1:
		case RIGHT2:
		case RIGHT3:
		case RIGHT4:
			val = SignExtend(dvifp,command-RIGHT1+1);
			MoveOver(val);
			break;

		case W0:
			MoveOver(w);
			break;

		case W1:
		case W2:
		case W3:
		case W4:
			w = SignExtend(dvifp,command-W1+1);
			MoveOver(w);
			break;

		case X0:
			MoveOver(x);
			break;

		case X1:
		case X2:
		case X3:
		case X4:
			x = SignExtend(dvifp,command-X1+1);
			MoveOver(x);
			break;

		case DOWN1:
		case DOWN2:
		case DOWN3:
		case DOWN4:
			val = SignExtend(dvifp,command-DOWN1+1);
			MoveDown(val);
			break;

		case Y0:
			MoveDown(y);
			break;

		case Y1:
		case Y2:
		case Y3:
		case Y4:
			y = SignExtend(dvifp,command-Y1+1);
			MoveDown(y);
			break;

		case Z0:
			MoveDown(z);
			break;

		case Z1:
		case Z2:
		case Z3:
		case Z4:
			z = SignExtend(dvifp,command-Z1+1);
			MoveDown(z);
			break;

		case FNT1:
		case FNT2:
		case FNT3:
		case FNT4:
			SetFntNum(NoSignExtend(dvifp,command-FNT1+1));
			break;

		case XXX1:
		case XXX2:
		case XXX3:
		case XXX4:
			k = NoSignExtend(dvifp,command-XXX1+1);
			/* while (k--)
				NoSignExtend(dvifp, 1); */
			{
			    char specialBuffer [2048];
			    register char *cp;
			    int sweetp = 0;

			    if (k > 2047) {
				sweetp = k - 2047;
				k = 2047;
			    }
			    
			    for (cp = specialBuffer ; k > 0; k--) {
				*cp = NoSignExtend(dvifp,1);
				cp++;
			    }
			    *(cp) = 0;

			    while(sweetp > 0) {
				NoSignExtend(dvifp,1);
			    }

			    applicationDoSpecial(specialBuffer);
			}

			break;

		case FNT_DEF1:
		case FNT_DEF2:
		case FNT_DEF3:
		case FNT_DEF4:
			SkipFontDef(NoSignExtend(dvifp, command-FNT_DEF1+1));
			break;

		case PRE:
			Fatal("PRE occurs within file");
			break;

		case POST:
			page_left = FALSE;
			break;

		case POST_POST:
			Fatal("POST_POST with no preceding POST");
			break;

		default:
			if (command >= FONT_00 && command <= FONT_63) {
			  SetFntNum(command - FONT_00);
			} else if (command>=SETC_000 && command <= SETC_127) {
				SetChar(command - SETC_000, command);
			} else
				Fatal("%d is an undefined command", command);
			break;

		}
	}
}


ReadPreamble()
{
	int	i, j;
	char	*n;

	if (NoSignExtend(dvifp, 1) != PRE) {
		fprintf(stderr,"\n");
		Fatal("%s: PRE doesn't occur first--are you sure this is a DVI file?\n\n",
			G_progname);
	}

	if ((i = SignExtend(dvifp, 1)) != DVIFORMAT) {
		fprintf(stderr,"\n");
		Fatal("%s: DVI format = %d, can only process DVI format %d files\n\n",
			G_progname, i, DVIFORMAT);
	}

	num = NoSignExtend(dvifp, 4);
	den = NoSignExtend(dvifp, 4);
	mag = NoSignExtend(dvifp, 4);
	conv = DoConv(num, den, RESOLUTION);
	j = NoSignExtend(dvifp, 1);
	n = malloc(j + 1);
	GetBytes(dvifp, n, j);
	free(n);
}

/*-->AbortRun*/
/**********************************************************************/
/***************************  AbortRun  *******************************/
/**********************************************************************/

void
AbortRun(code)
int code;
{
    unlink(filename);
    fflush(stdout);
    sleep(10);	/* for network flush */
    exit(code);
}


/*-->ActualFactor*/
/**********************************************************************/
/**************************  ActualFactor  ****************************/
/**********************************************************************/

float		/* compute the actual size factor given the approximation */
ActualFactor(unmodsize)
int unmodsize;  /* actually factor * 1000 */
{
    float realsize;	/* the actual magnification factor */

    realsize = (float)unmodsize / 1000.0;
    /* a real hack to correct for rounding in some cases--rkf */
    if(unmodsize==1095) realsize = 1.095445;	/*stephalf*/
    else if(unmodsize==1315) realsize=1.314534;	/*stepihalf*/
    else if(unmodsize==2074) realsize=2.0736;	/*stepiv*/
    else if(unmodsize==2488) realsize=2.48832;  /*stepv*/
    else if(unmodsize==2986) realsize=2.985984;	/*stepiv*/
    /* the remaining magnification steps are represented with sufficient
	   accuracy already */
    return(realsize);
}


/*-->AllDone*/
/**********************************************************************/
/****************************** AllDone  ******************************/
/**********************************************************************/

void
AllDone()
{
    ResetLBP();
    AbortRun(G_errenc);
}

/*-->DoConv*/

int DoConv(num, den, convResolution)
{
    register float doconv;

    doconv = ((float)num/(float)den) * 
#ifdef USEGLOBALMAG
/*	ActualFactor(mag) * why was this in as Actual Factor?  jls */
	((float) mag/1000.0) *
#endif
	((float)convResolution/254000.0);
    return((int) (1.0 / doconv + 0.5));
}

/*-->Fatal*/
/**********************************************************************/
/******************************  Fatal  *******************************/
/**********************************************************************/

/*VARARGS*/
void
Fatal(fmt, args)/* issue a fatal error message */
char	*fmt;	/* format */
char	*args;	/* arguments */
{
	ResetLBP();
	fprintf(stderr,"\n");
	fprintf(stderr, "%s: FATAL--", G_progname);
	_doprnt(fmt, &args, stderr);
	fprintf(stderr, "\n\n");
	AbortRun(1);
}


/*-->FindPostAmblePtr*/
/**********************************************************************/
/************************  FindPostAmblePtr  **************************/
/**********************************************************************/

void
FindPostAmblePtr(postambleptr)
long	*postambleptr;

/* this routine will move to the end of the file and find the start
    of the postamble */

{
    int     i;

    fseek (dvifp, (long) 0, 2);   /* goto end of file */
    *postambleptr = ftell (dvifp) - 4;
    fseek (dvifp, *postambleptr, 0);

    while (TRUE) {
	fseek (dvifp, --(*postambleptr), 0);
	if (((i = NoSignExtend(dvifp, 1)) != 223) &&
	    (i != DVIFORMAT))
	    Fatal ("Bad end of DVI file");
	if (i == DVIFORMAT)
	    break;
    }
    fseek (dvifp, (*postambleptr) - 4, 0);
    (*postambleptr) = NoSignExtend(dvifp, 4);
    fseek (dvifp, *postambleptr, 0);
}


/*-->GetBytes*/
/**********************************************************************/
/*****************************  GetBytes  *****************************/
/**********************************************************************/

void
GetBytes(fp, cp, n)	/* get n bytes from file fp */
register FILE *fp;	/* file pointer	 */
register char *cp;	/* character pointer */
register int n;		/* number of bytes  */

{
    while (n--)
	*cp++ = getc(fp);
}


/*-->GetFontDef*/
/**********************************************************************/
/**************************** GetFontDef  *****************************/
/**********************************************************************/

void
GetFontDef()

/***********************************************************************
   Read the font  definitions as they  are in the  postamble of the  DVI
   file.  Note that the font directory  is not yet loaded.  In order  to
   adapt ourselves to the existing "verser" the following font paramters
   are  copied	 onto  output	fontno  (4   bytes),  chksum,	fontmag,
   fontnamelength (1 byte), fontname.  At the end, a -1 is put onto  the
   file.
***********************************************************************/

{
    char    *calloc ();
    unsigned char   byte;

    while (((byte = NoSignExtend(dvifp, 1)) >= FNT_DEF1) &&
	(byte <= FNT_DEF4)) {
	switch (byte) {
	case FNT_DEF1:
	    ReadFontDef(NoSignExtend(dvifp, 1));
	    break;
	case FNT_DEF2:
	    ReadFontDef(NoSignExtend(dvifp, 2));
	    break;
	case FNT_DEF3:
	    ReadFontDef(NoSignExtend(dvifp, 3));
	    break;
	case FNT_DEF4:
	    ReadFontDef(NoSignExtend(dvifp, 4));
	    break;
	default:
	    Fatal("Bad byte value in font defs");
	    break;
	}
    }
    if (byte != POST_POST)
	Fatal("POST_POST missing after fontdefs");
}

/*-->InitLBP*/
/**********************************************************************/
/**********************************************************************/
/*****************************  InitLBP  *****************************/
/**********************************************************************/

void
InitLBP()	/* initialize terminal */

{
	/* I don't know why it works. :-) */
	int i;

	PRES(printf("page;"));NRM(1);
	PRES(printf("res;daf;str 300;unit d;"));
	PRES(printf("spd 1;spm p;ldfc 1000,103,36,34,928,0,0,0,0;"));
	for(i = 0; i<36; i++) printf("\n@@0@@0@@0");
	printf(";\nmap 644,183;font 1000;");
	NRM(printf("g\n")); 
	PRES(printf("page;"));NRM(1);  
	PRES(printf("res;daf;str 300;unit d;"));
	printf("spd 1;spm p;swm h;\n");NRM(1);
	fflush(stdout);
}

/*-->MoveDown*/
/**********************************************************************/
/****************************  MoveDown  ******************************/
/**********************************************************************/

void
MoveDown(a)
int a;
{
    v += a;
}


/*-->MoveOver*/
/**********************************************************************/
/****************************  MoveOver  ******************************/
/**********************************************************************/

void
MoveOver(b)
int b;
{
	h += b;
}

/*-->PixRound*/
/**********************************************************************/
/*****************************  PixRound  *****************************/
/**********************************************************************/

int
PixRound(x)		/* return rounded number of pixels */
register int x;		/* in DVI units     */
{
	return((int)((x + (conv >> 1)) / conv));
}

/*-->ReadFontDef*/
/**********************************************************************/
/****************************  ReadFontDef  ***************************/
/**********************************************************************/

int
ReadFontDef(k)
int k;
{
	int	t, i, fdir, lastchar;
	register struct font_entry *tfontptr;	/* temporary font_entry pointer  */
	register struct char_entry *tcharptr;	/* temporary char_entry pointer  */

	if (CheckFontNum(k)) return;

	if ((tfontptr = NEW(struct font_entry)) == NULL)
		Fatal("can't malloc space for font_entry");
	tfontptr->next = hfontptr;
	fontptr = hfontptr = tfontptr;

	tfontptr->gfxSetNumber = 0;
	tfontptr->k = k;
	tfontptr->c = NoSignExtend(dvifp, 4); /* checksum */
	tfontptr->s = NoSignExtend(dvifp, 4); /* space size */
	tfontptr->d = NoSignExtend(dvifp, 4); /* design size */
	tfontptr->a = NoSignExtend(dvifp, 1); /* area length for font name */
	tfontptr->l = NoSignExtend(dvifp, 1); /* device length */
	GetBytes(dvifp, tfontptr->n, tfontptr->a+tfontptr->l);
	tfontptr->n[tfontptr->a+tfontptr->l] = '\0';
	tfontptr->font_space = tfontptr->s/6; /* never used */
	tfontptr->font_mag = (int)((ActualFactor((int)(((float)tfontptr->s/
		(float)tfontptr->d)*1000.0 + 0.5)) * 
#ifdef USEGLOBALMAG
		ActualFactor(mag) *
#endif
		(float)RESOLUTION * 5.0) + 0.5);

	/* check font name is internal font or not ( knji specific ) */
	/* I want to support gotic here */

	if (fix(tfontptr->font_mag) == 1500 &&
	    ((t=2,!strncmp(tfontptr->n,"jisj",4) 
	     &&(i=subfont_num(tfontptr->n+4,'j'))>0) ||
	     ((t=2,!strncmp(tfontptr->n,"dmj",3) ||
	     (t=3,!strncmp(tfontptr->n,"dgj",3)))
	     &&(i=subfont_num(tfontptr->n+3,'d'))>0))) { 
	  tfontptr->gfxSetNumber = i;
	  tfontptr->isDownLoad = t;
	  tfontptr->magnification = 1500;
	  tfontptr->designsize = 10485760;
	  for (i = FIRSTPXLCHAR; i <= LASTPXLCHAR; i++) {        
	    tcharptr = &(tfontptr->ch[i]);
	    tcharptr->width = 36;
	    tcharptr->height = 36;
	    tcharptr->xOffset= 0;
	    tcharptr->yOffset = 29;
	    tcharptr->where.address.fileOffset = NULL;
	    tcharptr->tfmw = 599929;
	  }
	  return;
	} 
    if(SearchFontFile(tfontptr, FNTpath))
	readpsfontinfo(tfontptr);
}

erase_font()
{
  int i;
  struct font_entry *tfontptr;
  struct char_entry *tcharptr;

  PRES(printf("daf;"));
  for(tfontptr = fontptr; tfontptr; tfontptr = tfontptr->next)
    if(tfontptr->isDownLoad != 2||tfontptr->isDownLoad != 3)
      for (i = FIRSTPXLCHAR; i <= LASTPXLCHAR; i++)
	tfontptr->ch[i].loaded = FALSE;
  use_mem = LBP_MEM_Base;
}

/*-->ReadPostAmble*/
/**********************************************************************/
/**************************  ReadPostAmble  ***************************/
/**********************************************************************/

/***********************************************************************
    This  routine  is  used  to  read  in  the  postamble  values.    It
    initializes the magnification and checks  the stack height prior  to
    starting printing the document.
***********************************************************************/

int
ReadPostAmble()
{
	long	postambleptr;	/* Pointer to the postamble */
	int	lastpageptr;
	int	total_pages;
	int	postnum, postden, postmag;

	FindPostAmblePtr(&postambleptr);

	if (NoSignExtend(dvifp, 1) != POST)
		Fatal ("POST missing at head of postamble");
#ifdef DEBUG
	if (Debug) fprintf (stderr, "got POST command\n");
#endif
	lastpageptr = NoSignExtend(dvifp, 4);

	postnum = NoSignExtend(dvifp, 4);
	if (num != postnum)
		Fatal ("num incompatible in postamble");
	postden = NoSignExtend(dvifp, 4);
	if (den != postden)
		Fatal ("den incompatible in postamble");
	postmag = NoSignExtend(dvifp, 4);
	if (mag != postmag)
		Fatal ("mag incompatible in postamble");

	page_height = NoSignExtend(dvifp, 4);	/* height-plus-depth of tallest page */
	page_width = NoSignExtend(dvifp, 4);	/* width of widest page */

	stack_size = NoSignExtend(dvifp, 2);

	total_pages = NoSignExtend(dvifp, 2);	/* this reads the number of pages in */
						/* the DVI file */
#ifdef DEBUG
	if (Debug) fprintf (stderr, "now reading font defs");
#endif
	GetFontDef();

	return(lastpageptr);
}


/*-->ResetLBP*/
/**********************************************************************/
/****************************  ResetLBP  *****************************/
/**********************************************************************/

void
ResetLBP()   /* Reset LBP */
{
	PRES(printf("res;exit,e;"));
	in_prescribe = 0;
}

/*-->SetChar*/
/**********************************************************************/
/*****************************  SetChar  ******************************/
/**********************************************************************/

static int min_got = 0;	

void
SetChar(c, command)
int c, command;
{
	register struct char_entry *ptr;  /* temporary char_entry pointer */
	int	t,k,tmp,pos;

	ptr = &(fontptr->ch[c]);
	hh = PixRound(h);
	vv = PixRound(v);
	if (fontptr->isDownLoad==2 || fontptr->isDownLoad==3) {
	  if (fontptr->isDownLoad!=min_got) {
		min_got=fontptr->isDownLoad;
		PRES(fputs("kfnt ",stdout);outint(min_got-1));
		putchar(';');
	    }
	  ku_ten_compute(fontptr->gfxSetNumber,c,&k,&t);
	  PRES(fputs("map ",stdout));
	  outint(hh - ptr->xOffset + xscreen); putchar(',');
	  outint(vv + yscreen);
	  fputs(";exit,e;\n\033K",stdout);
	  putchar(k);putchar(t);putchar('\033');putchar('H');
	  in_prescribe = 0;
	  current_gfx = -1;
	} else if (ptr->loaded) {
	  if (DOWNLOADFIRST<=c && c<=DOWNLOADLAST) {
	    tmp = fontptr->gfxSetNumber;
	    if (tmp!=current_gfx) {
	      PRES(fputs("font ",stdout);outint(tmp);putchar(';'));
	      current_gfx = tmp;
	    }
	    PRES(fputs("map ",stdout);outint(hh + xscreen));
	    putchar(',');
	    outint(vv + yscreen);fputs(";exit,e;\n",stdout);
	    putchar((char)c);
	    in_prescribe = 0;
	  } else {
	    if (c<DOWNLOADFIRST)
	      pos = 1;
	    else if (c>DOWNLOADLAST) 
	      pos = c>>6;
	    tmp = fontptr->gfxSetNumber+pos;
	    c = (c | 0x40) & 0x7f;
	    c = (c==0x7f?48:c);
	    if (tmp!=current_gfx) {
	      PRES(printf("font %d;",tmp));
	      current_gfx = tmp;
	    }
	    PRES(fputs("map ",stdout));
	    outint(hh + xscreen);putchar(',');
	    outint(vv + yscreen);putchar(';');
	    NRM(putchar((char)c));
	  }
	} else {
	  c = DownLoad(fontptr,c,&tmp);
	  if (tmp != -1) {
	      PRES(printf("map %d,",hh + xscreen));
	      printf("%d;",vv + yscreen);
	      if (tmp!=current_gfx) {
		PRES(printf("font %d;",tmp));
		current_gfx = tmp;
	      }
	      NRM(putchar((char)c));
	    } else {
		return;  /* error: do nothing */
	    }
	    /* not used now  else {
	      PRES(printf("map %d,",- ptr->xOffset + hh + xscreen));
	      printf("%d;rvrd;\n",vv - ptr->yOffset + yscreen);
	      PutCharPattern(ptr);
	      printf("\nendr;"); 
	    } */
	}
	if (command <= SET4) h += ptr->tfmw;
}

/*
char	hex_char[] = "0123456789abcdef";
#define	TOHEX(X)	printf("%c", hex_char[(X) & 0xf])

void
PutCharPattern(ptr)
register struct char_entry *ptr;
{
	register int col, row;
	int nints, nchars, inchars, diffs;
	register unsigned char *pr;

	pr = (unsigned char *)ptr->where.address.pixptr;
	if (pr == NULL)
	  return;
	nints = (ptr->width + 31) / 32;
	nchars = nints * 4;
	inchars = (ptr->width + 7) / 8;
	diffs = nchars - inchars;
        for (col = 0; col < ptr->height; col++) {
	  outint(inchars);
	  for (row = 0; row < inchars; row++) {
	    putchar(',');
	    outint(*pr++);
	  }
	  pr += diffs;
        }
        printf(";\n");
	fflush(stdout);
}
*/

BOOLEAN
CheckFontNum(k)
int	k;
{
	register struct	font_entry	*tfontptr;

	tfontptr = hfontptr;
	while(tfontptr != NULL) {
		if (tfontptr->k == k)
			return(TRUE);
		tfontptr = tfontptr->next;
	}
	return(FALSE);
}


/*-->SetFntNum*/
/**********************************************************************/
/****************************  SetFntNum  *****************************/
/**********************************************************************/

/*
 *  this routine is used to specify the font to be used in printing future
 *  characters
 */

void
SetFntNum(k)
int k;
{
	fontptr = hfontptr;
	while ((fontptr!=NULL) && (fontptr->k!=k))
		fontptr = fontptr->next;
	if (fontptr == NULL)
		Fatal("font %d undefined", k);
}


/*-->SetRule*/
/**********************************************************************/
/*****************************  SetRule  ******************************/
/**********************************************************************/

/*	 this routine will draw a rule on the screen */

void
SetRule(a, b, Set)
int	a, b;
BOOLEAN	Set;
{
	int	ehh, evv, aa, bb;

	hh = PixRound(h);
	vv = PixRound(v);
	ehh = PixRound(h + b);
	evv = PixRound(v - a);
	if (hh == ehh) ehh++;
	if (vv == evv) evv--;
	aa = vv - evv;
	bb = ehh - hh;
	if ((a > 0) && (b > 0)) {
	  if (a > b) {
	    PRES((printf("spd %d;map %d,%d;dap %d,%d;\n",
			bb,
			hh + xscreen,vv  + yscreen,
			hh + xscreen,evv + yscreen)));
	  } else {
	    PRES((printf("spd %d;map %d,%d;dap %d,%d;\n",
			aa,
			hh  + xscreen,vv + yscreen,
			ehh + xscreen,vv + yscreen)));
	  }
	}
	if (Set) h += b;
}

/*-->SkipFontDef*/
/**********************************************************************/
/****************************  SkipFontDef  ***************************/
/**********************************************************************/

void
SkipFontDef(k)
int k;
{
    int a, l;
    char n[STRSIZE];

    NoSignExtend(dvifp, 4);
    NoSignExtend(dvifp, 4);
    NoSignExtend(dvifp, 4);
    a = NoSignExtend(dvifp, 1);
    l = NoSignExtend(dvifp, 1);
    GetBytes(dvifp, n, a+l);
}


/*-->Warning*/
/**********************************************************************/
/*****************************  Warning  ******************************/
/**********************************************************************/

/* VARARGS */
void
Warning(fmt, args)  /* issue a warning */
char *fmt;	/* format   */
char *args;	/* arguments */
{
    G_errenc = TRUE;
}

DownLoad(tfontptr,code,gfx)
struct	font_entry	*tfontptr;
int code, *gfx;
{
	int	MaxHeight, MaxDepth, MaxWidth;
	register int 	i, j, k;
	register struct	char_entry *tcharptr;
	register char	*pr, *pt;
	int	nbytes, cells;
	int	fonts, rest, pos, tmp;

	tcharptr = &(tfontptr->ch[code]);
	if (tcharptr->where.address.fileOffset == 0)
	  return code;
	tfontptr->isDownLoad = TRUE;
	if(tfontptr->gfxSetNumber == 0) {
	  use_mem += LBP_MEM_Font;
	  tfontptr->gfxSetNumber = gfxSet;
	  gfxSet += 4;
	}
	tcharptr->loaded = TRUE;
	nbytes = tcharptr->nbpl;
	
	if (tcharptr->where.address.pixptr==NULL) 
	  if (tfontptr->font_type == FT_PK) 
	    loadpkchar(tfontptr,code);
	  else if(tfontptr->font_type == FT_PXL)
	    loadpxlchar(tfontptr,code);
	  else {
	    *gfx = -1;  /* Error? */
	    return code;
	  }
	pr = tcharptr->where.address.pixptr;

	if (DOWNLOADFIRST<=code && code<=DOWNLOADLAST) 
		tmp = tfontptr->gfxSetNumber;
	    else {
		if (code<DOWNLOADFIRST)
		    pos = 1;
		else if (code>DOWNLOADLAST) 
		    pos = code>>6;
		tmp = tfontptr->gfxSetNumber+pos;
		code = (code | 0x40) & 0x7f;
		code = (code==0x7f?48:code);
	    }
	  *gfx = tmp;
	  PRES(printf("ldfc %d,%d,%d,%d,%d,%d,%d,%d,%d;",
		      tmp,code,
		      tcharptr->height,tcharptr->width,
		      tcharptr->yOffset*32,
		      (tcharptr->xOffset+KCL_Alpha_shift)*32,
		      tcharptr->width*32,
		      0,0));
	  use_mem += nbytes*tcharptr->height+LBP_MEM_Char;
	  for(j = 0; j < tcharptr->height; j++) {
	    if (j%16==0||nbytes>2) putchar('\n');
	    for(k = 1; k < nbytes; k += 2) {   /* if odd width rest one byte */
	      tmp = ( *pr >> 2 )&0x3f;
	      tmp = (tmp==127-64)?47:tmp+64;
	      putchar(tmp);

	      tmp = ((*pr << 4)&0x30) + ((pr[1] >> 4)&0xf);
	      pr++;
	      tmp = (tmp==127-64)?47:tmp+64;
	      putchar(tmp);

	      tmp = (*pr++ &0xf) + 48;
	      putchar(tmp);
	    }
	    if (nbytes%2!=0) {
	      tmp = ( *pr >> 2 )&0x3f;
	      tmp = (tmp==127-64)?47:tmp+64;
	      putchar(tmp);

	      tmp = (*pr++ << 4)&0x30;
	      tmp = (tmp==127-64)?47:tmp+64;
	      putchar(tmp);putchar(48);
	    }
	  }
	  putchar(';');
	  putchar('\n');
	  fflush(stdout);
	  return code;
}

/* ku-ten code to code and font number ( form NttJTeX) */

compute_f_c(ku,ten)
int ku,ten;
{
  int f,c,n;
  
  if ((ku<=0)||((ku>=9)&&(ku<=15))||(ku>84))
    /* @<Report invalid ku in JIS code and |goto exit|@>; */
    return 256+1;
  if ((ten<1)||(ten>94))
    /* then @<Report invalid ten in JIS code and |goto exit|@>; */
    return 256+1;
  if (ku<=8) {
    switch(ku) {
    case 1: f=1; c=ten; break;
    case 2: f=1; c=ten+100; break;
    case 3: f=2; c=ten+32; break;
    default:f=ku-1; c=ten;
    }
  } else if (ku<=47) { /* then {Daiichi Suijun} */
    n=(ku-16)*94+ten-1; f=(n / 256)+8; c=n-(f-8)*256;
  } else { /* {Daini Suijun} */
    n=(ku-48)*94+ten-1; f=(n / 256)+20; c=n-(f-20)*256;
  }
  return 256*f+c;
}

/* @<Utility functions and procedures for Japanese@>= */
ku_ten_compute(f,c,k,t)
int f,c,*k,*t;
{
  int ku, ten, n;
  if (f<=7) 
    switch(f) {
    case 1: 
      if (c>=100) {
	ku=2; ten=c-100;
      }else {
	ku=1; ten=c;
      }
      break;
    case 2: 
      ku=3; ten=c-32;
      break;
    default: 
      ku=f+1; ten=c;
    }
  else if (f<=19) { /* then {Daiichi Suijun} */
    n=(f-8)*256+c; ku=(n / 94)+16; ten=(n % 94)+1;
  }else { /* {Daini Suijun} */
    n=(f-20)*256+c; ku=(n / 94)+48; ten=(n % 94)+1;
  }
  *k = ku+32;
  *t = ten+32;
}

struct sub_name {
  char *name;
  int  no;
} kanji_font_name[] = {
      {"sy",1},
      {"roma",2},
      {"hira",3},
      {"kata",4},
      {"greek",5},
      {"russian",6},
      {"keisen",7},
      {"ka",8},
      {"kb",9},
      {"kc",10},
      {"kd",11},
      {"ke",12},
      {"kf",13},
      {"kg",14},
      {"kh",15},
      {"ki",16},
      {"kj",17},
      {"kk",18},
      {"kl",19},
      {"km",20},
      {"kn",21},
      {"ko",22},
      {"kp",23},
      {"kq",24},
      {"kr",25},
      {"ks",26},
      {"kt",27},
      {"ku",28},
      {"kv",29},
      {"kw",30},
      {"kx",31},
      {"ky",32},
      {"kz",33}
};

int
subfont_num(name,c)
char *name;
int  c;
{
  int i;
  char *n,*m;
  struct sub_name *font;

  font = kanji_font_name;
  for(i=0;i<(sizeof(kanji_font_name)/sizeof(kanji_font_name[0]));i++) {
    n = font-> name;
    m = name;
    while(*n++ == *m++)
      if(*n=='\0') 
	if((m[0]=='3'&&m[1]=='6'&&m[2]=='\0'&&c=='j')||
	   (m[0]=='1'&&m[1]=='0'&&m[2]=='\0'&&c=='d'))
	  return font->no;
	else
	  break;
    font++;
  }
  return -1;
}
                              
/***********************************************************
     Fast Output Integer
************************************************************/
struct hex {
  char h,l;
} hexArray[] = {

  {'0','0'}, {'0','1'}, {'0','2'}, {'0','3'},
  {'0','4'}, {'0','5'}, {'0','6'}, {'0','7'},
  {'0','8'}, {'0','9'}, {'0','a'}, {'0','b'},
  {'0','c'}, {'0','d'}, {'0','e'}, {'0','f'},

  {'1','0'}, {'1','1'}, {'1','2'}, {'1','3'},
  {'1','4'}, {'1','5'}, {'1','6'}, {'1','7'},
  {'1','8'}, {'1','9'}, {'1','a'}, {'1','b'},
  {'1','c'}, {'1','d'}, {'1','e'}, {'1','f'},

  {'2','0'}, {'2','1'}, {'2','2'}, {'2','3'},
  {'2','4'}, {'2','5'}, {'2','6'}, {'2','7'},
  {'2','8'}, {'2','9'}, {'2','a'}, {'2','b'},
  {'2','c'}, {'2','d'}, {'2','e'}, {'2','f'},

  {'3','0'}, {'3','1'}, {'3','2'}, {'3','3'},
  {'3','4'}, {'3','5'}, {'3','6'}, {'3','7'},
  {'3','8'}, {'3','9'}, {'3','a'}, {'3','b'},
  {'3','c'}, {'3','d'}, {'3','e'}, {'3','f'},

  {'4','0'}, {'4','1'}, {'4','2'}, {'4','3'},
  {'4','4'}, {'4','5'}, {'4','6'}, {'4','7'},
  {'4','8'}, {'4','9'}, {'4','a'}, {'4','b'},
  {'4','c'}, {'4','d'}, {'4','e'}, {'4','f'},

  {'5','0'}, {'5','1'}, {'5','2'}, {'5','3'},
  {'5','4'}, {'5','5'}, {'5','6'}, {'5','7'},
  {'5','8'}, {'5','9'}, {'5','a'}, {'5','b'},
  {'5','c'}, {'5','d'}, {'5','e'}, {'5','f'},

  {'6','0'}, {'6','1'}, {'6','2'}, {'6','3'},
  {'6','4'}, {'6','5'}, {'6','6'}, {'6','7'},
  {'6','8'}, {'6','9'}, {'6','a'}, {'6','b'},
  {'6','c'}, {'6','d'}, {'6','e'}, {'6','f'},

  {'7','0'}, {'7','1'}, {'7','2'}, {'7','3'},
  {'7','4'}, {'7','5'}, {'7','6'}, {'7','7'},
  {'7','8'}, {'7','9'}, {'7','a'}, {'7','b'},
  {'7','c'}, {'7','d'}, {'7','e'}, {'7','f'},

  {'8','0'}, {'8','1'}, {'8','2'}, {'8','3'},
  {'8','4'}, {'8','5'}, {'8','6'}, {'8','7'},
  {'8','8'}, {'8','9'}, {'8','a'}, {'8','b'},
  {'8','c'}, {'8','d'}, {'8','e'}, {'8','f'},

  {'9','0'}, {'9','1'}, {'9','2'}, {'9','3'},
  {'9','4'}, {'9','5'}, {'9','6'}, {'9','7'},
  {'9','8'}, {'9','9'}, {'9','a'}, {'9','b'},
  {'9','c'}, {'9','d'}, {'9','e'}, {'9','f'},

  {'a','0'}, {'a','1'}, {'a','2'}, {'a','3'},
  {'a','4'}, {'a','5'}, {'a','6'}, {'a','7'},
  {'a','8'}, {'a','9'}, {'a','a'}, {'a','b'},
  {'a','c'}, {'a','d'}, {'a','e'}, {'a','f'},

  {'b','0'}, {'b','1'}, {'b','2'}, {'b','3'},
  {'b','4'}, {'b','5'}, {'b','6'}, {'b','7'},
  {'b','8'}, {'b','9'}, {'b','a'}, {'b','b'},
  {'b','c'}, {'b','d'}, {'b','e'}, {'b','f'},

  {'c','0'}, {'c','1'}, {'c','2'}, {'c','3'},
  {'c','4'}, {'c','5'}, {'c','6'}, {'c','7'},
  {'c','8'}, {'c','9'}, {'c','a'}, {'c','b'},
  {'c','c'}, {'c','d'}, {'c','e'}, {'c','f'},

  {'d','0'}, {'d','1'}, {'d','2'}, {'d','3'},
  {'d','4'}, {'d','5'}, {'d','6'}, {'d','7'},
  {'d','8'}, {'d','9'}, {'d','a'}, {'d','b'},
  {'d','c'}, {'d','d'}, {'d','e'}, {'d','f'},

  {'e','0'}, {'e','1'}, {'e','2'}, {'e','3'},
  {'e','4'}, {'e','5'}, {'e','6'}, {'e','7'},
  {'e','8'}, {'e','9'}, {'e','a'}, {'e','b'},
  {'e','c'}, {'e','d'}, {'e','e'}, {'e','f'},

  {'f','0'}, {'f','1'}, {'f','2'}, {'f','3'},
  {'f','4'}, {'f','5'}, {'f','6'}, {'f','7'},
  {'f','8'}, {'f','9'}, {'f','a'}, {'f','b'},
  {'f','c'}, {'f','d'}, {'f','e'}, {'f','f'}
} ; 
    
TOHEX2(k)
unsigned char k;
{   register int j; 
    
    j = hexArray[k].h;  
    putchar(j); 
    j = hexArray[k].l;  
    putchar(j); 
}

outint(i)
     register int i;
{
  register unsigned int c,M,*mag;
  int sup;
  static unsigned int decimal[] = {
     1000000000, 100000000, 10000000, 1000000, 100000,
          10000, 1000, 100, 10, 1        } ;

#define printMag(Mag)	{ \
     while (i >= Mag) { c++; i -= Mag; } \
     if ( c != 0 || sup) { \
	   c += '0'; \
	   putchar( c ); sup++; c = 0; } \
     }

     sup = c  = 0;
     if ( i < 0 ) {
	 putchar('-');
	 i = -i;
     }
     if ( i < 10000 ) {
     lessThan10000:
       printMag(1000)
       printMag(100)
       printMag(10)
       i += '0';
       putchar(i);
       return;
     } else {
       for( mag = decimal ; (M = *mag++) > 1000 ; )
	 printMag(M)
       goto lessThan10000;
     }
}


