/*
 * Kanji filter 29-Nov.-1986 by T.Wada at Dept.of Information
 * Engeneering of T.I.T 
 */

/************************ kanji-in sequence *******************************
  
                                       ROOT
                                        |
                        |-------------------------------|
                       ESC                              |
                        |                               |
                |---------------|               |---------------|
               '$'             'K'             SB               SH
                |               |               |               |
           |---------|          |          |---------|          |
          '@'        |          |         'p'     FAILURE       |
           |         |          |          |                    |
           |    |---------|     |          |                    |
           |   'B'        |     |          |                    |
           |    |         |     |          |                    |
           |    |         |     |          |                    |
-------------------------------------------------------------------------------
     jis(1978)          ??????             basic'I'
            jis(1983)        basic'P'                       tsscc(oldversion)
******************************************************************************/
/************************ kanji-out sequence *******************************
  
                                       ROOT
                                        |
                        +-------------------------------+
                       ESC                              |
                        |                               |
                +---------------+               +---------------+
               '('              |              SB               SH
                |               |               |               |
           +---------+        +--------+   +---------+          |
          'B'        |       '+'      'H' 'q'     FAILURE       |
           |         |        |        |   |                    |
           |    +---------+   |        |   |                    |
           |   'J'        |   |        |   |                    |
           |    |     +-----+ |        |   |                    |
           |    |    'A'   'H'|        |   |                    |
           |    |     |     | |        |   |                    |
-------------------------------------------------------------------------------
         Ascii       UK       ?????       basic'I'
           JIS roman     Sweden     basic'P'                tsscc(oldversion)
*****************************************************************************/
#include <stdio.h>
#define SB  0x1a
#define SH  0x01
#define ESC 0x1b
#define CNT   0			/* dummy node                   */
#define SUC  -2			/* find kanji in(or out)        */
#define FAI  -3			/* cant found kanji in(or out)  */
#define ROOT -4
#define ASCII 0
#define JIS   1
#define SHIFT 2

struct tnode {
	struct tnode   *left;
	struct tnode   *right;
	int             val;
};

/************************* grobal var.*********************************/

struct tnode    success = {&success, &success, SUC}, failure = {&failure, &failure, FAI};
struct tnode    ki[] = {
			 /* 0 */ {&ki[1], &ki[7], ROOT},
			 /* 1 */ {&ki[2], &ki[6], ESC},
			 /* 2 */ {&ki[3], &ki[4], '$'},
			 /* 3 */ {&success, &success, '@'},
			 /* 4 */ {&ki[5], &success, CNT},
			 /* 5 */ {&success, &success, 'B'},
			 /* 6 */ {&success, &success, 'K'},
			 /* 7 */ {&ki[8], &ki[10], CNT},
			 /* 8 */ {&ki[9], &failure, SB},
			 /* 9 */ {&success, &success, 'p'},
			 /* 10 */ {&success, &success, SH}
};
struct tnode    kiodd = {&ki[1], &ki[7], '^'};

struct tnode    ko[] = {
			 /* 0 */ {&ko[1], &ko[12], ROOT},
			 /* 1 */ {&ko[2], &ko[9], ESC},
			 /* 2 */ {&ko[3], &ko[4], '('},
			 /* 3 */ {&success, &success, 'B'},
			 /* 4 */ {&ko[5], &ko[6], CNT},
			 /* 5 */ {&success, &success, 'J'},
			 /* 6 */ {&ko[7], &ko[8], CNT},
			 /* 7 */ {&success, &success, 'A'},
			 /* 8 */ {&success, &success, 'H'},
			 /* 9 */ {&ko[10], &ko[11], CNT},
			 /* 10*/ {&success, &success, '+'},
			 /* 11*/ {&success, &success, 'H'},
			 /* 12*/ {&ko[13], &ko[15], CNT},
			 /* 13*/ {&ko[14], &failure, SB},
			 /* 14 */ {&success, &success, 'q'},
			 /* 15 */ {&success, &success, SH}
};
struct tnode    koodd = {&ko[1], &ko[10], '^'};

int             k_mode = ASCII,out_mode = ASCII, odd = 0, count = 0,
		ins_ctr_count = 0, o_is_jis = 1;

unsigned char   buf[20];
char ins_ctr[400], *termko, *termki;

FILE *fk;
/***********************************************************************/

main(argc, argv)
	int             argc;
	char           *argv[];
{
	FILE *fopen();
	int f_count = 0,i;

	set_sw(argv[0][0]);
	for (i=1; i< argc; i++)
		if (argv[i][0] == '-') {
					int_arg(&argv[i][1]);
					if (argv[i][2] == '!') oddversion();
		} else f_count++;

	if (f_count == 0) {
		fk = stdin;
		kanji_copy();
	} else  for (i=1 ; i<argc ;i++ )
			if (argv[i][0] != '-')
				if ((fk = fopen(argv[i],"r"))!= NULL) kanji_copy();
				else fprintf(stderr,"Can't open %s\n",argv[i]);

		if (out_mode && o_is_jis) scr_put(termko);
}

kanji_copy()
{
	int ret_cond = 0;
	while (ret_cond != EOF)
		switch (k_mode) {
		case JIS:
			while ((ret_cond = walktree(ko)) == FAI)
				wipeout_j();
			break;
		case SHIFT:
			while ((ret_cond = walktree(ki)) == FAI)
				wipeout_s();
			break;
		case ASCII:
			while ((ret_cond = walktree(ki)) == FAI)
				wipeout_a();
		}
}

mode_tr(to)
	int             to;
{
	switch (to) {
	case ASCII:		/* kanji ---> ASCII */
		if (o_is_jis && out_mode) scr_put(termko);
		if (k_mode == SHIFT)
			wipeout_a();
		k_mode = out_mode = ASCII;
		break;
	case JIS:		/* ASCII , SHIFT JIS ----> JIS 2 */
		if (out_mode == ASCII) {
			if (ins_ctr_count)
				wipeout_c();
			if (o_is_jis) scr_put(termki);
		}
		odd = 0;
		k_mode = out_mode = JIS;
		break;
	case SHIFT:		/* ASCII, JIS 2 ----> SHIFT JIS */
		if (out_mode == ASCII) {
			if (ins_ctr_count)
				wipeout_c();
			if (o_is_jis) scr_put(termki);
		}
		odd = 0;
		k_mode = out_mode = SHIFT;
		wipeout_s();
	}
}

scr_put(p)
	char  *p;
{
	while (*p != NULL) putchar(*p++);
}

wipeout()
{
	switch (k_mode) {
	case ASCII:
		wipeout_a();
		break;
	case JIS:
		wipeout_j();
		break;
	case SHIFT:
		wipeout_s();
	}
}

wipeout_a()
{
	ins_ctr[ins_ctr_count] = buf[count] = NULL;
	ins_ctr_count = 0;
	scr_put(ins_ctr);
	scr_put((char *)buf);
}


wipeout_j()
{
	static char kanji_buf[2];
	int             i;

	for (i = 0; i < count; i++) {
		if (buf[i] < 0x21)
			ins_ctr[ins_ctr_count++] = buf[i];
		else {
			kanji_buf[odd] = buf[i];
			odd = (odd + 1) % 2;
			if (odd == 0){
				if (out_mode == ASCII) {
					out_mode = JIS;
					scr_put(termki);
				}
				put2k(kanji_buf);
			}
		}
	}

	if (ins_ctr_count)
		wipeout_c();
}

wipeout_s()
{
	static char kanji_buf[2];
	int             i;

	if (ins_ctr_count)
		wipeout_c();

	for (i = 0; i < count; i++) {
		kanji_buf[odd] = buf[i];
		odd = (odd + 1) % 2;
		if (odd == 0){
			if (out_mode == ASCII) {
					out_mode = SHIFT;
					scr_put(termki);
			}
			put2k(kanji_buf);
		}
	}
}

wipeout_c()
{
	ins_ctr[ins_ctr_count] = NULL;
	ins_ctr_count = 0;
	if (out_mode && o_is_jis) {
		out_mode = ASCII;
		scr_put(termko);
		scr_put(ins_ctr);
	} else
		scr_put(ins_ctr);
}

put2k(str)
	char  *str;
{
	if (o_is_jis){
		putchar(*str++);
		putchar(*str);
	}
	else jis_to_shift(str);
}

walktree(node, ch)
	struct tnode   *node;
	int             ch;
{
	int             v, a, b, active,rv;

	switch (v = (node->val)) {
	case SUC:
		--count;
		ungetc(ch,fk);
		switch (k_mode) {
		case ASCII:
			mode_tr(JIS);
			break;
		case JIS:
			mode_tr(ASCII);
			break;
		case SHIFT:
			mode_tr(JIS);
			break;
		}

		return SUC;
	case FAI:
		return FAI;
	case CNT:
		if(((rv=walktree(node->left, ch))==SUC)||(rv==EOF)) return rv;
		return walktree(node->right, ch);
	case ROOT:
		count = 0;
		if ((a = read1c())==EOF) return EOF;
		/***************** search designate code **************/
		if(((rv=walktree(node->left, a))==SUC)||(rv==EOF)) return rv;
		if(((rv=walktree(node->right, a))==SUC)||(rv==EOF)) return rv;
		/************* there is no designate code *************/
		a = buf[count - 1];
		if (count > 1) {
			ungetc((char)buf[--count],fk);
			if (k_mode != SHIFT) return FAI;
		}
		if (a < 0x80 || 0xa0 <= a && a < 0xe0) {

			/* not a SHIFT code */

			if (k_mode == SHIFT) {

				/* SHIFT --> ASCII */

				mode_tr(ASCII);
				return SUC;
			}
			return FAI;
		} else {

			/* SHIFT JIS */

			while ((b = read1c()) < 0x21)
				if (b == EOF) return EOF;
				else ins_ctr[ins_ctr_count++] = buf[--count];

			/* code transform */
			shift_to_jis(a,b);
			if (k_mode == SHIFT)

			/* SHIFT JIS ---> SHIFT JIS */

				return FAI;
			mode_tr(SHIFT);

			/* ?????    ----> SHIFT JIS */

			return SUC;
		}
	default:
retry:
		if ((active = buf[count - 1]) == v) {
			if ((a = read1c()) == EOF) return EOF;
			if(((rv=walktree(node->left, a))==SUC)||(rv==EOF))
					return rv;
			return walktree(node->right, a);
		} else if ((active < 0x21)&&(count>1)) {
			ins_ctr[ins_ctr_count++] = buf[--count];
			if (read1c() == EOF) return EOF;
			goto retry;
		} else
			return FAI;

	}
}

read1c()
{
	int             a;
	if ((a = getc(fk)) == EOF) {
		wipeout();
		return EOF;
	}
	buf[count++] = a;
	return a;
}

shift_to_jis(a,b)
int a,b;
{

	a = (a - ((a <= 0x9f) ? 0x81 : 0xc1)) * 2 + 0x21;
	if (b < 0x80)
		b -= 0x1f;
	else {
		if (b < 0x9f)
			b -= 0x20;
		else {
			b -= 0x7e;
			a++;
		}
	}
	buf[count - 2] = a;
	buf[count - 1] = b;
}

jis_to_shift(str)
char *str;
{
	int a,b;
	a = *str++;
	b = *str;
        putchar((a-0x21)/2+((a<=0x51)?0x81:0xc1));
        putchar(b+((a&1)?((b<0x60)?0x1f:0x20):0x7e));
}

int_arg(arg)
char *arg;
{
	while(*arg != NULL) set_sw(*arg++);
}

set_sw(sw)
	char            sw;
{
	switch (sw) {
	case 'j':
		termki = "\33$@";
		termko = "\33(J";
		break;
	case 'J':
		termki = "\33$B";
		termko = "\33(J";
		break;
	case 'g':
		termki = "\33$@";
		termko = "\33(B";
		break;
	case 'G':
		termki = "\33$B";
		termko = "\33(B";
		break;
	case 'c':
		termki = "\33$@";
		termko = "\33(H";
		break;
	case 'u':
		termki = "\33$";
		termko = "\33+";
		break;
	case 'p':
		termki = "\33K";
		termko = "\33H";
		break;
	case 'i':
		termki = "\32p";
		termko = "\32q";
		break;
	case 't':
		termki = "\01";
		termko = "\01";
		break;
	case 's':
		o_is_jis = 0;
		break;
	case 'e':
		ki[0].right = ko[0].right = &failure;
		break;
	case 'k':
	case 'h':
		message();
		break;
	case '!':
		oddversion();
		break;
	default:
		fprintf(stderr, "undefined switch %c\n", sw);
		exit(1);
	}
}

oddversion()
{
	ki[0].left = &kiodd;
	ki[0].right = &failure;
	ki[1].val = '[';
	ki[8].val = 'Z';
	ki[10].val = 'A';

	ko[0].left = &koodd;
	ko[0].right = &failure;
	ko[1].val = '[';
	ko[13].val = 'Z';
	ko[15].val = 'A';
}

message()
{
	fprintf(stderr, "usage:(1)  Xkc [-swich] [file 1]...[file n]\n");
	fprintf(stderr, "           ^\n");
	fprintf(stderr, "           |\n");
	fprintf(stderr, "           +----------------------+\n");
	fprintf(stderr, "                                  |\n");
	fprintf(stderr, "[swich] is following.(Default is 'X'.)\n");
	fprintf(stderr, "******* Designate code for output *******\n");
	fprintf(stderr, "j:     junet standard	 kin=^[$@	 kout=^[(J\n");
	fprintf(stderr, "J:     junet standard	 kin=^[$B        kout=^[(J\n");
	fprintf(stderr, "g:     junet standard	 kin=^[$@        kout=^[(B\n");
	fprintf(stderr, "G:     junet standard	 kin=^[$B        kout=^[(B\n");
	fprintf(stderr, "c:      cpm type        kin=^[$@        kout=^[(H\n");
	fprintf(stderr, "u:      ???????????     kin=^[$         kout=^[+\n");
	fprintf(stderr, "p:      98basic term P  kin=^[K         kout=^[H\n");
	fprintf(stderr, "i:      98basic term i  kin=^Zp         kout=^Zq\n");
	fprintf(stderr, "t:      tsscc(old)      kin=^A          kout=^A\n");
	fprintf(stderr, "s:      SHIFT JIS\n");
	fprintf(stderr, "*****************************************\n");

	fprintf(stderr, "e: Ignore the designate code which bigins from SB and SH.\n");
	fprintf(stderr, "h or k: display this message.\n");
	fprintf(stderr, "  if control characters like ESC SB SH... are transformed");
	fprintf(stderr, "into ^[ ^Z ^A, you can use [!] option.\n");
	fprintf(stderr, "but this option shares a little danger.\n");
	exit(0);
}
