#include	<stdio.h>
#include	"defs.h"
#include	"global.h"

#define	PXLID		1001

#ifndef NHALFPXLCHARS	
#  define	NHALFPXLCHARS	128
#  define	NPXLCHARS	256	/* <= NFNTCHARS */
#endif

ReadPXLFontInfo(fe, fntfp)
register struct font_entry *fe;
register FILE *fntfp;
{
    int t, i, fdir, nchars;
    register struct char_entry *tcharptr;/* temporary char_entry pointer  */

    if ((t = NoSignExtend(fntfp, 4)) != PXLID)
	Fatal("PXL ID = %d, can only process PXL ID = %d files",
	      t, PXLID);
    fseek(fntfp, -20, 2);
    t = NoSignExtend(fntfp, 4);
    if ((fe->c != 0) && (t != 0) && (fe->c != t))
	Warning("font = \"%s\",\n-->font checksum = %d,\n-->dvi checksum = %d",
		fe->name, fe->c, t);
    fe->magnification = NoSignExtend(fntfp, 4);
    fe->designsize = NoSignExtend(fntfp, 4);
    fe->isDownLoad = FALSE;
    
    t = ftell(fntfp) - 12;
    fseek(fntfp, fdir = NoSignExtend(fntfp, 4) * 4, 0);
    nchars = (t-fdir)/(4*4);
    if(nchars > NPXLCHARS) {
	Fatal("font dir size of %s is %d\n", fe->name, nchars);
    } else if(nchars != NHALFPXLCHARS && nchars != NPXLCHARS) {
	Warning("font dir size of %s is %d\n", fe->name, nchars);
    }
    
    for (i = 0; i < nchars; i++) {
	tcharptr = &(fe->ch[i]);
	tcharptr->width = NoSignExtend(fntfp, 2);
	tcharptr->height = NoSignExtend(fntfp, 2);
	tcharptr->xOffset = SignExtend(fntfp, 2);
	tcharptr->yOffset = SignExtend(fntfp, 2);
	tcharptr->nbpl = ((tcharptr->width + 31) >> 5) * 4;
	if((tcharptr->where.address.fileOffset = NoSignExtend(fntfp, 4) * 4) == 0)
	    tcharptr->where.address.fileOffset = NONEXISTANT;
	tcharptr->where.address.pixptr = NULL;
	tcharptr->loaded = FALSE;
	tcharptr->tfmw = ((float)NoSignExtend(fntfp, 4)*(float)fe->s) /
	    (float)(1<<20);
    }
}

loadpxlchar(fe, c)
register struct font_entry *fe;
int c;
{
    char *pixel;
    int nbytes;
    register struct char_entry *ce;
    FILE *pxlfp;

    ce = &(fe->ch[c]);
    OpenFontFile(fe);
    fseek(pxlfp = fe->font_file_id, ce->where.address.fileOffset, 0);
    nbytes = ce->nbpl * ce->height;
    if((pixel = (char *)malloc(nbytes)) == NULL )
	Fatal("Unable to allocate memory for char\n");
    fread(pixel, 1, nbytes, pxlfp);
    ce->where.address.pixptr = pixel;
}
