#ifndef lint

static char rcsid[] = "$Header: special.c,v 1.6 88/12/09 23:20:23 root Locked $";
#endif

/*
 *	$Log:	special.c,v $
 * Revision 1.6  88/12/09  23:20:23  root
 * add ellipse using xfig
 * 
 * Revision 1.5  88/12/08  05:58:54  root
 * memory fix
 * 
 * Revision 1.4  88/12/07  15:09:39  root
 * gcc errors
 * 
 * Revision 1.2  88/12/04  14:57:36  root
 * dap fix
 * 
 * Revision 1.1  88/11/15  15:55:55  root
 * special
 * 
 */

#include <stdio.h>
#include <ctype.h>

#include "defs.h"
#include "global.h"
#include "kyocera.h"
#define M_PI    3.14159265358979323846
#define M_PI_2  1.57079632679489661923

float specialConv = (float) 	RESOLUTION / 1000.0;

/*
 *	This code attempts to support the same set of specials
 *	as imagen1
 */ 
static char *
skipWhite(c)
char *c;
{
    while (c != 0 && *c != 0 && isspace(*c)) c++;
    return(c);
}

static char *
skipNonWhite(c)
char *c;
{
    while (c != 0 && *c != 0 && ! isspace(*c)) c++;
    return(c);
}

typedef struct XPoint {
  int x,y;
} XPoint;

#define MAX_POINTS 128
static int pointListCount = 0;
static XPoint pointList[MAX_POINTS];
static penSize = 1;

extern double atan();

void
applicationDoSpecial(command)
char *command;
{
    char com[20];
    int x,y,i;
    char *c, *oc;

    c = skipWhite(command);
    if (*c == 0) return;

    hh = PixRound(h);
    vv = PixRound(v);

    oc = c;
    c = skipNonWhite(c);
    x = *c;
    *c = '\000';
    strncpy(com, oc, 20);
    *c = x;
    c++;

    if (strcmp(com, "pa") == 0) {
	sscanf(c, " %d %d ", &x, &y);
	pointList[pointListCount].x =
	    specialConv * x + hh + xscreen;
	pointList[pointListCount].y =
	    specialConv * y + vv + yscreen;

	pointListCount++;

/*
 *	Make all lines styles come out as a simple line.
 */

    } else if (  (strcmp(com,"fp") == 0)
	       || (strcmp(com,"da") == 0)
	       || (strcmp(com,"dt") == 0)) {
	if (pointListCount > 1) {
	  PRES((printf("map %d,%d;drp ",
		       pointList[0].x,pointList[0].y)));
	  for(i=1;i<pointListCount;i++) {
	    printf("%d,%d",
		   pointList[i].x-pointList[i-1].x,
		   pointList[i].y-pointList[i-1].y);
	    if (i==pointListCount-1) 
		putchar(';');
	    else if (i%7==0) {
		printf(";\ndrp ");
	    } else putchar(',');
	  }
	  printf("map %d,%d;\n",hh+xscreen,vv+yscreen);
	}
	pointListCount = 0;
    } else if (strcmp(com,"ar") == 0) {
	int rx,ry,s,e; double start,end;
	sscanf(c, " %d %d %d %d %lf %lf", &x, &y, &rx, &ry, &start, &end);
	    x = specialConv * x + hh + xscreen;
	    y = specialConv * y + vv + yscreen;
	    rx = specialConv * rx;
	    ry = specialConv * ry;
	if (rx == ry) {
	  /* draw arc */
	  if(start==end) {
	      PRES(printf("map %d,%d;cir %d;\n",x,y,rx));
	  } else {
	      s = start * 360.0 / (2.0*M_PI)+90.0;
	      e = end * 360.0 / (2.0*M_PI)+90.0;
	      rx -= penSize/2;
	      PRES(printf("map %d,%d;arc %d,%d,%d,%d;\n",x,y,rx,rx+penSize,s,e))
	  }
	} else 
        curve(rx, 0, rx, 0, 1, (ry*ry), (rx*rx),x,y,0);

    } else if (strcmp(com, "pn") == 0) {
	sscanf(c," %d ", &penSize);
	penSize = penSize<1?  1:penSize;
	penSize = penSize>99?99:penSize;
        PRES((printf("spd %d;",penSize)));
    } else {
	fprintf(stderr, "[%s] special \"%s\" not implemented\n",
		"dvikcr", command);
    }
}


/* 
 *	FIG : Facility for Interactive Generation of figures
 *
 *	Copyright (c) 1985 by Supoj Sutanthavibul (supoj@sally.UTEXAS.EDU)
 *	January 1985.
 *	1st revision : Aug 1985.
 *
 *	%W%	%G%
*/

#define		round(a)	((int)((a) + .5))

/*	This routine plot two dimensional curve defined by a second degree
	polynomial of the form :
			    2    2
		f(x, y) = ax + by + g = 0

	(x0,y0) is the starting point as well as ending point of the curve.
	The curve will translate with the offset xoff and yoff.

	This algorithm is derived from the eight point algorithm in :
	"An Improved Algorithm for the generation of Nonparametric Curves"
	by Bernard W. Jordan, William J. Lennon and Barry D. Holm, IEEE
	Transaction on Computers Vol C-22, No. 12 December 1973.
*/

curve(xstart, ystart, xend, yend, direction, a, b, xoff, yoff, val)
int	xstart, ystart, xend, yend, a, b, xoff, yoff;
int	direction, val;
{
	int	dfx, dfy, dfxx, dfyy;
	int	falpha, fx, fy, fxy, absfx, absfy, absfxy;
	int	margin, test_succeed, x, y, deltax, deltay, inc, dec;
	
	if (a == 0 || b == 0) return;
	x    = xstart;
	y    = ystart;
	dfx  = 2 * a * xstart;
	dfy  = 2 * b * ystart;
	dfxx = 2 * a;
	dfyy = 2 * b;

	falpha = 0;
	if (direction) {
	    inc = 1;  dec = -1;
	    }
	else {
	    inc = -1;  dec = 1;
	    }
	if (xstart == xend && ystart == yend) {
	    test_succeed = margin = 1;
	    }
	else {
	    test_succeed = margin = 3; 
	    }

	PRES((printf("map %d,%d;",x+xoff,y+yoff)));
	do {
	    if (dfy < 0) deltax = inc; else deltax = dec;
	    if (dfx < 0) deltay = dec; else deltay = inc;
	    fx  = falpha + dfx * deltax + a;
	    fy  = falpha + dfy * deltay + b;
	    fxy = fx + fy - falpha;
	    absfx  = abs(fx); absfy  = abs(fy); absfxy = abs(fxy);

	    if ((absfxy <= absfx) && (absfxy <= absfy))
		falpha = fxy;
	    else if (absfy <= absfx) {
		deltax = 0; falpha = fy;
		}
	    else {
		deltay = 0; falpha = fx;
		}
	    x = x + deltax;  y = y + deltay;
	    PRES((printf("dap %d,%d;\n", xoff+x, yoff-y)));
	    dfx = dfx + dfxx * deltax;
	    dfy = dfy + dfyy * deltay;
	    if (abs(x - xend) < margin && abs(y - yend) < margin) 
		test_succeed--;
	    } while (test_succeed);
	}
