/*
 *	Copyright (c) Japan TeX Users Group, 1986 1987
 */

/*	This file contains device dependent routines	*/

#include <stdio.h>
#include "../common/def.h"
#define	 n_putc(n, c)	for(x=n; --x>=0; putchar(c))

float	mag;
int	f, h, v, dh, dv;
int	t_margin, l_margin, copy, dflag, dfn, hflag;
FONT	font[];

/*	initialize LBP-8	*/

init_lbp()
{
	if(dflag >= 0 && font[dfn].n) {
		font[dfn].down = 1;
		if(dflag > 0 || !same_font(dfn)) {
			down_pixel(dfn);
			memo_font(dfn);
		}
	}
	printf("\033<");		/* LBP soft reset */
	printf("\233%dp", hflag);	/* portrait/landscape */
	printf("\2337 I\23311h");	/* set unit = dot */
	printf("\233%dv", copy);	/* copy no. */
	printf("\233%dd\2332t", t_margin); /* set top margin */
	printf("\233%d`\233t",  l_margin); /* set left margin */
	printf("\033)/ 0");		/* designate 3840 to G1 */
	printf("\233?5l");		/* LF only */
	printf("\2331;1 G");		/* spacing */
}
	

flush_page()
{
	putchar('\f');			/* eject */
}


/*	down load fn	*/

down_pixel(fn)
{
	register FONT *t;
	register FONT_CH *p;
	register i, x, y;
	int	 maxw, maxh, maxd, nchar;	/* width, height, depth */
	char	 *q;

	t= &font[fn];
	maxw = maxh = maxd = nchar = 0;
	for(i=0; i < NCHAR; ++i) {
#if OFS
		if(i == '\033' || i == ' ')
			continue;
#else
		if(i <=' ' || i>'~')
			continue;
#endif
		p = &t->ch[i];
		if(p->pxl == NULL)
			continue;
		++nchar;
		if(p->width > maxw)	maxw = p->width;
		if(p->yoff > maxh)	maxh = p->yoff;
		if(p->height-p->yoff > maxd)
			maxd = p->height-p->yoff;
	}
	if(maxw > MAX_W/8 || maxh+maxd > MAX_H)
		error("can't down load! too big character.\n");
	i = (maxw*(maxh+maxd)+(2+OFS)) * nchar;
/*
	if(i > MAX_MEM)
		error("can't down load! memory full.\n");
*/
	printf("\033c");			/* LBP hard reset */
	printf("\233%d;", i);			/* total bytes */
	printf("%d;0;0;3840;%d;", nchar, SPC);	/* no. of char, set no. */
	printf("1200;400;0;0;200;"); 		/* pitch, size, face */
	printf("%d;%d;", maxw*8, maxh+maxd);	/* width, height */
#if OFS
	printf("%d;0;0;1.p", maxd);		/* baseline */
#else
	printf("%d;1.p", maxd);		/* baseline */
#endif
	for(i=0; i < NCHAR; ++i) {
#if OFS
		if(i == '\033' || i == ' ')	/* skip CSI/sp */
			continue;
#else
		if(i <=' ' || i>'~')		/* skip non graphics */
			continue;
#endif
		p = &t->ch[i];
		if((q = p->pxl) == NULL)
			continue;
		putchar(i);			/* code */
		putchar(sp_to_dot0(p->tfmw));	/* pitch */
#if OFS
		putchar(p->width*8);
		putchar(-p->xoff);		/* offset */
#endif
		n_putc((maxh-p->yoff)*maxw, 0); /* raster data */
		for(y=p->height; --y >= 0; ) {
			n_putc(p->width, *q++);
			n_putc(maxw-p->width, 0);
		}
		n_putc((maxd+p->yoff-p->height)*maxw, 0);
	}
}


/*	set character	*/

set_char(c, update)
{
	register FONT_CH *p;
	register n;

	p = &font[f].ch[c];
#if OFS
	if(font[f].down && c != '\033' && c != ' ') {
#else
	if(font[f].down && c > ' ' && c <= '~') {
#endif
#if OFS
		move(sp_to_dot(h)-dh, sp_to_dot(v)-dv);
#else
		move(sp_to_dot(h)-(p->xoff)-dh, sp_to_dot(v)-dv);
#endif
		putchar(c+128);
		dh += sp_to_dot0(p->tfmw);
	} else {
		move(sp_to_dot(h)-(p->xoff)-dh, sp_to_dot(v)-(p->yoff)-dv);
		n = p->width * p->height;
		printf("\233%d;%d.r", n, p->width);	/* rectangle image */
		fwrite(p->pxl, 1, n, stdout);
	}
	if(update) h += p->tfmw;
}


/*	set rule	*/

set_rule(a, b, update)
{
	register da, db;

	if(a > 0 && b > 0) {
		move(sp_to_dot(h)-dh, sp_to_dot(v)-dv);
		if((da = sp_to_dot(a)-1) < 0)	da = 0;
		if((db = sp_to_dot(b)-1) < 0)	db = 0;
		printf("\2331x");		/* save current position */
		printf("\2333s");		/* start rule */
		if(da) printf("\233%dk", da);	/* up */
		if(db) printf("\233%da", db);	/* right */
		printf("\233r");		/* end rule */
		printf("\233x");		/* return to saved position */
	}
	if(update) h += b;
}


/*	move current point relative	*/

move(dx, dy)
register dx, dy;
{
	switch(dx) {
	case 2:	 putchar(' ');
	case 1:	 putchar(' ');
	case 0:	 break;
	default:
		if(dx > 0) printf("\233%da", dx);	/* right */
		else	   printf("\233%dj", -dx);	/* left */
	}
	dh += dx;

	switch(dy) {
	case 2:	putchar('\n');
	case 1:	putchar('\n');
	case 0: break;
	default:
		if(dy > 0) printf("\233%de", dy);	/* down */
		else	   printf("\233%dk", -dy);	/* up */
	}
	dv += dy;
}
