/*
 *	Copyright (c) Japan TeX Users Group, 1986 1987
 */

/*	This file contains device dependent routines	*/

#include <stdio.h>
#include <ctype.h>
#include "../common/def.h"
#define	 n_putc(n, c)	for(x=n; --x>=0; putchar(c))

#define	SHIFTIN		017
#define	SHIFTOUT	016

/* float	mag; */

int	f, h, v, dh, dv;
int	t_margin, l_margin, copy, dflag, dfn, hflag, last_x, last_y;
FONT	font[];
int	kmode, last_size;

/*	initialize LBP-8	*/


init_lbp()
{
	if(dflag >= 0 && font[dfn].n) {
		font[dfn].down = 1;
		if(dflag > 0 || !same_font(dfn)) {
			printf("\033c\2332&z");		/* LBP hard reset */
			printf("\23311h\2337 I");	/* set unit = dot */
			printf("\233?5l");		/* LF only */
			printf("\233?2;3h");
			printf("\2331;1 G");		/* spacing */
			down_pixel(dfn);
			memo_font(dfn);
		}
	}
	printf("\033;\033<");	/* LBP soft reset */
	printf("\23311h\2337 I");	/* set unit = dot */
	printf("\2331;1 G");		/* spacing */
	printf("\233%dp", hflag);	/* portrait/landscape */
	printf("\2337 I\23311h");	/* set unit = dot */
	printf("\233%dv", copy);	/* copy no. */
	printf("\233%dd\2332t", t_margin); /* set top margin */
	printf("\233%d`\233t",  l_margin); /* set left margin */
	printf("\033)/ 0");		/* designate 3840 to G1 */
	printf("\233?5l");		/* LF only */
	printf("\2331;1 G");		/* spacing */
	printf("\233?2;3h");
	printf("\033(/ 0");
}
	

flush_page()
{
	putchar('\f');			/* eject */
	printf("\233%dd", t_margin);    /* to top margin */
	printf("\233%d`", l_margin);    /* to left margin */ 
}




/*	down load fn	*/

down_pixel(fn)
{
	register FONT *t;
	register FONT_CH *p;
	register i, x, y;
	int	 maxw, maxh, maxd, nchar;	/* width, height, depth */
	char	 *q;

	t= &font[fn];
	maxw = maxh = maxd = nchar = 0;
	for(i=0; i < NCHAR; ++i) {
#if OFS
		if(i == '\033' || i == ' ')
			continue;
#else
		if(i <=' ' || i>'~')
			continue;
#endif
		p = &t->ch[i];
		if(p->pxl == NULL)
			continue;
		++nchar;
		if(p->width > maxw)	maxw = p->width;
		if(p->yoff > maxh)	maxh = p->yoff;
		if(p->height-p->yoff > maxd)
			maxd = p->height-p->yoff;
	}
	if(maxw > MAX_W/8 || maxh+maxd > MAX_H)
		error("can't down load! too big character.\n");
#if SPC
	i = (maxw*(maxh+maxd)+(2+OFS)) * nchar;
#else
	i = (maxw*(maxh+maxd)+(1+OFS)) * nchar;
#endif
/*
	if(i > MAX_MEM)
		error("can't down load! memory full.\n");
*/
	printf("\233%d;", i);			/* total bytes */
	printf("%d;0;0;3840;%d;", nchar, SPC);	/* no. of char, set no. */
	printf("1200;400;0;0;200;"); 		/* pitch, size, face */
	printf("%d;%d;", maxw*8, maxh+maxd);	/* width, height */
#if OFS
	printf("%d;0;0;1.p", maxd);		/* baseline */
#else
	printf("%d;1.p", maxd);		/* baseline */
#endif
	for(i=0; i < NCHAR; ++i) {
#if OFS
		if(i == '\033' || i == ' ')	/* skip CSI/sp */
			continue;
#else
		if(i <=' ' || i>'~')		/* skip non graphics */
			continue;
#endif
		p = &t->ch[i];
		if((q = p->pxl) == NULL)
			continue;
		putchar(i);			/* code */
#if SPC
		putchar(sp_to_dot0(p->tfmw));	/* pitch */
#endif

#if OFS
		putchar(p->width*8);
		putchar(-p->xoff);		/* offset */
#endif
		n_putc((maxh-p->yoff)*maxw, 0); /* raster data */
		for(y=p->height; --y >= 0; ) {
			n_putc(p->width, *q++);
			n_putc(maxw-p->width, 0);
		}
		n_putc((maxd+p->yoff-p->height)*maxw, 0);
	}
}


/*	set character	*/

set_char(cc, update)
{
	register FONT_CH *p;
	register n;

	int	c;

	c = cc > 255 ? get_char_type(f, (unsigned short)cc) : cc;
	p = &font[f].ch[c];
#if OFS
	if(cc > 255 || ((font[f].down) && (c != '\033') && (c != ' '))) {
#else
	if(cc > 255 || ((font[f].down) && (c > ' ') && (c <= '~'))) {
#endif
		if(cc > 255){
#if OFS
			move(sp_to_dot(h)-dh, sp_to_dot(v)-dv);
#else
			move(sp_to_dot(h)-(p->xoff)-dh, sp_to_dot(v)-(p->yoff)-dv);
#endif
			dh += sp_to_dot0(p->tfmw);
			if(!kmode){
				printf("\033(,0");
				kmode = 1;
			}
			if(last_size != font[f].size){
				last_size = font[f].size;
				select_size(last_size);
			}
			putchar(cc >> 8);
			putchar(cc & 0xff);
		}else{
#if OFS
			move(sp_to_dot(h)-dh, sp_to_dot(v)-dv);
#else
			move(sp_to_dot(h)-(p->xoff)-dh, sp_to_dot(v)-dv);
#endif
			if(kmode){
				printf("\033(/ 0");/* designate 3840 to G1 */
				kmode = 0;
				if(last_size != 24 && last_size != 32){
					last_size = 0;
					printf("\233100;100 B");
				}
			}
			putchar(c);
/*
			dh += sp_to_dot0(p->tfmw);
*/
		}
	} else {
		move(sp_to_dot(h)-(p->xoff)-dh, sp_to_dot(v)-(p->yoff)-dv);
		n = p->width * p->height;
		printf("\233%d;%d.r", n, p->width);	/* rectangle image */
		fwrite(p->pxl, 1, n, stdout);
	}
	if(update) h += p->tfmw;
}



/*	set rule	*/

set_rule(a, b, update)
{
	register da, db;

	if(a > 0 && b > 0) {
		move(sp_to_dot(h)-dh, sp_to_dot(v)-dv);
		if((da = sp_to_dot(a)-1) < 0)	da = 0;
		if((db = sp_to_dot(b)-1) < 0)	db = 0;
		printf("\2331x");		/* save current position */
		printf("\2333s");		/* start rule */
		if(da) printf("\233%dk", da);	/* up */
		if(db) printf("\233%da", db);	/* right */
		printf("\233r");		/* end rule */
		printf("\233x");		/* return to saved position */
	}
	if(update) h += b;
}

move(dx, dy)
register dx, dy;
{
	if(dx > 0) printf("\233%da", dx);       /* right */
	else if(dx!=0)       printf("\233%dj", -dx);      /* left */
        dh += dx;

	if(dy > 0) printf("\233%de", dy);       /* down */
	else if(dy!=0)      printf("\233%dk", -dy);      /* up */
        dv += dy;
}

select_size(n)
{
	int	m, s;
	m = 100;
	switch(n){
		case 24*2:	m += 100;
		case 24:	s = 0;
				break;
		case 32*2:	m += 100;
		case 32:
		default:	s = 3;
				break;
	}
	printf("\233%d K", s);
	printf("\233%d;%d B", m, m);
}

#include "plot.h"

double specialConv = (double) 	720 / 1000.0;
#define GDPI (720.0/DPI)

/*
 *	This code attempts to support the same set of specials
 *	as imagen1
 */ 
static char *
skipWhite(c)
char *c;
{
    while (c != 0 && *c != 0 && isspace(*c)) c++;
    return(c);
}

static char *
skipNonWhite(c)
char *c;
{
    while (c != 0 && *c != 0 && ! isspace(*c)) c++;
    return(c);
}

typedef struct XPoint {
  int x,y;
} XPoint;

#define MAX_POINTS 128
static int pointListCount = 0;
static XPoint pointList[MAX_POINTS];
static penSize = 1;

#define GRAPHICS \
          move(sp_to_dot(h)-dh, sp_to_dot(v)-dv); \
	  ENTER;\
  \
	  putchar(0x23);putchar(0x1e); /* begin picture */ \
	  scale(1,INCH); /* 1/720 * 2.4 = 1/300 */ \
	  putchar(0x24);putchar(0x1e); /* begin picture body */ \
	  origin((int)((l_margin+dh)*GDPI),(int)((63+t_margin+dv)*GDPI)); \
	  /* line type */ \
	  hex("4531");p(type-10);IS2; \
	  hex("4631");p(-penSize);IS2;

#define M_PI    3.14159265358979323846

void
applicationDoSpecial(command)
char *command;
{
    char com[20];
    int x,y,i,type;
    char *c, *oc; int hh,vv;

    c = skipWhite(command);
    if (*c == 0) return;

    oc = c;
    c = skipNonWhite(c);
    x = *c;
    *c = '\000';
    strncpy(com, oc, 20);
    *c = x;
    c++;

    if (strcmp(com, "pa") == 0) {
	sscanf(c, " %d %d ", &x, &y);
	pointList[pointListCount].x = specialConv * x ;
	pointList[pointListCount].y = specialConv * y ;

	pointListCount++;

/*
 *	Make all lines styles come out as a simple line.
 */
    } else if (  (strcmp(com,"fp") == 0 && (type=10))
	       || (strcmp(com,"da") == 0 && (type=11))
	       || (strcmp(com,"dt") == 0 && (type=12))) {
          GRAPHICS;
	  putchar(0x31);
	if (pointListCount > 1) {
	  p(pointList[0].x);p(pointList[0].y);
	  for(i=1;i<pointListCount;i++) {
	    p(pointList[i].x-pointList[i-1].x);
	    p(pointList[i].y-pointList[i-1].y);
	  }
          IS2;
  	  hex("251e7d701e");
	}
	pointListCount = 0;

    } else if (strcmp(com,"ar") == 0) {
	int rx,ry,s,e; double start,end;
	sscanf(c, " %d %d %d %d %lf %lf", &x, &y, &rx, &ry, &start, &end);
          GRAPHICS;
	    x = specialConv * (double)x ;
	    y = specialConv * (double)y ;
	    rx = specialConv * rx;
	    ry = specialConv * ry;
	if (rx == ry) {
	  /* draw arc */
	  if(start==end) {
	      hex("35");p(x);p(y);p(rx);IS2;
	  } else {
              s = start * 360.0 / (2.0*M_PI);
              e = end * 360.0 / (2.0*M_PI);
	      e = (e-s)%360; if (e<0) e += 360;
	      hex("7d3630");p(x);p(y);p(rx);p(s);p(e);IS2;
	  }
	} else {
	/* draw elipse ( no arc ) */
	  hex("7d37");p(x);p(y);p(rx);p(ry);p(0);IS2;
	}
	hex("251e7d701e");
	pointListCount = 0;
    } else if (strcmp(com, "pn") == 0) {
	sscanf(c," %d ", &penSize);
	penSize = penSize<1?  1:penSize;
	penSize = penSize>4?4:penSize;
	pointListCount = 0;
    } else {
	pointListCount = 0;

      
/*
 *	For now, lets just flush the special
	fprintf(stderr, "[%s] special \"%s\" not implemented\n",
		ProgName, command);
 */
    }
}
