/*
 *	Copyright (c) Japan TeX Users Group, 1986 1987
 */

#include <stdio.h>
#include <strings.h>
#include "../common/def.h"
#define	PXL_ID	1001			/* pixel file id */

float	mag;
FONT	font[];

#ifndef	PK_FORMAT

/*	load pixel file of font no. fn	*/

load_pixel(fn)
{
	register FONT *t;
	register FONT_CH *p;
	int	i, c;
	float	d;
	char	*q, *get_str();
	FILE	*pxl;

	t = &font[fn];
	if((pxl = fopen(t->a, "r")) == NULL)
		error("can't open pixel file %s.\n", t->a);
	c = get_int(pxl, 4);
	fseek(pxl, -4, 2);
	if(c != PXL_ID || get_int(pxl, 4) != PXL_ID)
		error("bad pixel file %s.\n", t->a);
	fseek(pxl, -20, 2);
	if((c = get_int(pxl, 4)) && t->c && c != t->c)
		;
/*		error("pixel file %s version error.\n", t->a); */
	fseek(pxl, 8, 1);
	c = get_int(pxl, 4) * 4;
	fseek(pxl, 0, 0);
	q = get_str(pxl, c);
	d = (float)t->d * t->fmag / (float)(1<<20);
	t->ch = (FONT_CH *)malloc(sizeof(FONT_CH [NCHAR]));
	if(t->ch == NULL)
		error("can't allocate memory for font table.\n");
	for(p=t->ch; p < &t->ch[NCHAR]; ++p) {
		register char *r, *s;
		register x, y;
	
		p->width = (get_uint(pxl, 2)+7)/8;
		p->height = get_uint(pxl, 2);
		p->xoff = get_int(pxl, 2);
		p->yoff = get_int(pxl, 2);
		i = get_int(pxl, 4);
		p->pxl = i ? q + i * 4 : NULL;
		p->tfmw = fix((float)get_int(pxl, 4) * d);

		r = s = p->pxl;	/* byte pack */
		for(y=p->height; --y>=0; s+=(-p->width)&3)
			for(x=p->width; --x>=0; )
				*r++ = *s++;
	}
	fclose(pxl);
}
#endif

/*	Is fn same as .down_font ?	*/

same_font(fn)
{
	register FILE	*fp;
	char	dfname[80], buf[80];

	sprintf(dfname, "%s/.down_font", LIB);
	if((fp = fopen(dfname, "r")) == NULL)
		return 0;
	fgets(buf, 80, fp);
	fclose(fp);
	return (strcmp(buf, font[fn].n) == 0);
}


/*	memorize name of font fn	*/

memo_font(fn)
{
	register FILE	*fp;
	char	dfname[80];

	sprintf(dfname, "%s/.down_font", LIB);
	if(fp = fopen(dfname, "w")) {
		fputs(font[fn].n, fp);
		fclose(fp);
	}
}
