/* Copyright (C) 1989 Keizo Saisho (saisho@csce.kyushu-u.junet) */
/*   (sep. 8)							*/

/* Usage: texpr [parameter] dvifile */
/* parameter (default)
 *	-p: page select				(1,end,0)
 *		-p [start],[end],[all(0)|odd(1)|even(2)]
 *	-l: left margin				(100)
 *		-l num (/100 inch)
 *	-t: top margin				(100)
 *		-t num (/100 inch)
 *	-m: magnification			(DEFMAGNIF)
 *		-m x (0,h,1,2,3,4,5)
 *	-c: copy count				(1)
 *		-c num
 *	-r: reverse mode
 *	-o: landscape mode
 *	-P: select printer			(0)
 *		-P LBP AJ-II(0)|LBP8-II(1)|B406(2)
 */

#include <stdio.h>
#include "def.h"
#define	TEXFONT	"/usr/tex/fonts/pk/cmfonts:/usr/tex/fonts/pk/dnpmincho:/usr/tex/fonts/pk/dnpgothic"
#define	FONTENV	"TEXFONTS"

int	tmargin = 100;		/* $@%H%C%W%^!<%8%s(J			*/
int	lmargin = 100;		/* $@:8%^!<%8%s(J				*/
int	Magnif;			/* $@Bg$-$5(J				*/

int	start_page = 1;		/* $@=PNO3+;O%Z!<%8(J			*/
int	end_page = ENDPAGE;	/* $@=PNO=*N;%Z!<%8(J			*/
int	skip_page = 0;		/* $@0u:~%Z!<%8$N;XDj(J			*/
int	page;
int	copy = 1;		/* $@%3%T!<?t(J				*/

int	f_pnt = 0;		/* $@%U%)%s%H%F!<%V%k?t(J			*/
DVIFONT	*dvifonts[MAXTEXFONT];	/* $@%U%)%s%H>pJs$X$N%]%$%s%?(J		*/
DVIFONT	*current = NULL;	/* $@8=:_A*BrCf$N%U%)%s%H%;%C%H(J		*/
int	c_pnt = 0;			/* $@;HMQIQEYI=$X$NEPO??t(J		*/
C_ENTRY	chrtbl[MAXCHAR];	/* $@;HMQIQEYI=(J			*/
int	p_pnt = 0;		/* $@%U%)%s%H%G%#%l%/%H%j$N?t(J		*/
char	*f_path[MAXPATH];	/* $@%U%)%s%H%Q%9(J				*/
char	fpath[MAXBUF];

DVICOST	dviinfm = { 0, 0, 0, 0.0 };	/* $@#d#v#i$N>pJs(J			*/
int	nowcxfont = -1;		/* $@A*BrCf$N%U%)%s%H(J		*/

FILE	*tmpf;			/* $@Cf4V%U%!%$%k(J				*/
long	b_pos = -1;		/* $@A0$NJG$N0LCV(J				*/

PRINTER sel_printer[] = {
		{ 1200, 240, 240000,  64, -100, -40, '2' },
		{ 1200, 300,1200000, 128, -125, -50, '2' },
		{ 1200, 240, 400000, 128, -100, -40, '3' }
	};

PRINTER	*prn = sel_printer;	/* $@%W%j%s%?$NA*Br(J			*/

int	rev_flag = 0;		/* $@5U=g$G=PNO(J				*/
int	how_to_make = 0;	/* $@%"%&%H%i%$%s%U%)%s%H$NE83+K!(J		*/
int	orient = 0;		/* $@2#J}8~$G=PNO(J				*/

/*  $@%a%b%j3d$jEv$F(J	*/
char *new(size)
int	size;
{
	char	*s,*malloc();

	if ((s = malloc(size)) == NULL) {
		error("no memory space\n");
	}
	return (s);
}

/*
 *	$@J8;zNs$N@Z$j=P$7!J;XDj$5$l$?J8;z$r(J '\0' $@$KCV$-49$(!"<!$NJ8;z(J
 *	$@$N%]%$%s%?$rJV$9!#;XDj$5$l$?J8;z$,$J$1$l$P(J NULL $@$rJV$9!#!K(J
 */

char *cut_str(s,c)
char	*s;
int	c;
{
	char	*d, *index();

	if ((d = index(s,c)) == NULL) return (NULL);
	*d = '\0'; return (d+1);
}

/*	$@@hF,$N6uGrJ8;z$r>C$9(J	*/
char *trim(s)
char	*s;
{
	while (*s && ((*s == ' ') || (*s == '\t'))) s++;
	return (s);
}

/*	$@Id9fIU$-@0?t$r<h$j=P$9(J	*/
a_i(s)
char	*s;
{
	int	sign = 1;

	s = trim(s);
	if (*s == '-') {
		sign = -1; s++;
	}
	return (sign*atoi(s));
}

main(ac,av)
int	ac;
char	*av[];
{
	char	*dvifile = NULL;
	char	*tmpfname = "/tmp/dviXXXXXX";
	int	magstep = 10000;

	while (--ac > 0) {
		char	*cp,*cp2;
		int	c;

		if (*(*++av) != '-') {
			dvifile = av[0];
			continue;
		}
		if (av[0][1] == 'r') {
			rev_flag = 1;
			continue;
		}
		if (av[0][1] == 'o') {
			orient = 1;
			continue;
		}
		c = av[0][1];
		if (av[0][2] == EOS) {
			if (--ac > 0) cp = *++av;
			else break;
		} else cp = &av[0][2] ;
		switch(c) {
		case 'p':
			cp2 = cut_str(cp,',');
			if (*trim(cp) != '\0') start_page = a_i(cp);
			if (cp2 != NULL) {
				cp = cut_str(cp2,',');
				if (*trim(cp2)) end_page = a_i(cp2);
			}
			if ((cp != NULL) && *trim(cp)) skip_page = a_i(cp);
			if (start_page <= 0) start_page = 1;
			if (start_page > end_page) exit(0);
			if ((skip_page < 0) || (skip_page > 2)) skip_page = 0;
			break;
		case 'l' :
			lmargin = a_i(cp);
			break;
		case 't' :
			tmargin = a_i(cp);
			break;
		case 'm' :
			switch (*cp) {
			case '0' : magstep = 10000; break;
			case 'h' : magstep = 10954; break;
			case '1' : magstep = 12000; break;
			case '2' : magstep = 14400; break;
			case '3' : magstep = 17280; break;
			case '4' : magstep = 20736; break;
			case '5' : magstep = 24883; break;
			default :  break;
			}
			break;
		case 'c' :
			copy = a_i(cp);
			if (copy <= 0) copy = 1;
			if (copy > 99) copy = 99;
			break;
		case 'P' :
			switch (*cp) {
			case '0' : prn = &sel_printer[0]; break;
			case '1' : prn = &sel_printer[1]; break;
			case '2' : prn = &sel_printer[2]; break;
			default :  break;
			}
			break;
		default :
			break;
		}
	}

/* set parameter */

	if (dvifile != NULL) {
		char	fname[MAXBUF];

		strcpy(fname,dvifile);
		if ((strlen(fname) < 5) ||
		    (strcmp(fname+strlen(fname)-4,".dvi")))
			strcat(fname,".dvi");
		if (freopen(fname,READ,In) == NULL) {
			error("%s: can't open dvi file\n",fname) ;
		}
	}

/*	$@Cf4V%U%!%$%k$N%*!<%W%s(J	*/

	mktemp(tmpfname);
	if ((tmpf = fopen(tmpfname,"w+")) == NULL) {
		error("disk system full\n");
	}
	unlink(tmpfname);

/*	$@%U%)%s%H8!:w%Q%9$N:n@.(J	*/

	{
		char	*ptr,*ptr2,*getenv();
		int	l;

		fpath[0] = '\0';	/* set null string	*/
		if ((ptr = getenv(FONTENV)) != NULL) strcat(fpath,ptr);
		strcat(fpath,TEXFONT); ptr = fpath;
		while (ptr != NULL) {
			ptr2 = cut_str(ptr,':');
			if (*(ptr = trim(ptr))) {
				l = strlen(ptr);
				if (*(ptr+l-1) == '/')
					*(ptr+l-1) = '\0';
				f_path[p_pnt++] = ptr;
				if (p_pnt >= MAXPATH) break;
			}
			ptr = ptr2;
		}
	}

	Magnif = (prn->dot*5*magstep)/10000;
	lmargin = (lmargin*(prn->dot)/100)*magstep/10000+prn->l_offset;
	tmargin = (tmargin*(prn->dot)/100)*magstep/10000+prn->t_offset;

/* $@#D#V#I%U%!%$%k$rFI$_9~$_Cf4V%U%!%$%k$K=PNO(J	*/

	if (getc(In) != PRE || getc(In) != VERSION) {
		error("Not dvi file or dvi versions differ\n") ;
	}
	dviinfm.num = getuint(In,4); dviinfm.den = getuint(In,4);
	dviinfm.mag = getint(In,4);
	dviinfm.RSU = ((float)dviinfm.mag * (float)dviinfm.num) /
			((float)dviinfm.den * 1000.0) ;
	{
		int		i;

		i = getc(In);
		while (i--) getc(In);
	}

	for (page = 1; page <= end_page; page++) {
		int	c;

		c = getc(In);
		if ((c != BOP) && (c != POST)) {
			warning("error POST or BOP at page %d\n",page);
			break;
		}
		if (c == POST) break;
		for (c = 0; c < 44; c++) getc(In);
		if (page < start_page) { pass1_skip(); continue; }
		switch (skip_page) {
		case 1 :
			if (page & 1) pass1_page();
			else pass1_skip();
			break;
		case 2 :
			if (page & 1) pass1_skip();
			else pass1_page();
			break;
		default :
			pass1_page();
		}
	}
	if (ftell(tmpf) == 0) exit(0);
	putc(POST,tmpf);

/* select download fonts & download */

	cxinit(prn->pagesize);
	cxtex;
	fontload();

/* $@Cf4V%U%!%$%k$rFI$_9~$_%W%j%s%?$K=PNO(J		*/

	cxcopy(copy);
	if (orient) cxland;
	cxselg0(DG0);
	if (rev_flag) {
		while (b_pos >= 0) {
			fseek(tmpf,b_pos,TOP);
			if (getc(tmpf) != BOP) error("error BOP in pass1\n");
			b_pos = getuint(tmpf,4);
			putpage();
			cxcejt;
		}
	} else {
		int	c;

		fseek(tmpf,0l,TOP);
		c = getc(tmpf);
		while (c == BOP) {
			b_pos = getuint(tmpf,4);
			putpage();
			cxcejt;
			c = getc(tmpf);
		}
		if (c != POST) error("error POST in pass2\n");
	}
	if (copy != 1) cxcopy(1);
	cxreset;
	fclose(In); fclose(Out);
	exit(0);
}

error(fmt,dim)
char	*fmt;
int	dim;
{
	int	*av ;

	av = &dim ;
	fprintf(stderr,fmt,av[0],av[1],av[2],av[3]);
	exit(1);	/* abnormal return exit(1) */
}

warning(fmt,dim)
char	*fmt;
int	dim;
{
	int	*av;

	av = &dim ;
	fprintf(stderr,fmt,av[0],av[1],av[2],av[3]);
}
