static char rcsid[] = "$Header: j_font.c,v 0.3 88/12/13 16:06:29 onuma Exp $";
/*
 * Copyright(C) $BF|K\EE5$3t<02q<R(J  $B>.>B(J $B@i3((J, 1989
 */

#include <stdio.h>
#include <newsiop/lbp.h>
#include "font_types.h"
#include "font.h"

#define  NCHAR	256	/* $BF|K\8l(J pxl $B%U%!%$%k$K4^$^$l$kJ8;z?t(J */

#define fix(_x)	((int)((_x) + 0.5))
#define sp2dot(_x,_mag)	(fix((float)(_x)*(_mag)*(DPI/(65536*72.27))))

#define j_size		data.j.size
#define j_code_offs 	data.j.code_offs
#define j_tfmw		data.j.tfmw
#define j_bitmap	data.j.bitmap

float ratio();
char *malloc();
char *nwp_get_bitmap();

static char *CashFonts[] = {
    "dmjhira12", "dmjhira10", "dmjkata10", "dmjkata12", NULL
    };
    
int
j_font_def(fp, size, design_size, filename, mag)
struct font *fp;
int size, design_size;	/* $B%5%$%:(J ($BC10L(J: sp) */
char *filename;	/* $B%U%!%$%kL>(J */
float mag;	/* magnification */
{
    int i;
    char **p, **bp;
    /* $B%U%)%s%H%U%!%$%kL>%A%'%C%/(J */
    if (!strncmp(filename, "dmj", sizeof("dmj")-1))		/* $B:G=i$N(J 3 $BJ8;z$,(J "dmj" */
	fp->type = MINCHO;
    else if (!strncmp(filename, "dgj", sizeof("dgj")-1))	/* $B:G=i$N(J 3 $BJ8;z$,(J "dgj" */
	fp->type = GOTHIC;
    else
	return(-1);

    if (!strncmp(filename+3, "keisen", sizeof("keisen")-1))
	fp->j_size = sp2dot(size, mag)*11/10;	/* $B7S@~$O(J 10% $BA}$7(J */
    else
	fp->j_size = sp2dot(size, mag)*94/100;	/* $B$=$NB>$NJ8;z$O(J 6% $B8:(J */
    fp->j_code_offs = get_code_offs(filename);
    fp->j_tfmw  = get_tfmw(size, design_size, mag);
    for (p = CashFonts; *p; p++)
	if (strcmp(*p, filename) == 0)
	    break;
    if (*p != NULL) {	/* $B%-%c%C%7%e$9$k%U%)%s%H(J */
	if ((bp = fp->j_bitmap = (char **)malloc(sizeof(char *)*NCHAR)) == NULL)
	    return(-1);
	for  (i = 0; i < NCHAR; i++, bp++)
	    *bp = NULL;
    }
    else 
	fp->j_bitmap = NULL;
    return(0);
}

static int
get_code_offs(filename)
char *filename;
{
    char c;

    filename += 3;
    if (!strncmp(filename, "sy", sizeof("sy")-1))	/* filename $B$N=i$a$N(J 2 $BJ8;z$,(J "sy" */
	return(-1);	/* 95 $B0J9_$:$l$k(J (j_set_char $B$GJd@5(J) */ 
    if (!strncmp(filename, "hira", sizeof("hira")-1))	/* filename $B$N=i$a$N(J 4 $BJ8;z$,(J "hira" */
	return(282 - 1);	/* 94*3 - 1 */
    if (!strncmp(filename, "kata", sizeof("kata")-1))	/* filename $B$N=i$a$N(J 4 $BJ8;z$,(J "kata" */
	return(376 - 1);	/* 94*4 - 1 */
    if (!strncmp(filename, "greek", sizeof("greek")-1))	/* filename $B$N=i$a$N(J 5 $BJ8;z$,(J "greek" */
	return(470 - 1);	/* 94*5 - 1 */
    if (!strncmp(filename, "russian", sizeof("russian")-1))	/* filename $B$N=i$a$N(J 4 $BJ8;z$,(J "russian" */
	return(564 - 1);	/* 94*6 - 1 */
    if (!strncmp(filename, "roma",sizeof("roma")-1))	/* filename $B$N=i$a$N(J 4 $BJ8;z$,(J "roma" */
	return(188 - 0x21);	/* 94*2 - 0x211 */
    if (!strncmp(filename, "keisen", sizeof("keisen")-1)) {	/* filename $B$N=i$a$N(J 6 $BJ8;z$,(J "keisen" */
	return(658 - 1);	/* 94*7 -1 */
    }
    if (*filename == 'k') {	/* filename $B$N=i$a$N(J 1 $BJ8;z$,(J "k" */
	/* 'k' $B$N<!$NJ8;z$K$h$j7hDj(J */
	c = filename[1];
	if (c >= 'a' && c < 'm')	/* $BBh(J 1 $B?e=`J8;z(J */
	    return(1410 + 256*(c-'a'));		/* 1410 = 94*15 */
	else if (c >= 'm')		/* $BBh(J 2 $B?e=`J8;z(J */
	    return(4418 + 256*(c-'m'));		/* 4418 = 94*47 */
    }
    fprintf(stderr, "Unknown font: %s\n",  filename-3);
    return(-2);
}

static int
get_tfmw(size, design_size, mag)
int size, design_size;	/* $B%5%$%:(J ($BC10L(J: sp) */
float mag;		/* magnification */
 {
#define LBP_DPI	300    
    float fmag;	/* font magnification */
    int pixels, x;
    
    fmag = ratio(size, design_size);
    pixels = fix((LBP_DPI*5.0)*fmag*mag);
    switch (design_size >> 16)  {
    case 5:
	switch (pixels) {
	case 1500:
	    x = 959887;
	    break;
	default:
	    x = 0;
	}
	break;
    case 6:
	switch  (pixels) {
	case 1500:
	    x = 968307;
	    break;
	default:
	    x = 0;
	}
	break;
    case 7:
	switch (pixels) {
	case 1500:
	    x = 974321;
	    break;
	case 1643:
	    x = 955313;
	    break;
	case 1800:
	    x = 962293;
	    break;
	default:
	    x = 0;
	}
	break;
    case 8:
	switch (pixels) {
	case 1500:
	    x = 947257;
	    break;
	default:
	    x = 0;
	}
	break;
    case 9:
	switch (pixels) {
	case 1500:
	    x = 954274;
	    break;
	default:
	    x = 0;
	}
	break;
    case 10:
	switch (pixels) {
	case 1500:
	    x = 959887;
	    break;
	case 1643:
	    x = 968490;
	    break;
	case 1800:
	    x = 968307;
	    break;
	case 2160:
	    x = 964799;
	    break;
	case 2592:
	    x = 964799;
	    break;
	case 3110:
	    x = 962362;
	    break;
	case 3732:
	    x = 964393;
	    break;
	case 4479:
	    x = 955933;
	    break;
	case 5375:
	    x = 958753;
	    break;
	default:
	    x = 0;
	}
	break;
    case 12:
	switch (pixels) {
	case 1500:
	    x = 968307;
	    break;
	case 1643:
	    x = 960804;
	    break;
	default:
	    x = 0;
	}
	break;
    case 17:
	switch (pixels) {
	case 1500:
	    x = 980689;
	    break;
	case 1643:
	    x = 976629;
	    break;
	default:
	    x = 0;
	}
	break;
    case 20:
	switch (pixels) {
	case 1500:
	    x = 959887;
	    break;
	default:
	    x = 0;
	}
	break;
    default:
	x = 0;
    }
    if (x == 0)
	fprintf(stderr, "Warnning: tfmw is 0 :(size, d_size, pixels) = (%d, %d, %d)\n", size, design_size, pixels);
    return (fix (x * (float)design_size * fmag / (float)(1<<20)));
}

int
j_set_char(fp, x, y, code)
struct font *fp;
int x, y;	/* $B=PNO0LCV(J ($BC10L(J: dot) */
int code;	/* $BAjBP%3!<%I(J */
{
    int serial_code;	/* $BO"B3%3!<%I(J */
    char *p;
    
    if (fp->j_bitmap != NULL){	/* $B%-%c%C%7%e%U%)%s%H(J */
	if ((p = fp->j_bitmap[code]) == NULL) {	/* $B$^$@%m!<%I$7$F$J$$(J */
	    if ((p = fp->j_bitmap[code] = malloc(((fp->j_size+7)>>3)*fp->j_size)) ==  NULL)
		return(0);
	    serial_code = code + fp->j_code_offs;
	    if (fp->j_code_offs == -1 && code > 94)	/* $B5-9f%3!<%I$N$:$l$NJd@5(J */
		serial_code -= 6;
	    if(nwp_get_bitmap(fp->type, serial_code, p, (fp->j_size+7)>>3, fp->j_size, fp->j_size) == NULL)
		return(0);
	}
	nwp_copy_area(x, y-fp->j_size*5/6, (fp->j_size+7)>>3, fp->j_size, p);
    }
    else {
	serial_code = code + fp->j_code_offs;
	if (fp->j_code_offs == -1 && code > 94)	/* $B5-9f%3!<%I$N$:$l$NJd@5(J */
	    serial_code -= 6;
	nwp_write_char(fp->type, serial_code, x, y-fp->j_size*5/6, fp->j_size, fp->j_size);
    }
    return(fp->j_tfmw);
}
