static char rcsid[] = "$Header: main.c,v 0.3 89/02/17 13:11:48 onuma Exp $";
/*
 *	Copyright (c) Japan TeX Users Group, 1986 1987
 */
/*
 * Extentions: Copyright(C) $BF|K\EE5$3t<02q<R(J  $B>.>B(J $B@i3((J, 1989
 */

#include <stdio.h>
#include <newsiop/lbp.h>
#include "dvicom.h"

#define	fix(_x)	((int)((_x) + 0.5))
#define	sp2dot(_x,_mag) (fix((float)(_x)*(_mag)*(DPI/(65536*72.27))))
#define MAX_STACK	256

float ratio();

main(argc, argv)
int argc;
char **argv;
{
    int stack[MAX_STACK*6],  *sp;	/* $B0LCV>pJs%9%?%C%/$*$h$S%]%$%s%?(J */
    int h, v;		/* $B8=:_0LCV(J ($BC10L(J: sp) */
    int w, x, y, z;	/* $B0\F0NL%l%8%9%?(J ($BC10L(J: sp) */
    int f;		/* $B%+%l%s%H%U%)%s%HHV9f(J */
    FILE *dvi;		/* dvi $B%U%!%$%k(J */
    int i, c;
    int copy = 1;
    int v_margin, h_margin, inch;	/* $B%^!<%8%s(J ($BC10L(J: sp) */
    float mag;
    int cmd;
    int a,  b,  rect_height;
    int font_no, check_sum, size, design_size, dir_len, file_len;
    char dirname[64], filename[64];

    /* dvi $B%U%!%$%k%*!<%W%s(J */
#ifndef FILTER
    if (argc > 1) {
	if ((dvi = fopen(argv[1], "r")) == NULL) {
	    perror(argv[1]);
	    exit(1);
	}
    }
    else {
	fprintf(stderr, "Usage: %s  dvi_file\n", argv[0]);
	exit(1);
    }
#else
    dvi = stdin;
#endif
    /*************************************************** $B0J2<(J dvi2lbp $B$r0zMQ(J */
    /* dvi file format check */
    if(get_uint(dvi, 1) != PRE || get_uint(dvi, 1) != DVI_ID) {
	fprintf(stderr, "bad dvi file.\n");
	exit (2);
    }
    i = 0;
    do {
	if(fseek(dvi, --i, 2) == -1) {	/* may be pipe */
	    fprintf(stderr, "can't seek to the end of dvi file.\n");
	    exit(2);
	}
    } while ((c=get_uint(dvi, 1)) == DVI_PAD);
    fseek(dvi, i-5, 2);
    if(get_uint(dvi, 1) != POST_POST || c != DVI_ID) {
	fprintf(stderr, "bad dvi file.\n");
	exit(2);
    }

    inch = fix(72.27*65536);
    v_margin = inch;		/* $B>e%^!<%8%s(J 1 inch */
    h_margin = inch*5/6;	/* $B2#%^!<%8%s(J 5/6 inch */
    /* postamble */
    fseek(dvi, get_int(dvi, 4)+13, 0);
    mag = ratio(get_int(dvi, 4), 1000);
    fseek(dvi, 8, 1);
    if(get_uint(dvi, 2) > MAX_STACK) {
	fprintf(stderr, "stack overflow.\n");
	exit(2);
    }

    if (nwp_init())	/* $B%W%j%s%?=i4|2=(J */
	exit(2);

    /* $B%3%^%s%I$N=hM}(J */
    fseek(dvi, 14, 0);
    fseek(dvi, get_uint(dvi, 1), 1);
    for (cmd = get_uint(dvi, 1); cmd != POST; cmd = get_uint(dvi, 1)) {
	if (cmd <= SET_CHAR_127)  {	/* $BJ8;z=PNO(J */
	    h += set_char(f, sp2dot(h, mag), sp2dot(v, mag), cmd);
	    continue;
	}
	switch(cmd) {
	case BOP:	/* $B%Z!<%8;O$a(J */
	    fseek(dvi, 44, 1);
	    h = h_margin;
	    v = v_margin;
	    w = x = y = z = 0;
	    sp = stack;
	    f = -1;
	    break;
	case EOP:	/* $B%Z!<%8=*$o$j(J */
	    nwp_flush(copy);
	    break;
	case SET1: case SET2: case SET3: case SET4:	/* $BJ8;z=PNO(J */
	    h += set_char(f, sp2dot(h, mag), sp2dot(v, mag),
			  get_uint(dvi, cmd-SET1+1));
	    break;
	case PUT1: case PUT2: case PUT3: case PUT4:
	    (void)set_char(f, sp2dot(h, mag), sp2dot(v, mag),
			  get_uint(dvi, cmd-SET1+1));
	    break;
	case SET_RULE: case PUT_RULE:	/* $B@~(J */
	    a = get_int(dvi, 4);
	    b = get_int(dvi, 4);
	    rect_height = sp2dot(a, mag);
	    nwp_write_rect(sp2dot(h, mag), sp2dot(v, mag) - rect_height,
			   sp2dot(b, mag), rect_height);
	    if (cmd == SET_RULE)
		h += b;
	    break;
	case RIGHT1: case RIGHT2: case RIGHT3: case RIGHT4:	/* $B?eJ?0\F0(J */
	    h += get_int(dvi, cmd-RIGHT1+1);
	    break;
	case DOWN1: case DOWN2: case DOWN3: case DOWN4:	/* $B?bD>0\F0(J */
	    v += get_int(dvi, cmd-DOWN1+1);
	    break;
	case W1: case W2: case W3: case W4:	/* $B%l%8%9%?A`:n(J */
	    h += w = get_int(dvi, cmd-W1+1);
	    break;
	case W0:
	    h += w;
	    break;
	case X1: case X2: case X3: case X4:
	    h += x = get_int(dvi, cmd-X1+1);
	    break;
	case X0:
	    h += x;
	    break;
	case Y1: case Y2: case Y3: case Y4:
	    v += y = get_int(dvi, cmd-Y1+1);
	    break;
	case Y0:
	    v += y;
	    break;
	case Z1: case Z2: case Z3: case Z4:
	    v += z = get_int(dvi, cmd-Z1+1);
	    break;
	case Z0:
	    v += z;
	    break;
	case FNT1: case FNT2: case FNT3: case FNT4:	/* $B%U%)%s%H@_Dj(J */
	    f = get_uint(dvi, cmd-FNT1+1);
	    break;
	case FNT_DEF1: case FNT_DEF2: case FNT_DEF3: case FNT_DEF4:	/* $B%U%)%s%HDj5A(J */
	    font_no = get_uint(dvi, cmd-FNT_DEF1+1);	/* $B%U%)%s%HHV9f(J */
	    check_sum = get_int(dvi, 4);	/* $B%A%'%C%/%5%`(J */
	    size = get_int(dvi, 4);		/* $B%5%$%:(J */
	    design_size = get_int(dvi, 4);	/* $B%G%6%$%s%5%$%:(J */
	    dir_len = get_uint(dvi, 1);
	    file_len = get_uint(dvi, 1);
	    get_str(dvi, dirname, dir_len);	/* $B%U%!%s%H%G%#%l%/%H%jL>(J */
	    get_str(dvi, filename, file_len);	/* $B%U%)%s%H%U%!%$%kL>(J */
	    font_def(font_no, check_sum, size, design_size, dirname, filename, mag);
	    break;
	case XXX1: case XXX2: case XXX3: case XXX4:	/* special ($BFI$_<N$F(J) */
	    fseek(dvi, get_uint(dvi, cmd-XXX1+1), 1);
	    break;
	case PUSH:	/* $B0LCV>pJs$r(J push */
	    *sp++ = h; *sp++ = v;
	    *sp++ = w; *sp++ = x;
	    *sp++ = y; *sp++ = z;
	    break;
	case POP:	/* $B0LCV>pJs$r(J pop */
	    z = *--sp; y = *--sp;
	    x = *--sp; w = *--sp;
	    v = *--sp; h = *--sp;
	    break;
	case NOP:
	    break;
	default:	
	    if(cmd >= FNT_NUM_0 && cmd <= FNT_NUM_63)	/* $B%U%)%s%H@_Dj(J */
		f = cmd-FNT_NUM_0;
	    else
		fprintf(stderr, "Unknown command %d\n", cmd);
	}
    }
    exit(0);
}
