static char rcsid[] = "$Header: misc.c,v 0.1 88/12/08 11:49:31 onuma Exp $";
/*
 *	Copyright (c) Japan TeX Users Group, 1986 1987
 */

#include <stdio.h>
#define fix(_x)	((int)((_x) + 0.5))

/* get signed integer from fp */
int
get_int(fp, n)
register FILE	*fp;
register n;
{
	register i;

	if((i=getc(fp)) >= 128)
		i -= 256;
	while(--n > 0)
		i = (i<<8) + getc(fp);
	return i;
}


/* get unsigned integer from fp */
int
get_uint(fp, n)
register FILE	*fp;
register n;
{
	register i;

	for(i = 0; --n >= 0; )
		i = (i<<8) + getc(fp);
	return i;
}

/* get string of length n from fp */
char *
get_str(fp, str, n)
register FILE	*fp;
char *str;
register n;
{
	register char	*p;

	p =  str;
	fread(p, 1, n, fp);
	p[n] = '\0';
	return p;
}

/* compute ratio (to get accurate magnification) */
float
ratio(i, j)	/* due to TeX's bad design */
{
	float	f;

	f = (float)i / (float)j;
	switch( fix(f*1000.0) ) {
	case 1095: case 1096:	f = 1.0954451;	break;
	case 1314: case 1315:	f = 1.3145341;	break;
	case 1643: case 1644:	f = 1.6431676;	break;
	case 2073: case 2074:	f = 2.0736;	break;
	case 2488: case 2489:	f = 2.48832;	break;
	case 2985: case 2986:	f = 2.985984;	break;
	case 3110: case 3111:	f = 3.1104;	break;
	case 3732: case 3733:	f = 3.73248;	break;
	case 4478: case 4479:	f = 4.478976;	break;
	default:	/* o.k. */;
	}
	return f;
}
