static char rcsid[] = "$Header: nwp.c,v 0.3 89/02/02 14:30:17 onuma Exp $";
/*
 * Extentions: Copyright(C) $BF|K\EE5$3t<02q<R(J  $B>.>B(J $B@i3((J, 1989
 */

#include <stdio.h>
#include <sys/ioctl.h>
#include <sys/file.h>
#include <newsiop/lbp.h>
#include "font_types.h"

#ifdef A4_XDOTS		/* NWB-240A/NWB-241A $BMQ(J */
#ifdef B4			/* B4 $B%5%$%:MQ(J */
#define XDOTS B4_XDOTS
#define YDOTS B4_YDOTS
#define FRAME_WIDTH	488	/* XDOTS/8 */
#else				/* A4 $B%5%$%:MQ(J */
#define XDOTS A4_XDOTS
#define YDOTS A4_YDOTS
#define FRAME_WIDTH	392	/* XDOTS/8 */
#endif /* B4 */

#else			/* NWB-240 $BMQ(J */
#define FRAME_WIDTH  392	/* XDOTS/8 */
#endif

#define LBP	"/dev/lbp"	/* NWP-533 $B$N%G%P%$%9L>(J */
#define MINCHO_FONT	"/usr/sony/lib/font/devnwp533/Mincho.vfont"
#define GOTHIC_FONT	"/usr/sony/lib/font/devnwp533/Gothic.vfont"

#define BasicError (ST0_REPRINT_REQ|ST0_WAIT|ST0_PAUSE|ST0_CALL)	/* $B4pK\%9%F!<%?%9(J */
#define OpCallError (ST1_NO_CARTRIGE|ST1_NO_PAPER|ST1_JAM|ST1_OPEN|ST1_TEST)  /* $B%*%Z%l!<%?%3!<%k%9%F!<%?%9(J */
#define ServiceCallError (ST2_FIXER|ST2_SCANNER|ST2_MOTOR)	/* $B%5!<%S%9%3!<%k%9%F!<%?%9(J */

static char frame[YDOTS+1][FRAME_WIDTH];	/* NWP $B%U%l!<%`%P%C%U%!(J */
static int font_des[2];	/* $B%U%)%s%H%U%!%$%k%G%9%/%j%W%?(J */
static int lbp;

int
nwp_init()
{
    struct lbp_stat stat;

    /* $B%U%)%s%H%U%!%$%k%*!<%W%s(J */
    if ((font_des[MINCHO] = FS_open_font(MINCHO_FONT))  < 0) {
	perror(MINCHO_FONT);
	return(-1);
    }
    if ((font_des[GOTHIC] = FS_open_font(GOTHIC_FONT))  < 0) {
	perror(GOTHIC_FONT);
	return(-1);
    }
    
    /* /dev/lbp $B%*!<%W%s(J */
#ifndef FILTER
    if ((lbp = open(LBP, O_WRONLY)) < 0) {
	perror(LBP);
	return(-1);
    }
#else
    lbp = 1;	/* $BI8=`=PNO(J */
#endif

    /* $B%U%l!<%`%P%C%U%!%/%j%"(J */
    FS_fillzero(frame, sizeof(frame));
    return(0);
}

int
nwp_flush(copy)
int copy;
{
    struct lbp_stat stat;
    
    if(lseek(lbp, 0, 0) < 0){
	perror(LBP);
	return(-1);
    }
    if (write(lbp, frame, sizeof(frame)) < 0) {
	perror(LBP);
	return(-1);
    }
    for ( ; copy > 0; copy--) {	/* copy $BKg?t$@$1=PNO(J */
    RETRY:
	if (ioctl(lbp, LBIOCSTART, 0) < 0)	/* $B=PNO3+;O(J */
	    while (1) {
		ioctl(lbp, LBIOCSTATUS, &stat);
		if ((stat.stat[0] & BasicError) == 0)
		    goto RETRY;
		/* $B%5!<%S%9%3!<%k$rI,MW$H$9$k%(%i!<$,H/@8$7$F$$$k$+!)(J */
		if ((stat.stat[2] & ServiceCallError) != 0) 
		    return(-1);
		sleep(1);
	    }
	if (ioctl(lbp, LBIOCSTOP, 0) < 0)	/* $B=PNOBT$A(J */
	    while (1) {
		ioctl(lbp, LBIOCSTATUS, &stat);
		if ((stat.stat[0] & BasicError) == 0)
		    goto RETRY;
		/* $B%5!<%S%9%3!<%k$rI,MW$H$9$k%(%i!<$,H/@8$7$F$$$k$+!)(J */
		if ((stat.stat[2] & ServiceCallError) != 0) 
		    return(-1);
		sleep(1);
	    }
    }
	
    /* $B%U%l!<%`%P%C%U%!%/%j%"(J */
    FS_fillzero(frame, sizeof(frame));
    return(0);
}

int
nwp_write_char(type, code, x, y, width, height)
int type;	/* $B=PNO%U%)%s%H%?%$%W(J (MINCHO/GOTHIC) */
int code;	/* $BO"B3%3!<%I(J */
int x, y;	/* $B=PNO0LCV(J ($BC10L(J: dot) */
int width, height;	/* $B=PNOJ8;z%5%$%:(J ($BC10L(J: dot) */
{
    if (x < 0 || y < 0 || x + width >= XDOTS || y + height >= YDOTS)
	return (-1);
    if (FS_get_bitmap(code, font_des[type], width, height, FRAME_WIDTH,
		      x&0x07, frame[y]+(x>>3), 0, 0, 0)) {
			  return(-1);
		      }
    return(0);
}

int
nwp_write_rect(x, y, width, height)					 
int x, y;		/* $B=PNO0LCV(J ($BC10L(J: dot) */		       
int width, height;	/* $B=PNO6k7A%5%$%:(J ($BC10L(J: dot) */	       
{
    int w1, w2, x_byte, bytes;
    char pattern1,  pattern2, pattern;
    int i, j;

    if (x < 0 || y < 0 || x + width >= XDOTS || y + height >= YDOTS)
	return (-1);
    if((x >> 3) != ((x+width) >> 3)) {	/* $B%P%$%H6-3&$K$^$?$,$k>l9g(J */
	w1 = 8 - (x & 0x07);
	x_byte = (x >>  3) + 1;
	bytes = (width - w1) >> 3;
	w2 = width - w1 - (bytes << 3);

	pattern1 = 0xff >> (8-w1);
	pattern2 = 0xff << (8-w2);

	for (i = 0; i < height; i++, y++) {
	    frame[y][x_byte-1] |= pattern1;
	    for (j = 0; j < bytes; j++)
		frame[y][x_byte+j] = 0xff;
	    frame[y][x_byte+bytes] |= pattern2;
	}
    }
    else {				/* $B%P%$%H6-3&$K$^$?$,$i$J$$>l9g(J */
	x_byte = x >> 3;
	w1 = 8 - (x & 0x07);
	w2 = (x + width) & 0x07;
	pattern1 = 0xff >> (8-w1);
	pattern2 = 0xff << (8-w2);
	pattern = pattern1 & pattern2;
	for (i = 0; i < height; i++, y++)
	    frame[y][x_byte] |= pattern;
    }
    return(0);
}

int
nwp_copy_area(x, y, width,  height, pixels)
int x, y;	/* $B=PNO0LCV(J ($BC10L(J: dot) */
int width;	/* pixels $B$NI}(J ($BC10L(J: byte) */
int height;	/* pixels $B$N9b$5(J ($BC10L(J: dot) */
char *pixels;	/* $B=PNO%$%a!<%8(J */
{
    unsigned long pattern;
    char *frow, *prow, *p, *q;
    int w, bitoffs;

    if (x < 0 || y < 0 || x >= XDOTS || y + height >= YDOTS || width > FRAME_WIDTH)
	return (-1);
    bitoffs = x & 0x07;
    frow = frame[y]+(x>>3);
    prow =  pixels;
    for (  ; height > 0; height--) {
	for (w = width, p = prow, q = frow; w >= 2; w -= 2, p += 2, q += 2) {
	    pattern = *(unsigned short *)p << (16 - bitoffs);
	    *(long *)q |= pattern;
	}
	/* $BH>C<$N%P%$%H(J */
	if (w) {
	    pattern = *(unsigned char *)p << (24 - bitoffs);
	    *(long *) q |= pattern;
	}

	frow += FRAME_WIDTH;
	prow += width;
    }
    return(0);
}

char *
nwp_get_bitmap(type, code, buf, buf_width, width, height)
int type;	/* $B%U%)%s%H%?%$%W(J */
int code;	/* $B%3!<%I(J */
char *buf;	/* $B%S%C%H%^%C%W(J */
int buf_width;	/* buf $B$N2#I}(J ($BC10L(J: byte) */
int width, height;	/* $B%5%$%:(J ($BC10L(J: dot) */
{
    FS_fillzero(buf, buf_width*height);
    if (FS_get_bitmap(code, font_des[type], width, height, buf_width,
		      0, buf, 0, 0, 0))
	return(NULL);
    return(buf);
}
