static char rcsid[] = "$Header: pxl_font.c,v 0.2 89/02/07 14:45:33 onuma Exp $";
/*
 *	Copyright (c) Japan TeX Users Group, 1986 1987
 */
/*
 * Extentions: Copyright(C) $BF|K\EE5$3t<02q<R(J  $B>.>B(J $B@i3((J, 1989
 */

#include <stdio.h>
#include  <newsiop/lbp.h>
#include "font_types.h"
#include "font.h"

#define  NCHAR	128	/* $B1Q?t;z(J pxl $B%U%!%$%k$K4^$^$l$kJ8;z?t(J */

#define  PXL_ID 1001	/* pxl $B%U%!%$%k(J ID */
#define FONT_DIR "/usr/lib/tex/fonts/pxl"	/* $B%G%U%)%k%H$N%U%)%s%H%G%#%l%/%H%jL>(J */

#define fix(_x)	((int)((_x) + 0.5))

float ratio();
char *malloc();

#ifdef PXL_FORMAT

int
pxl_font_def(fp, check_sum, size, design_size, dirname, filename,  mag)
struct font *fp;
int check_sum;		/* $B%A%'%C%/%5%`(J */
int  size, design_size;	/* $B%5%$%:(J ($BC10L(J: sp) */
char *dirname;		/* $B%U%)%s%H%G%#%l%/%H%jL>(J */
char *filename;		/* $B%U%)%s%H%U%!%$%kL>(J */
float mag;		/* magnification */
{
    float fmag, f;
    int pixels;
    char buf[BUFSIZ];
    FILE  *pxl;
    int  id, c, raster_size, rem, i, w, h;
    char *pxl_buf, *d, *s;
    int  pxl_addr;
    struct char_pxl *p;
    
    fp->type = PXL;
    
    /* $B%U%!%$%kL>$r5a$a!$%*!<%W%s(J */
    fmag = ratio(size, design_size);
    pixels = fix((DPI*5.0)*fmag*mag);
    if (*dirname == '\0')
	dirname = FONT_DIR;
    sprintf(buf, "%s/%s.%dpxl", FONT_DIR, filename, pixels);
    if((pxl = fopen(buf, "r")) == NULL) {
	perror(buf);
	return(-1);
    }

    id = get_int(pxl, 4);
    fseek(pxl, -4, 2);
    if(id != PXL_ID || get_int(pxl, 4) != PXL_ID)	/* pxl $B%U%!%$%k(J id $B%A%'%C%/(J */
	return(-1);
    
    fseek(pxl, -20, 2);
    c = get_int(pxl, 4);
    if (check_sum && c && check_sum != c)	/* check sum */
	fprintf(stderr, "Warning: %s version error.\n", buf);
    fseek(pxl, 8, 1);
    raster_size = get_int(pxl, 4) * 4;	/* DIR $BIt$N%"%I%l%9(J ($B%i%9%?%G!<%?$N%5%$%:(J) */
    if ((pxl_buf =  malloc(raster_size)) == NULL)  {
	perror();
	return(-1);
    }
    fseek(pxl, 0, 0);
    get_str(pxl, pxl_buf, raster_size);	/* $B%i%9%?%G!<%?FI$_9~$_(J */
    
    /* DIR $BItFI$_9~$_(J */
    if((fp->data.char_pxl = (struct char_pxl *)malloc(sizeof(struct char_pxl)*NCHAR))  == NULL) {
	perror();
	return(-1);
    }
    f = (float)design_size * fmag / (float)(1<<20);
    for(p=fp->data.char_pxl, i = 0; i < NCHAR; p++, i++) {
	p->width = (get_uint(pxl, 2)+7)/8;
	p->height = get_uint(pxl, 2);
	p->x_off = get_int(pxl, 2);
	p->y_off = get_int(pxl, 2);
	pxl_addr = get_int(pxl, 4);
	p->pxl = pxl_addr ? pxl_buf + pxl_addr * 4 : NULL;
	p->tfmw = fix((float)get_int(pxl, 4)*f);
	
	rem = (-p->width)&3;
	if (rem == 0)
	    continue;
	d = s = p->pxl;	/* byte pack */
	for(h = p->height; h > 0; s += rem, h--)
	    for(w = p->width; w > 0; w--)
		*d++ = *s++;
    }
    
    fclose(pxl);
    return(0);
}

#endif /* PXL_FORMAT */

pxl_set_char(fp, x,  y, code)
struct  font *fp;
int x, y;
int code;
{
    struct char_pxl *p;
    
    p = fp->data.char_pxl + code;
    nwp_copy_area(x-p->x_off, y-p->y_off, p->width,  p->height,  p->pxl);
    return(p->tfmw);
}
