#include	<stdio.h>
#include	"defs.h"
#include	"global.h"
#include	"rastfont.h"

void init_pxl_fontinfo();
struct fontop pxlop = {
    "pxl",
    pxltype_access,
    init_pxl_fontinfo,
};

#define	NHALFPXLCHARS	128
#define	NPXLCHARS	256	/* <= NFNTCHARS */

static FILE *fntfp;
void loadpxlchar();

void
init_pxl_fontinfo(fe)
register struct font_entry *fe;
{
    void read_pxl_fontinfo();

    fe->dev_readfontinfo = read_pxl_fontinfo;
    init_rast_fontinfo(fe);
}

void
read_pxl_fontinfo(fe)
register struct font_entry *fe;
{
    int t, i, fdir, nchars;
    long possave;
    register struct rastchar_entry *ce;/* temporary char_entry pointer  */
    struct keeprastfntinfo *krfi;
    struct rastfntinfo *rfi;
    int ds, mg;

    openfontfile(fe);
    fntfp = fe->openfile;
    if ((t = getuint(fntfp, 4)) != PXLID)
	Fatal("PXL ID = %d, can only process PXL ID = %d files",
	      t, PXLID);
    fseek(fntfp, -20, 2);
    t = getuint(fntfp, 4);
    if ((fe->c != 0) && (t != 0) && (fe->c != t))
	Warning("font = \"%s\",\n-->font checksum = %d,\n-->dvi checksum = %d",
		fe->name, fe->c, t);
    mg = getuint(fntfp, 4);
    ds = getuint(fntfp, 4);
    
    t = ftell(fntfp) - 12;
    fseek(fntfp, fdir = getuint(fntfp, 4) * 4, 0);
    nchars = (t-fdir)/(4*4);
    if (nchars > NPXLCHARS) {
	Fatal("PXL-font dir size of %s is %d\n", fe->name, nchars);
    } else if (nchars != NHALFPXLCHARS && nchars != NPXLCHARS) {
	Warning("PXL-font dir size of %s is %d\n", fe->name, nchars);
    }

    krfi = keeprastfinfo(fe);
    rastfinfo(fe) = rfi = alloc_rastfinfo(krfi->maxc+1, TRUE, krfi);
    dev_rast_initfe(fe);
    /* rfi->designsize = ds; */
    /* rfi->magnification = mg; */
    rfi->nfntchars = nchars;
    for (i = 0; i < nchars; i++) {
	if (krfi->mark[i] == FALSE) {
	    fseek(fntfp, 16L, 1);
	} else {
	    ce = &(rfi->ch[i]);
	    ce->width = getuint(fntfp, 2);
	    ce->height = getuint(fntfp, 2);
	    ce->xOffset = getint(fntfp, 2);
	    ce->yOffset = getint(fntfp, 2);
	    ce->dev_char = NONCHAR; 
	    ce->nbpl = ((ce->width + 31) >> 5) * 4;
	    ce->where.fileOffset = getuint(fntfp, 4) * 4;
	    ce->tfmw = ((float)getuint(fntfp, 4)*(float)fe->s) / 
		       (float)(1<<20);
	    if (ce->where.fileOffset == 0) {
		/*ce->where.fileOffset = NONEXISTANT;*/
		Warning("The glyf of char %x in %s missing\n", i, fe->name);
		continue;
	    }
	    possave = ftell(fntfp);
	    loadpxlchar(fe, ce);
	    dev_rast_initfontdict(fe, i);
	    fseek(fntfp, possave, 0);
	}
    }

    free(krfi);
}

void
loadpxlchar(fe, ce)
register struct font_entry *fe;
register struct rastchar_entry *ce;
{
    char *pixel;
    int nbytes;

    fseek(fntfp, ce->where.fileOffset, 0);
    nbytes = ce->nbpl * ce->height;
    if ((pixel = (char *)malloc(nbytes)) == NULL)
	Fatal("Unable to allocate memory for char\n");
    fread(pixel, 1, nbytes, fntfp);
    ce->where.pixptr = pixel;
}
