#include	<stdio.h>
#include	"file.h"
#include	"defs.h"
#include	"global.h"
#include	"rastfont.h"

init_rast_fontinfo(fe)
register struct font_entry *fe;
{
    register int i;
    struct keeprastfntinfo *k;
    int	rast_markchar();

    fe->markchar = rast_markchar;
    k = (struct keeprastfntinfo *)
	alloc_check(malloc(sizeof(struct keeprastfntinfo)+
			   MAXMARKCHAR*sizeof(char)));
    for (i = 0; i <= MAXMARKCHAR; i++)
	k->mark[i] = FALSE;
    k->maxc = 0;
    k->corrfact = passrastfinfo(fe)->corrfact;
    keeprastfinfo(fe) = k;
}

rast_markchar(fe, c)
register struct font_entry *fe;
int c;
{
    keeprastfinfo(fe)->mark[c] = TRUE;
    if (c > keeprastfinfo(fe)->maxc)
	keeprastfinfo(fe)->maxc = c;
}

struct rastfntinfo *
alloc_rastfinfo(nchars, init, krfi)
int nchars, init;
struct keeprastfntinfo *krfi;
{
    register struct rastfntinfo *rfi;
    register struct rastchar_entry *ce;	/* temporary char_entry pointer  */
    register int i;

    rfi = (struct rastfntinfo *)
	  alloc_check(malloc(sizeof(struct rastfntinfo)+
			     (nchars-1)*sizeof(struct rastchar_entry)),
		      "rastfont info");
    if (init)
	for (i = 0; i < nchars; i++) {
	    ce = &(rfi->ch[i]);
	    ce->width = 0;
	    ce->height = 0;
	    ce->xOffset= 0;
	    ce->yOffset = 0;
	    ce->dev_font = NONFONT;
	    ce->dev_char = NONCHAR;
	    ce->where.fileOffset = NONEXISTANT;
	    ce->tfmw = 0;
	}
    rfi->corrfact = krfi->corrfact;
    return (rfi);
}

pktype_access(proto, fe, acca)
char *proto;
struct font_entry *fe;
struct accarg *acca;
{
    return (rast_access(proto, fe, acca, 1));
}

pxltype_access(proto, fe, acca)
char *proto;
struct font_entry *fe;
struct accarg *acca;
{
    if (rast_access(proto, fe, acca, 5))
	return (check_id(fe->name, PXLID));
    else
	return (FALSE);
}

jxl4type_access(proto, fe, acca)
char *proto;
struct font_entry *fe;
struct accarg *acca;
{
    if (rast_access(proto, fe, acca, 5))
	return (check_id(fe->name, JXL4ID));
    else
	return (FALSE);
}

struct passrastfntinfo passrfinfo;

rast_access(proto, fe, acca, t)
char *proto;
register struct font_entry *fe;
register struct accarg *acca;
int t;
{
    fe->finfo = (struct finfo *)&passrfinfo;
    switch (acca->acc_mode) {
    case ACC_EXACT:
	acca->pv_mag = ROUND(acca->actmagfact*resolution*t);
	passrfinfo.corrfact = 1;
	break;
    case ACC_SUBST:
	if (ROUND(acca->actmagfact*resolution*t) != acca->reqmag)
	    return (FALSE);
	acca->pv_mag = acca->submag;
	passrfinfo.corrfact = (float)acca->reqmag/(float)acca->submag;
	break;
    case ACC_MAGSTEP:
	acca->pv_mag = ROUND(acca->stepmagfact*resolution*t);
	passrfinfo.corrfact = acca->rawmagfact/acca->stepmagfact;
	break;
    }
    pave(fe->name, proto, acca);
    return (access(fe->name, R_OK) == 0);
}

check_id(name, id)
char	*name;
int	id;
{
    FILE *tfp;
    int t;

    if ((tfp = BINARYOPEN(name, "r")) == NULL)
	Fatal("FNT file %s could not be opened", name);
    if ((t = getuint(tfp, 4)) != id) {
	fclose(tfp);
	return (FALSE);
    }
    fseek(tfp, -4L, 2);
    if ((t = getuint(tfp, 4)) != id) {
	fclose(tfp);
	return (FALSE);
    }
    fclose(tfp);
    return (TRUE);
}

/* returs the current fontdict of raster font */
rast_fontdict(fe, c)
struct font_entry *fe;
int c;
{
    /* char range check omitted */
    return (rastfinfo(fe)->ch[c].dev_font);
}
