#define	NFNTCHARS	256
#define	NONEXISTANT	-1	/* offset for raster files not found */
#define	MAXMARKCHAR	255	/* >= 255 */

struct rastchar_entry {		/* character entry */
    unsigned short width, height;/* width and height in pixels */
    short xOffset, yOffset;	/* x offset and y offset in pixels */
    short dev_font, dev_char;
    unsigned short nbpl;	/* # of bytes per pixel data line */
    union {
	unsigned int fileOffset;
	char *pixptr;
    } where;
    int tfmw;			/* TFM width */
    int	mark;
};

struct rastfntinfo {
    /* int font_space;	/* computed from FNT_DEF s parameter	*/
    /* int font_mag;	/* computed from FNT_DEF s and d parameters */
    /* int designsize;	/* design size read from raster file	*/
    float corrfact;
    int nfntchars;
    int dictform;	/* form of dev_font dictionary		*/
    struct rastchar_entry ch[1];	/* character information	*/
};

/* form of dictionary */
#define	PACK		0
#define	DVI		1

#define	rastfinfo(fe)	((struct rastfntinfo *)(fe->finfo))

/* used to pass information from access to initfontinfo */
struct passrastfntinfo {
    /* int font_mag; */
    float corrfact;
};

/* used to pass information from initfontinfo to readfontinfo
   and to pass marking information */
struct keeprastfntinfo {
    /* int font_mag; */
    float corrfact;
    int maxc;
    char mark[1];
};

#define	passrastfinfo(fe)	((struct passrastfntinfo *)(fe->finfo))
#define	keeprastfinfo(fe)	((struct keeprastfntinfo *)(fe->finfo))

#define	PXLID		1001
#define	JXL4ID		101157

struct rastfntinfo *alloc_rastfinfo();
int pktype_access();
int pxltype_access();
int jxl4type_access();
int rast_fontdict();
extern int resolution;
