/*   computefc (C)  Hideki ISOZAKI 1989 */


#include <stdio.h>

int compute_f_c(ku,ten)
     int ku,ten;
{
  int f,c,n;
  if ((ku<=0 || ku>=9) && (ku<=15 || ku>84))
    fprintf(stderr,"Invalid KU : %d\n",ku);
  if (ten<1 || ten>94) 
    fprintf(stderr,"Invalid TEN : %d\n",ten);
  if (ku<=8) {
    switch(ku){
    case 1: f=1; c=ten; break;  /* sy */
    case 2: f=1; c=ten+100; break; /* sy */
    case 3: f=2; c=ten+32; break; /* roma */
    default: f=ku-1; c=ten;  /* hira, kata, greek, russian, keisen */
    }
  }
  else 
    if(ku<=47){ /* Daiichi Suijun */
      n=(ku-16)*94+ten-1; 
      f=n/256+8;
      c=n-(f-8)*256;
    }
    else {  /* Daini Suijun */
      n=(ku-48)*94+ten-1; 
      f=n/256+20; 
      c=n-(f-20)*256;
    }
  return(256*f+c);
}

#define ASCII 0
#define JIS   1
#define ESC  27
#define INVERT(x) (1-x)
#define GETCHAR  getchar()
main()
{
  int ans,f,c,c1,c2,s;
  s=ASCII; 
  printf("\\input alljis\n");
  while((c1=GETCHAR) != EOF){
    if(c1==ESC) {
      s=INVERT(s); GETCHAR; GETCHAR;
    }
    else
      switch(s){
      case ASCII: 
	printf("{\\tentt\\char%d} \n",c1); break;
      case JIS: 
	c2=GETCHAR;
	ans=compute_f_c(c1-32,c2-32);
	c=ans%256;
	f=ans/256;
	switch(f){
	case 1: printf("{\\tendmjsy\\char%d} \n",c); break;
	case 2: printf("{\\tendmjroma\\char%d} \n",c); break;
	case 3: printf("{\\tendmjhira\\char%d} \n",c); break;
	case 4: printf("{\\tendmjkata\\char%d} \n",c); break;
	case 5: printf("{\\tendmjgreek\\char%d} \n",c); break;
	case 6: printf("{\\tendmjrussian\\char%d} \n",c); break;
	case 7: printf("{\\tendmjkeisen\\char%d} \n",c); break;
	default: printf("{\\tendmjk%c\\char%d} \n",f-8+'a',c);
	}
      }
  }
  printf("\\end\n");
}

