(defun pt-to-dot(pt dpi)(*$ pt (//$ dpi 72.27)))
(defun foo(pt mag dpi)(*$ (expt 1.2 mag)(pt-to-dot pt dpi)))

(defun dot-size(dot mag)(4-5(*$ (expt 1.2 mag) dot)))
(defun 4-5(x)(//$(float(ifix(+$ 0.5(*$ x 100.0)))) 100.0))

; In 300dpi 10pt is 38dots.  This is the basic relation.
; Other sizes for 5, 6, 7, 8, 9, 12, 14, 17, 20pt are calculated
; by 1pt=3.8dots.
; For 17pt, use 17.28125 instead of 17.0. (17.28125pt * 3.8 = 65.67).
; For other resolution, dot size in 300dpi are simply multiplies by
; a scale factor.  For example 30.4 of 480dpi is 19.0 * 480/300.

; following list should be obtained by the folowing function
(defun base-list(dpi)
  (mapcar '(lambda(x)(*$ 3.8 x (//$ dpi 300.0)))
	  '(5.0 6.0 7.0 8.0 9.0 10.0 12.0 14.0 17.28125 20.0)))

;(setq 240dpi '(15.2 18.24 21.28 24.32 27.36 30.4 36.48 42.56 52.54 60.8))
;(setq 300dpi '(19.0 22.8 26.6 30.4 34.2 38.0 45.6 53.2 65.67 76.0))
;(setq 400dpi '(25.33 30.4 35.47 40.53 45.6 50.67 60.8 70.93 87.56 101.33))
;(setq 480dpi '(30.4 36.48 42.56 48.64 54.72 60.8 72.96 85.12 105.07 121.6))
;(setq 600dpi '(38.0 45.6 53.2 60.8 68.4 76.0 91.2 106.4 131.34 152.0))
;(setq normal
      (mapcar '(lambda(x)(pt-to-dot x 300.0))
	      '(5.0 6.0 7.0 8.0 9.0 10.0 12.0 14.0 17.0 20.0)))

(defun dot-size-list(l)
  (terpri)
  (mapc '(lambda(x)(format t "~2,,7,' $" (dot-size x 0.0))) l)(terpri)
  (mapc '(lambda(x)(format t "~2,,7,' $" (dot-size x 0.5))) l)(terpri)
  (mapc '(lambda(x)(format t "~2,,7,' $" (dot-size x 1.0))) l)(terpri)
  (mapc '(lambda(x)(format t "~2,,7,' $" (dot-size x 2.0))) l)(terpri)
  (mapc '(lambda(x)(format t "~2,,7,' $" (dot-size x 3.0))) l)(terpri)
  (mapc '(lambda(x)(format t "~2,,7,' $" (dot-size x 4.0))) l)(terpri)
  (mapc '(lambda(x)(format t "~2,,7,' $" (dot-size x 5.0))) l)(terpri)
  (mapc '(lambda(x)(format t "~2,,7,' $" (dot-size x 6.0))) l)(terpri)
  (mapc '(lambda(x)(format t "~2,,7,' $" (dot-size x 7.0))) l)(terpri))

(defun i-dot-size-list(l)
  (terpri)
  (mapc '(lambda(x)(format t "~7D" (i-dot-size x 0.0))) l)(terpri)
  (mapc '(lambda(x)(format t "~7D" (i-dot-size x 0.5))) l)(terpri)
  (mapc '(lambda(x)(format t "~7D" (i-dot-size x 1.0))) l)(terpri)
  (mapc '(lambda(x)(format t "~7D" (i-dot-size x 2.0))) l)(terpri)
  (mapc '(lambda(x)(format t "~7D" (i-dot-size x 3.0))) l)(terpri)
  (mapc '(lambda(x)(format t "~7D" (i-dot-size x 4.0))) l)(terpri)
  (mapc '(lambda(x)(format t "~7D" (i-dot-size x 5.0))) l)(terpri)
  (mapc '(lambda(x)(format t "~7D" (i-dot-size x 6.0))) l)(terpri)
  (mapc '(lambda(x)(format t "~7D" (i-dot-size x 7.0))) l)(terpri))

(defun i-dot-size(dot mag)(i-4-5(*$ (expt 1.2 mag) dot)))

(defun i-4-5(x)(ifix(+$ 0.5 x)))

(defun all()
  (i-dot-size-list 240dpi)
  (i-dot-size-list 300dpi)
  (i-dot-size-list 480dpi)
  (i-dot-size-list normal))

(defun dot-size-table(dpi)(i-dot-size-list(base-list dpi)))
