(declare (special tyi8-pointer tyi8-word tyi8-byte-1 tyi8-byte-2
		  tyi8-byte-rest
		  tyi8-byte-3 tyi8-byte-4 tyo8-pointer tyo8-word))
(setq tyi8-word 0)
(setq ibase(setq base (+ 4 4)))
(defun tyi8(file)
       (caseq tyi8-pointer
	      (0(cond((= tyi8-word -1))
		     ((null(setq tyi8-word (errset (in file) nil)))
		      (setq tyi8-word -1))
		     (t(setq tyi8-word (car tyi8-word))))
		(setq tyi8-byte-rest (boole 1 17 tyi8-word))
		(setq tyi8-byte-1 (boole 1 377 (rot tyi8-word 10)))
		(setq tyi8-byte-2 (boole 1 377 (rot tyi8-word 20)))
		(setq tyi8-byte-3 (boole 1 377 (rot tyi8-word 30)))
		(setq tyi8-byte-4 (boole 1 377 (rot tyi8-word 40)))
		(setq tyi8-pointer 1)
		(cond((= tyi8-word -1) -1)(t tyi8-byte-1)))
	      (1(setq tyi8-pointer 2)
		(cond((= tyi8-word -1) -1)(t tyi8-byte-2)))
	      (2(setq tyi8-pointer 3)
		(cond((= tyi8-word -1) -1)(t tyi8-byte-3)))
	      (3(setq tyi8-pointer 0)
		(cond((= tyi8-word -1) -1)(t tyi8-byte-4)))))

(defun tyo8(byte file)
       (caseq tyo8-pointer
	      (0(setq tyo8-word (lsh byte 28.))
		(setq tyo8-pointer 1))
	      (1(setq tyo8-word (boole 7 tyo8-word (lsh byte 20.)))
		(setq tyo8-pointer 2))
	      (2(setq tyo8-word (boole 7 tyo8-word (lsh byte 12.)))
		(setq tyo8-pointer 3))
	      (3(setq tyo8-word (boole 7 tyo8-word (lsh byte 4.)))
		(setq tyo8-pointer 0)
		(out file tyo8-word))))
(setq tyo8-pointer 0)
(setq tyi8-pointer 0)

(defun make-8-file(ofile lst)
  (let((ofobj(open ofile '(out fixnum))))
       (setq tyo8-word 0)
       (setq tyo8-pointer 0)
       (do((l lst (cdr l)))((null l))(tyo8 (car l) ofobj))
       (cond((not(= tyo8-pointer 0))(out ofobj tyo8-word)))
       (close ofobj)))

;(defun barbar(infile outfile)
;       (prog(oldtyo infobj ofobj)
;	    (setq tyi8-pointer 0)
;	    (setq tyi8-word 0)
;	    (setq oldtyo tyo)
;	    (setq infobj (open infile '(in fixnum)))
;	    (setq tyo (setq ofobj(open outfile '(out))))
;	    (linel ofobj 132.)
;	    (errset(bar infobj)nil)
;	    (close ofobj)
;	    (close infobj)
;	    (setq tyo oldtyo)))

(setq ibase(setq base(+ 5 5)))

(defun hexdecout(a n)
       (do((i 1 (1+ i))
	   (byte1 (tyi8 a)(tyi8 a))
	   (byte2 (tyi8 a)(tyi8 a)))
	  ((> i n))
	  (hexout byte1)(hexout byte2)
	  (princ '/ )))

(defun hexout(n)
       (prog(a b)
	    (setq a (// n 16.) b (\ n 16.))
	    (cond((> a 9.)(tyo (+ 55. a)))
		 (t(tyo (+ 48. a))))
	    (cond((> b 9.)(tyo (+ 55. b)))
		 (t(tyo (+ 48. b))))))

(defun 8-7(in out)
       (do((ch (tyi8 in)(tyi8 in)))
	  ((< ch 0)'end)
	  (tyo ch out)))

(defun 7-8(in out)
       (do((ch (tyi in)(tyi in)))((< ch 0) 'end)(tyo8 ch out)))

(defun trans7-8(infile outfile)
       (prog(infobj outfobj)
	    (setq tyo8-word 0)
	    (setq tyo8-pointer 0)
	    (setq infobj (open infile '(in)))
	    (setq outfobj (open outfile '(out fixnum)))
	    (7-8 infobj outfobj)
	    (cond((not(= tyo8-pointer 0))(out outfobj tyo8-word)))
	    (close infobj)
	    (close outfobj)))

(defun trans8-7(infile outfile)
       (prog(infobj outfobj)
	    (setq tyi8-word 0)
	    (setq tyi8-pointer 0)
	    (setq infobj (open infile '(in fixnum)))
	    (setq outfobj (open outfile '(out)))
	    (8-7 infobj outfobj)
	    (close infobj)
	    (close outfobj)))

(defun ddump(infile outfile ) ; decimal dump
       (prog(infobj outfobj)
	    (setq tyi8-word 0)
	    (setq tyi8-pointer 0)
	    (setq infobj (open infile '(in fixnum)))
	    (setq outfobj (open outfile '(out)))
	    (8-d infobj outfobj)
	    (close infobj)
	    (close outfobj)))

(defun 8-d(in out)
       (do((ch (tyi8 in)(tyi8 in))
	   (count 1 (1+ count)))
	  ((< ch 0)'end)
	  (format out "~7D" ch)
	  (cond((= count 10.)(terpri out)(setq count 0)))))

(defun odump(infile outfile ) ; octal dump
       (prog(infobj outfobj)
	    (setq tyi8-word 0)
	    (setq tyi8-pointer 0)
	    (setq infobj (open infile '(in fixnum)))
	    (setq outfobj (open outfile '(out)))
	    (8-o infobj outfobj)
	    (close infobj)
	    (close outfobj)))

(defun 8-o(in out)
       (do((ch (tyi8 in)(tyi8 in))
	   (count 1 (1+ count)))
	  ((< ch 0)'end)
	  (format out "~7O" ch)
	  (cond((= count 10.)(terpri out)(setq count 0)))))

(defun compactify(infile outfile)
; deletes unnecessary nulls from infile and produce an compact outfile
       (prog(count eofp infobj outfobj char)
	    (setq tyi8-word 0)
	    (setq tyi8-pointer 0)
	    (setq tyo8-word 0)
	    (setq tyo8-pointer 0)
	    (setq infobj (open infile '(in fixnum)))
	    (setq outfobj (open outfile '(out fixnum)))
	    (setq eofp nil)
	  l (setq count 0)
	    (setq char (tyi8 infobj))
	    (cond((< char 0)(setq eofp t)(go ll)))
	    (tyo8 char outfobj)
	    (do((i 1 (1+ i)))((> i 15.))
	       (tyo8 (tyi8 infobj) outfobj))
	    (do((ch (tyi8 infobj)(tyi8 infobj)))
	       ((or(= ch 0)(< ch 0))(cond((< ch 0)(setq eofp t))))
                ; if null or eof exit.
	       (setq count (1+ count))
	       (tyo8 ch outfobj))
            (tyo8 37. outfobj)(tyo8 120. outfobj) ;cr/lf of jw-10
         ll (cond(eofp (cond((not(zerop tyo8-pointer))(out outfobj tyo8-word)))
		       (close outfobj)
		       (close infobj)
		       (return t)))
	    (setq count (- 679. count))
	    (do((i 1 (1+ i)))((> i count))(tyi8 infobj)) ;skip nulls
	    (go l)))
