; Typeout imPRESS file contents

; First the summary of imPRESS commands
; member	0-127 [0]	Print a character
; sp		128 [0]		advance one space
; sp1		129 [0]		advance one space and one pixel
; mplus		131 [0]		move one pixel forward
; mminus	132 [0]		move one pixel back
; mmove		133 [2]		move in main advance direction
; smove		134 [2]		move in secondary advance direction
; set_abs_h	135 [2]		move to h position
; set_rel_h	136 [2]		move in h direction
; set_abs_v	137 [2]		move to v position
; set_rel_v	138 [2]		move in v direction
; circ_arc	150 [6]		define a circular path
; ellipse_arc	151 [10]	define an eliptical path
; circ_segm	160 [10]	define a pie-shaped path
; brule		193 w[2] h[2] t[2]	print a rule (width, heigh, top-offset)
; crlf		197 [0]		move to beginning of next line
; bgly		199 [12+mask]	define a down-loaded glyph
;		    rotation[2bits] family[7bits] member[7bits]
;		    advance-width[2] width[2] left-offset[2] height[2]
;		    top-offset[2] mask[(* height (1+ (// width 8.)))bytes]
; set_hv_system	205 [1]		define new coordinate system
; set_adv_dirs	206 [1]		define advance directions
; set_family	207 [1]		use the family given
; set_il	208 [2]		define the space between lines
; set_bol	209 [2]		define the beginning of a line
; set_sp	210 [2]		defin the space between words
; push		211 [0]		push state variables on a stack
; pop		212 [0]		pop state variables off the stack
; page		213 [0]		sets h and v positions to zero
; set_push_mask	214 [2]		specify which variables to save
; endpage	219 [0]		print the current page
; create_family_table	221 [2+pairs]	define a family table
;		    family[1] pairs[1] [map-name[1] font-name[string]]pairs
; create_map	222 [2+triples]	create a member map
;		    map-name[1] triples[1]
;		    [starting-member[1] starting-symbol[2] count[1]]triples
; set_pum	225 [1]		append new path to current path
;				or  replace current path with new path
; create_path	230 [2+pairs]	define a path of segments
;		    vertex-count[2] [h[2] v[2]]vertex-count
; set_texture	231 [2]		select a texture for drawing (a glyph)
;		    rotation[2bits] family[7bits] member[7bits]
; set_pen	232 [1]		select a pen width (in pixels)
; fill_path	233 [1]		shade the area inside the path
; draw_path	234 [1]		draw the current path (a line)
; bitmap	235 [3+pattern]	print a full bitmap
;		    operation-type[1] hsize[1] vsize[1]
;		    hsize*vsize patches (patch = 32*32 bits = 128 bytes)
; set_magnification	236 [1]	magnify the page (by 1, 2 or 4)
; define_macro	242 [3+body]	define a macro
;		    macro-name[1] body-length[2] [body]body-length
; execute_macro	243 [1]		execute the named macro
; no_op		254 [0]		no operation (ignored by imPRESS)
; eof		255 [0]		end of document

(load '|as:<yaski.lisp>trans8-7|)

(defun imtype(imfname ofname print-mask-switch)
  (let((ifobj(open imfname '(in fixnum)))
       (ofobj(cond((null ofname)t)(t(open ofname 'out)))))
    (unwind-protect
     (progn
      (setq tyi8-pointer 0)
      (setq tyi8-word 0)
      (format ofobj "~%imPRESS file dump of ~A~%" imfname)
      (do((i 0 (1+ i))(byte(tyi8 ifobj)(tyi8 ifobj)))
	 ((= -1 byte)(format ofobj "End of imp file: ~D commands in total~%" i))
	(cond((< byte 128.)(format ofobj "member: ~D (~C)~%" byte byte))
	     (t(caseq byte
		 (128. (format ofobj "sp~%"))
		 (129. (format ofobj "sp1~%"))
		 (131. (format ofobj "mplus~%"))
		 (132. (format ofobj "mminus~%"))
		 (133. (format ofobj "mmove: ~D~%" (read-word ifobj)))
		 (134. (format ofobj "smove: ~D~%" (read-word ifobj)))
		 (135. (format ofobj "set_abs_h: ~D~%" (read-word ifobj)))
		 (136. (format ofobj "set_rel_h: ~D~%" (read-word ifobj)))
		 (137. (format ofobj "set_abs_v: ~D~%" (read-word ifobj)))
		 (138. (format ofobj "set_rel_v: ~D~%" (read-word ifobj)))
		 (150. (format ofobj "circ_arc: radius=~D alpha0=~D alpha1=~D~%"
			       (read-word ifobj)(read-word ifobj)(read-word ifobj)))
		 (151. (format ofobj "ellipse_arc: radiusa=~D radiusb=~D alphaoff=~D alpha0=~D alpha1=~D~%"
			       (read-word ifobj)(read-word ifobj)(read-word ifobj)
			       (read-word ifobj)(read-word ifobj)))
		 (160. (format ofobj "circ_segm: radius0=~D radius1=~D alpha0=~D alpha1=~D offset=~D~%"
			       (read-word ifobj)(read-word ifobj)(read-word ifobj)
			       (read-word ifobj)(read-word ifobj)))
		 (193. (format ofobj "brule: width=~D height=~D top-offset=~D~%"
			       (read-word ifobj)(read-word ifobj)(read-word ifobj)))
		 (197. (format ofobj "crlf~%"))
		 (199. (let*((word(read-word ifobj))
			     (rotation(lsh word -14.))
			     (family(boole 1 #o177 (lsh word -7.)))
			     (member(boole 1 #o177 word))
			     (advance-width (read-word ifobj))
			     (width(read-word ifobj))
			     (left-offset(read-word ifobj))
			     (height(read-word ifobj))
			     (top-offset(read-word ifobj))
			     (mask(read-mask width height ifobj)))
			 (format ofobj "bgly: rotation=~D family=~D member=~D advance-width=~D~%"
				 rotation family member advance-width)
			 (format ofobj "      width=~D height=~D ref-point=(~D ~D)~%"
				 width height left-offset top-offset)
			 (cond(print-mask-switch(print-mask mask ofobj)))))
		 (205. (format ofobj "set_hv_system: ~D~%" (tyi8 ifobj)))
		 (206. (format ofobj "set_adv_dirs: ~D~%" (tyi8 ifobj)))
		 (207. (format ofobj "set_family: ~D~%" (tyi8  ifobj)))
		 (208. (format ofobj "set_il: ~D~%" (read-word ifobj)))
		 (209. (format ofobj "set_bol: ~D~%" (read-word ifobj)))
		 (210. (format ofobj "set_sp: ~D~%" (read-word ifobj)))
		 (211. (format ofobj "push~%"))
		 (212. (format ofobj "pop~%"))
		 (213. (format ofobj "page~%"))
		 (214. (format ofobj "set_push_mask: ~B~%" (read-word ifobj)))
		 (219. (format ofobj "endpage~%"))
		 (221. (let((family(tyi8 ifobj))
			    (pairs(tyi8 ifobj)))
			 (format ofobj "create_family_table~%")
			 (do((i 0 (1+ i)))((= i pairs))
			   (format ofobj "mapname: ~D " (tyi8 ifobj))
			   (do((ch (tyi8 ifobj)(tyi8  ifobj)))
			      ((= ch 0)(terpri ofobj))
			     (tyo ch ofobj)))))
		 (222. (let((map-name(tyi8 ifobj))
			    (triples(tyi8 ifobj)))
			 (format ofobj "create_map mapname: ~D~%" map-name)
			 (do((i 0 (1+ i)))((= i triples)(terpri ofobj))
			   (format ofobj
				   "starting-member=~D starting-symbol=~D count=~D~%"
				   (tyi8 ifobj)(read-word ifobj)(tyi8 ifobj)))))
		 (225. (format ofobj "set_pum: ~D " (tyi8 ifobj)))
		 (230. (let((vertex-count(read-word ifobj)))
			 (format ofobj "create_path: ~D points~%" vertex-count)
			 (do((i 0 (1+ i)))((= i vertex-count))
			   (format ofobj "~Th=~D v=~D~%"
				   (read-word ifobj)(read-word ifobj)))))
		 (231. (let*((word(read-word ifobj))
			     (rotation(lsh word -14.))
			     (family(boole 1 #o177 (lsh word -7.)))
			     (member(boole 1 #o177 word)))
			 (format ofobj "set_texture: rotation=~D family=~D member=~D~%"
				 rotation family member)))
		 (232. (format ofobj "set_pen: ~D~%" (tyi8 ifobj)))
		 (233. (format ofobj "fill_path: ~D~%" (tyi8 ifobj)))
		 (234. (format ofobj "draw_path: ~D~%" (tyi8 ifobj)))
		 (235. (let*((operation-type(tyi8 ifobj))
			     (hsize(tyi8 ifobj))
			     (vsize(tyi8 ifobj))
			     (patches(* hsize vsize)))
			 (format ofobj "bitmap: op-type=~D (~D * ~D patches)~%"
				 operation-type hsize vsize)
			 (do((i 0 (1+ i)))((= i patches))
			   (format ofobj "patch no: ~D~%" i)
			   (do((j 0 (1+ j)))((= j 32.))
			     (format ofobj "~2,8,'0R~2,8,'0R~2,8,'0R~2,8,'0R~%"
				     (tyi8 ifobj)(tyi8 ifobj)
				     (tyi8 ifobj)(tyi8 ifobj))))))
		 (236. (format ofobj "set_magnification: ~D~%" (tyi8 ifobj)))
		 (242. (let((macro-name(tyi8 ifobj))
			    (body-length(read-word ifobj)))
			 (format ofobj "define_macro macro-name: ~D (length=~D)~%"
				 macro-name body-length)
			 (do((i 0(1+ i)))((= i body-length))
			   (format ofobj "~D " (tyi8 ifobj)))))
		 (243. (format ofobj "execute_macro: ~D~%" (tyi8 ifobj)))
		 (254. (format ofobj "no_op~%"))
		 (255. (format ofobj "eof~%")))))))
     (if (eq ofobj t) t
	 (close ofobj)) )))

(defun read-word(ifobj)
  (let((byte1(tyi8 ifobj))(byte2(tyi8 ifobj)))
    (cond((zerop(boole 1 #o200 byte1))
	  (boole 7 (lsh byte1 8.) byte2))
	 (t(- (boole 7 (lsh (boole 1 #o177 byte1) 8.) byte2)
	      (^ 2 15.))))))

(defun read-mask(width height ifobj)
  (let*((bytes-in-row(cond((zerop(\ width 8.))(// width 8.))
			 (t(1+(// width 8.)))))
       (mask(*array nil 'fixnum bytes-in-row height)))
    (do((j 0 (1+ j)))((= j height)mask)
      (do((i 0 (1+ i)))((= i bytes-in-row))
	(store(arraycall fixnum mask i j)(tyi8 ifobj))))))

(defun print-mask(mask ofobj)
  (let((bytes-in-row(array-dimension-n 1 mask))
       (height(array-dimension-n 2 mask)))
    (do((j 0 (1+ j)))((= j height))
      (do((i 0 (1+ i)))((= i bytes-in-row))
	(format ofobj "~2,8,'0R" (arraycall fixnum mask i j)))
      (terpri))))
