.TH TEXDRAW 1 "Sep 21, 1988" "X Version 11"
.SH NAME
texdraw \- LaTeX picture editor for X Version 11
.SH SYNOPSIS
.B texdraw
[ option ] ...
.SH DESCRIPTION
.I texdraw
is a program which runs as a client to the X window system,
and allows a user to:
.TP
1.
Create pictures using a graphics display with a mouse.
.TP
2.
Save the pictures as text files containing LaTeX command strings.
.TP
3.
Read the files back into the texdraw program for modification.
.PP
When
.I texdraw
is started, several menu buttons, a picture window,
and a message window are created on the display device.
Clicking menu buttons select corresponding program features.
In the picture window, the user can create, modify, or destroy objects
using mouse for geometric objects, or mouse and keyboard for text strings.
The text window shows various messages and command strings entered by the user.
.SH OPERATION
When
.I texdraw
starts, no features (except a default picture font) are active.
To begin drawing a picture, use the mouse to move the cursor
to one of the menu buttons (e.g. DRAW LINE),
press the left mouse button to select that feature,
then move the cursor into the picture window
to create objects of the type selected.
Only the left mouse button is used by this program,
and its use is implied in the following descriptions.
.TP
Pictures
A picture consists of a set of objects which can be drawn with LaTeX commands
in picture mode. The types of objects are lines, vectors, boxes, ovals,
circles, disks, and text strings. Geometric objects can be drawn in two
line thicknesses, and text strings can be created in a variety of type
styles and sizes, three of which are supported by this program.
.TP
The Current Set
At all times there exists a current set, which is a subset of the picture
objects and is useful for moving, duplicating, or deleting portions of a
picture. Each time an object is created or modified, that object becomes
the current set. If several objects are read in at once from a file or
created using the COPY CURRENT command, those objects become the current
set. Also, the user may use the mouse to select the current set from existing
picture objects.
.TP
Menu Buttons
The menu buttons are used to select various features of the program. Features
include "commands", which perform some action, and "modes", which affect the
operation of future actions. There are "primary modes", which determine
what the future actions will be, and "secondary modes", which determine
characteristics of the actions.

To make a menu selection, use the mouse to move the cursor into a menu button,
and press the mouse button.

When the program is first started, none of the features are active, and all
of the menu buttons have white backgrounds. When a feature is activated,
the background of its menu button becomes shaded, and remains shaded as long
as the feature is active.

If the feature is one of the primary modes, it remains active until some
other primary mode is selected. If it is one of the secondary modes, it
remains active until its menu is selected again. If the feature is a command,
it remains active until the effect of the command is completed.
.TP
Primary Modes
Primary modes select what action will be taken by mouse and keyboard activity
when the cursor is in the picture window. For example, if the selected
primary mode is DRAW LINE, all mouse activity in the picture window will be
directed toward drawing lines.

The menus for the primary modes are grouped at the top of the menu area, and
include DRAW LINE, DRAW VECTOR, DRAW BOX, DRAW RULE, DRAW OVAL, DRAW CIRCLE,
DRAW DISK, ENTER TEXT, MOVE POINT, RESIZE PICTURE, SELECT CURRENT,
MOVE CURRENT, and COPY CURRENT.

Only one of the primary modes may be active at any time. Selecting one
automatically deactivates all others.

If one of the DRAW modes is active, objects are drawn in the picture
window using "rubber-banding". To create an object, press the
mouse button to position the object (the "start point"). Next, move the
cursor while holding the button down to stretch the object to the desired
size, and release the button (the "end point"). The object thus shown is
added to the picture. Other primary modes which act on geometric objects
operate similarly.
.RS
.TP
DRAW LINE
Uses rubber-banding to draw a line between the start point and the
end point. LaTeX commands restrict lines to those whose slopes can be
defined by pairs of integers in the range of \-6 to +6. When drawing lines,
the rubber band will not move smoothly on the screen, but will jump between
positions which show the closest allowable LaTeX line.
.TP
DRAW VECTOR
Similar to DRAW LINE. Uses rubber-banding to draw a vector (a line with an
arrowhead) from the start point to the end point. The range of allowable
vectors is even more restricted than that of lines. The pairs of integers
must be in the range of \-4 to +4.
.TP
DRAW BOX
Uses rubber-banding to draw a rectangle with one corner at the start point,
and the diagonally opposite corner at the end point.
.TP
DRAW RULE
Similar to DRAW BOX, uses rubber-banding
to draw a filled rectangle defined by the start and end points.
.TP
DRAW OVAL
Similar to DRAW BOX, uses rubber-banding to draw a rectangle with rounded
corners inside a rectangular area defined by the start and end points. The
radius of the corners is that of the largest LaTeX circle which will fit
inside the rectangular area.
.TP
DRAW CIRCLE
Uses rubber-banding to draw a circle with its center at the start point,
and its circumference as near as possible to the end point. LaTeX circles
are limited to 40-pt in diameter (a little over 1/2 inch), so the rubber
band will only go to this size no matter how far the end point is from the
start point.
.TP
DRAW DISK
Similar to DRAW CIRCLE, uses rubber-banding to draw a disk (a solid,
filled circle). LaTeX disks are limited to 15-pt diameters (a bit less
than 1/4 inch).
.TP
ENTER TEXT
Used to create picture objects which are text strings. With the mouse
cursor in the picture window, press the mouse button and a text
cursor will be displayed at that location. If the text cursor is not in
the desired position, move the mouse cursor and press the button again.
Once the text cursor is correctly positioned, enter text from the keyboard
to create a text string in the picture. Terminate the string either by
pressing the mouse button or by moving the mouse cursor out of the picture
window.
.TP
MOVE POINT
Uses rubber-banding to change the shape of objects. Position the cursor
over a point to be moved, press the mouse button to "grab" the
point, move the cursor to the desired position for the point, and release
the mouse button. Points which can be moved include the endpoints of lines
and vectors, the corners of boxes, the corners of the rectangular areas
enclosing ovals, and points on the circumferences of circles and disks.
It usually is helpful to have GRAVITY, one of the secondary modes, active
when using this feature.
.TP
RESIZE PICTURE
Uses rubber banding to change the size of the picture window, which in
turn determines the size of the LaTeX picture. Position the cursor
anywhere inside the picture window. Press the mouse button. Move the
cursor to the desired position (in or out of the picture window), and
release the button. The window will be resized and the corresponding
dimensions of the LaTeX picture will be displayed in the text window.
If the picture size you select is too small for the current picture, an
an error message appears in the text window, and the picture is not resized.
.TP
SELECT CURRENT
Used to change the contents of the current set.
Use the mouse to rubber-band a rectangle in the picture window,
and release the mouse button.
The current set then will contain only those objects completely contained in
the rectangle.
.TP
MOVE CURRENT
Used to move all objects in the current set. Use the mouse to rubber-band
a line in the picture window. The objects in the current set will move
a distance equal to the length of the line, in the direction from the
start point to the end point. If any part of an object would be located
outside of the picture window area after the move, an error message appears
in the text window and none of the objects are moved.
.TP
COPY CURRENT
Used to create a copy of the current set. Use the mouse to rubber-band
a line in the picture window. A duplicate of each object in the current
set is created, displaced a distance equal to the length of the line, in
the direction from the start point to the end point. If any part of a new
object would be located outside of the picture window, an error message
appears in the text window and no new objects are created.
.RE
.TP
Secondary Modes
Secondary modes modify the action taken by primary mode activity in
the picture window. For example, if the THICK LINES mode is active, new
objects created in one of the DRAW modes will have thicker-than-normal lines.

The menus for the secondary modes are grouped in the middle part of the menu
area, and include GRAVITY, ALIGNH, ALIGNV, THICK LINES, and FONT.

Any or all of the secondary modes may be active at any time. They are
activated and deactivated by selecting their respective menus.

The FONT mode is a special case, where there always is an active picture
font which is changed each time the FONT menu is selected.
.RS
.TP
GRAVITY
When GRAVITY is active, the mouse cursor only needs to be close to a point
for that point to be chosen. If there is a point on an object that is
close to the cursor (within three pixels on the display) when the mouse
button is pressed, that point is selected instead of the mouse cursor
position.
.TP
ALIGNH
The ALIGNH feature makes it possible to achieve precise horizontal alignment
of picture objects. If ALIGNH is active when the mouse button is pressed,
the closest point which is in horizontal alignment with a point on some
object (if there is an object in the picture) will be selected instead of
the mouse cursor position.
.TP
ALIGNV
The ALIGNV feature makes it possible to achieve precise vertical alignment
of picture objects. If ALIGNV is active when the mouse button is pressed,
the closest point which is in vertical alignment with a point on some
object (if there is an object in the picture) will be selected instead of
the mouse cursor position.
.TP
THICK LINES
When THICK LINES is active, objects created using the DRAW modes have
thicker-than-normal lines.
.TP
FONT
When the program starts,
the LaTeX "\fB\\small\\tt\fP" font is the active picture
font. Each time the FONT menu is selected, (1) the active picture font
changes to the next size in rotation, (2) that font is used to display the
word FONT in the menu button, and (3) the LaTeX name for the font is
displayed in the text window.

LaTeX fonts currently supported include "\fB\\small\\tt\fP",
"\fB\\large\\tt\fP", and "\fB\\Large\\tt\fP".
In order for this program to run, the "6x10" font,
which corresponds to the LaTeX "\fB\\small\\tt\fP" font,
must be present in the X library.
.RE
.TP
Commands
Commands initiate actions without requiring input through the picture window.
For example, if the DELETE CURRENT command is activated, objects in the
current set are removed immediately from the picture.

The menus for commands are grouped in the lower part of the menu area, and
include READ, WRITE, SHOW CURRENT, DELETE CURRENT, CLEAR, REDRAW, UNDO, and
QUIT.

A command remains active until its effect has been completed, at which time
it deactivates itself.
.RS
.TP
READ
The READ command makes it possible to read in a set of objects from a
text file containing LaTeX command strings. When the READ menu is selected,
a prompt for a file name appears in the text window. Use the keyboard to
enter the name of a text file, followed by a carriage return. The file
will be read, and the objects added to the picture. Existing picture
objects are not removed. If the size of the picture being read in exceeds
that of the current picture window, the size of the window will be increased
as needed. If, after activating the READ command, but before pressing the
carriage return, you do decide not to read in a file, press control-C to
abort.
.TP
WRITE
The WRITE command makes it possible to save a set of picture objects as
a text file of LaTeX command strings. When the WRITE menu is selected, a
prompt for a file name appears in the text window.
Use the keyboard to enter a file name, followed by a carriage return.
LaTeX commands for the current picture size and objects
will be written to the file. If, after activating the WRITE command, but
before pressing the carriage return, you decide not to write to a file,
press control-C to abort.
.TP
SHOW CURRENT
Clears the picture window, and displays only those objects in the current
set. The rest of the objects still exist in the picture, but will not
appear in the picture window until some other action causes the picture
to be redrawn. The REDRAW command can be used to restore the complete
picture without changing either the picture or the current set.
.TP
DELETE CURRENT
Deletes the objects which are in the current set. If the current set
is empty, a message is given in the text window.
.TP
CLEAR
Deletes all of the objects in the current picture and clears the screen.
.TP
REDRAW
Clears the screen and draws all of the objects in the current picture.
This command can be used after SHOW CURRENT to restore all of the picture
objects on the screen.
.TP
UNDO
Reverses the effect of the last command which changed the set of picture
objects. For example, if the last change was to move the current set,
selecting UNDO will return the current set to its previous position.
Selecting UNDO again will reverse the effect of the first UNDO, and so on.
.TP
QUIT
Exits from the program. When exiting, any picture which has not been
saved to a file will be lost. To provide some protection against doing
this accidentally, it is necessary to select QUIT twice in succession
to actually exit.
.RE
.SH "SEE ALSO"
X(1)
.SH AUTHOR
Copyright (C) 1987 Thomas Taylor
.br
Copyright (C) 1988 Hiroto Kagotani
.PP
This software is free of charge. It may not be re-sold.
Everyone is granted permission to copy, modify and redistribute
.I texdraw,
as long as the original copyright and this notice are retained.
.SH BUGS
.TP
1.
.I texdraw
can not recognize any standard command line options (except \fB\-display\fP)
of X Version 11.
.TP
2.
.I texdraw
can not treat partition of ovals.
