/*----------------------------------------------------------------------------
**   Copyright (C) 1987 Thomas Taylor
**
** This file is part of TexDraw
**
** TexDraw is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY.  No author or distributor
** accepts responsibility to anyone for the consequences of using it
** or for whether it serves any particular purpose or works at all,
** unless he says so in writing. 
**
** This software is free of charge.  It may not be re-sold.
** Everyone is granted permission to copy, modify and redistribute
** TexDraw, as long as the original copyright and this notice are
** retained.
**
**
**         Module:  texstr.c
**
**   Program Name:  texdraw
**    Program Use:  Graphics Program for LaTeX Text Formatter
**
**         Author:  Tom Taylor
**           Date:  August 21, 1987
**
**          Class:  C Sci 498, Senior Project
**        Sponsor:  Hank Levy
**
**
**    This module contains string functions for the texdraw program.
**
----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------
**   Copyright (C) 1988 Hiroto Kagotani
----------------------------------------------------------------------------*/


#include "texdraw.h"


/* --------------------------------------------------------------------------
   str_Copy:
     Copies string "s" into string "t".
---------------------------------------------------------------------------*/
void
str_Copy(s,t)  
char *s, *t;
{
  while (*t++ = *s++);
}




/* --------------------------------------------------------------------------
   str_IsEqual:
     Returns TRUE iff strings "s" and "t" are identical.
---------------------------------------------------------------------------*/
bool
str_IsEqual(s, t)
char *s, *t;
{
  int i = 0;

  while (s[i] == t[i])
    if (s[i++] == '\0') return TRUE;
  return FALSE;
}




/* --------------------------------------------------------------------------
   str_Length:
     Returns the length of string "s".
---------------------------------------------------------------------------*/
int
str_Length(s)
char *s;
{
  int n;
  for (n=0; *s!='\0'; s++) n++;
  return n;
}

